commit 8535b3e11d2297854991c4272932ce4974dda629 (HEAD -> master, tag: 0.8.1)
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Mar 22 17:42:33 2021 -0500

    Version file update (0.8.1)

commit e56d9f2d94ed247696dda2cbf94d2ca05c7fc089 (origin/master, origin/HEAD)
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Mar 22 17:40:50 2021 -0500

    ReleaseNotes.md update in advance of next version.

commit ca83f955d45814b7d84f53933cdb73323c0dea2c
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Mar 22 17:21:21 2021 -0500

    CREDITS file update.

commit 57ef61f6cdb86957f67212aa59407f2f8e7f3d1a
Merge: bf1b578e e7a4a8ed
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Mar 19 13:05:43 2021 -0500

    Merge branch 'master' of github.com:flame/blis

commit bf1b578ea32ea1c9dbf7cb3586969e8ae89aa5ef
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Mar 19 13:03:17 2021 -0500

    Reduced KC on skx from 384 to 256.
    
    Details:
    - Reduced the KC cache blocksize for double real on the skx subconfig
      from 384 to 256. The maximum (extended) KC was also reduced
      accordingly from 480 to 320. Thanks to Tze Meng Low for suggesting
      this change.

commit e7a4a8edc940942357e8e4c4594383a29a962f93
Author: Nicholai Tukanov <nicholaitukanov@gmail.com>
Date:   Wed Mar 17 19:43:31 2021 -0500

    Fix calculation of new pb size (#487)
    
    Details:
    - Added missing parentheses to the i8 and i4 instantiations of the
      GENERIC_GEMM macro in sandbox/power10/generic_gemm.c.

commit 4493cf516e01aba82642a43abe350943ba458fe2
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Mar 15 13:12:49 2021 -0500

    Redefined BLIS_NUM_ARCHS to update automatically.
    
    Details:
    - Changed BLIS_NUM_ARCHS from a cpp macro definition to the last enum
      value in the arch_t enum. This means that it no longer needs to get
      updated manually whenever new subconfigurations are added to BLIS.
      Also removed the explicit initial index assigment of 0 from the
      first enum value, which was unnecessary due to how the C language
      standard mandates indexing of enum values. Thanks to Devin Matthews
      for originally submitting this as a PR in #446.
    - Updated docs/ConfigurationHowTo.md to reflect the aforementioned
      change.

commit a4b73de84cdffcbe5cf71969a0f7f0f8202b3510
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Mar 12 17:12:27 2021 -0600

    Disabled _self() and _equal() in bli_pthread API.
    
    Details:
    - Disabled the _self() and _equal() extensions to the bli_pthread API
      introduced in d479654. These functions were disabled after I realized
      that they aren't actually needed yet. Thanks to Devin Matthews for
      helping me reason through the appropriate consumer code that will
      appear in BLIS (eventually) in a future commit. (Also, I could never
      get the Windows branch to link properly in clang builds in AppVeyor.
      See the comment I left in the code, and #485, for more info.)

commit f9d604679d8715bc3e79a8630268446889b51388
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Mar 11 16:57:55 2021 -0600

    Added _self() and _equal() to bli_pthread API.
    
    Details:
    - Expanded the bli_pthread API to include equivalents to pthread_self()
      and pthread_equal(). Implemented these two functions for all three cpp
      branches present within bli_pthread.c: systemless, Windows, and
      Linux/BSD.

commit fa9b3c8f6b3d5717f19832362104413e1a86dfb0
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Mar 11 15:13:51 2021 -0600

    Shuffled code in Windows branch of bli_pthreads.c.
    
    Details:
    - Reordered the definitions in the cpp branch in bli_pthreads.c that
      defines the bli_pthreads API in terms of Windows API calls. Also added
      missing comments that mark sections of the API, which brings the code
      into harmony with other cpp branches (as well as bli_pthread.h).

commit 95d4f3934d806b3563f6648d57a4e381d747caf5
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Mar 11 13:50:40 2021 -0600

    Moved cpp macro redef of strerror_r to bli_env.c.
    
    Details:
    - Relocated the _MSC_VER-guarded cpp macro re-definition of strerror_r
      (in terms of strerror_s) from bli_thread.h to bli_env.c. It was
      likely left behind in bli_thread.h in a previous commit, when code
      that now resides in bli_env.c was moved from bli_thread.c. (I couldn't
      find any other instance of strerror_r being used in BLIS, so I moved
      the #define directly to bli_env.c rather than place it in bli_env.h.)
      The code that uses strerror_r is currently disabled, though, so this
      commit should have no affect on BLIS.

commit 8a3066c315358d45d4f5b710c54594455f9e8fc6
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Mar 9 17:52:59 2021 -0600

    Relocated gemmsup_ref general stride handling.
    
    Details:
    - Moved the logic that checks for general stridedness in any of the
      matrix operands in a gemmsup problem. The logic previously resided
      near the top of bli_gemmsup_int(), which is the thread entry point
      for the parallel region of the current gemmsup implementation. The
      problem with this setup was that the code would attempt to reject
      problems with any general-strided operands by returning BLIS_FAILURE,
      and that return value was then being ignored by the l3_sup thread
      decorator, which unconditionally returns BLIS_SUCCESS. To solve this
      issue, rather than try to manage n return values, one from each of n
      threads, I simply moved the logic into bli_gemmsup_ref(). I didn't
      move it any higher (e.g. bli_gemmsup()) because I still want the
      logic to be part of the current gemmsup handler implementation. That
      is, perhaps someone else will create a different handler, and that
      author wants to handle general stride differently. (We don't want to
      force them into a particular way of handling general stride.)
    - Removed the general stride handling from bli_gemmtsup_int(), even
      though this function is inoperative for now.
    - This commit addresses issue #484. Thanks to RuQing Xu for reporting
      this issue.

commit 670bc7b60f6065893e8ec1bebd2fc9e5ba710dff
Author: Nicholai Tukanov <nicholaitukanov@gmail.com>
Date:   Fri Mar 5 13:53:43 2021 -0600

    Add low-precision POWER10 gemm kernels (#467)
    
    Details:
    - This commit adds a new BLIS sandbox that (1) provides implementations
      based on low-precision gemm kernels, and (2) extends the BLIS typed
      API for those new implementations. Currently, these new kernels can
      only be used for the POWER10 microarchitecture; however, they may
      provide a template for developing similar kernels for other
      microarchitectures (even those beyond POWER), as changes would likely
      be limited to select places in the microkernel and possibly the
      packing routines. The new low-precision operations that are now
      supported include: shgemm, sbgemm, i16gemm, i8gemm, i4gemm. For more
      information, refer to the POWER10.md document that is included in
      'sandbox/power10'.

commit b8dcc5bc75a746807d6f8fa22dc2123c98396bf5 (origin/dev, origin/amd, dev, amd)
Author: RuQing Xu <r-xu@g.ecc.u-tokyo.ac.jp>
Date:   Tue Mar 2 06:58:24 2021 +0800

    Fixed typed API definition for gemmt (#476)
    
    Details:
    - Fixed incorrect definition and prototype of bli_?gemmt() in
      frame/3/bli_l3_tapi.c and .h, respectively. gemmt was previously
      defined identically to gemm, which was wrong because it did not
      take into account the uplo property of C.
    - Fixed incorrect API documentation for her2k/syr2k in BLISTypedAPI.md.
      Specifically, the document erroneously listed only a single transab
      parameter instead of transa and transb.

commit a0e4fe2340a93521e1b1a835a96d0f26dec8406a
Author: Ilknur <ilknuri607@gmail.com>
Date:   Tue Mar 2 02:06:56 2021 +0400

    Fixed double free() in level1v example (#482)
    
    Details:
    - In exampls/tapi/00level1v.c, pointer 'z' was being freed twice and
      pointer 'a' was not being freed at all. This commit correctly frees
      each pointer exactly once.

commit f5871c7e06a75799251d6b55a8a5fbfa1a92cf95
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Sun Feb 28 17:03:57 2021 -0600

    Added complex asm packm kernels for 'haswell' set.
    
    Details:
    - Implemented assembly-based packm kernels for single- and double-
      precision complex domain (c and z) and housed them in the 'haswell'
      kernel set. This means c3xk, c8xk, z3xk, and z4xk are now all
      optimized.
    - Registered the aforementioned packm kernels in the haswell, zen,
      and zen2 subconfigs.
    - Minor modifications to the corresponding s and d packm kernels that
      were introduced in 426ad67.
    - Thanks to AMD, who originally contributed the double-precision real
      packm kernels (d6xk and d8xk), upon which these complex kernels are
      partially based.

commit 426ad679f55264e381eb57a372632b774320fb85
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Sat Feb 27 18:39:56 2021 -0600

    Added assembly packm kernels for 'haswell' set.
    
    Details:
    - Implemented assembly-based packm kernels for single- and double-
      precision real domain (s and d) and housed them in the 'haswell'
      kernel set. This means s6xk, s16xk, d6xk, and d8xk are now all
      optimized.
    - Registered the aforementioned packm kernels in the haswell, zen,
      and zen2 subconfigs.
    - Thanks to AMD, who originally contributed the double-precision real
      packm kernels (d6xk and d8xk), which I have now tweaked and used to
      create comparable single-precision real kernels (s6xk and s16xk).

commit f50c1b7e5886d29efe134e1994d05af9949cd4b6
Merge: 8f39aea1 b3953b93
Author: Devin Matthews <damatthews@smu.edu>
Date:   Mon Feb 1 11:55:51 2021 -0600

    Merge pull request #473 from ajaypanyala/pkgconfig
    
    build: generate pkgconfig file

commit 8f39aea11f80a805b66cff4b4dc5e72727ea461d
Merge: f8db9fb3 2a815d5b
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Sat Jan 30 17:59:56 2021 -0600

    Merge branch 'dev'

commit f8db9fb33b48844d6b47fdef699625bd9197745a
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Jan 28 08:04:52 2021 -0600

    Fixed missing parentheses in README.md Citations.

commit b3953b938eee59f79b4a4162ba583a5cb59fa34e
Author: Ajay Panyala <ajay.panyala@gmail.com>
Date:   Tue Jan 12 17:07:04 2021 -0800

    drop CFLAGS in the generated pkgconfig file

commit b02d9376bac31c1a1c7916f44c4946277a1425e2
Author: Ajay Panyala <ajay.panyala@gmail.com>
Date:   Mon Jan 11 20:50:01 2021 -0800

    add datadir

commit d8d8deeb6d8b84adb7ae5fdb88c6dd4f06624a76
Author: Ajay Panyala <ajay.panyala@gmail.com>
Date:   Mon Jan 11 17:47:50 2021 -0800

    generate pkgconfig file

commit 8c65411c7c8737248a6f054ffa0ce008c95cb515
Merge: 328b4f88 874c3f04
Author: Devin Matthews <damatthews@smu.edu>
Date:   Mon Jan 11 16:01:45 2021 -0600

    Merge pull request #471 from flame/fix-470
    
    Fix kernel-to-config mapping for intel64

commit 874c3f04ece9af4d8fdf0e2713e21a259c117656
Author: Devin Matthews <damatthews@smu.edu>
Date:   Fri Jan 8 13:56:30 2021 -0600

    Update configure
    
    Choose last sub-config in the kernel-to-config map if the config list doesn't contain the name of the kernel set. E.g. for "zen: skx knl haswell" pick "haswell" instead of "skx" which was chosen previously. Fixes #470.

commit 2a815d5b365d934cb351b2f2a8cd1366e997b2e1
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Jan 4 18:03:39 2021 -0600

    Support trsm pre-inversion in 1m, bb, ref kernels.
    
    Details:
    - Expanded support for disabling trsm diagonal pre-inversion to other
      microkernel types, including the reference microkernel as well as the
      kernel implementations for 1m and the pre-broadcast B (bb) format used
      by the power9 subconfig. This builds on the 'haswell' and 'penryn'
      kernel support added in 7038bba. Thanks to Bhaskar Nallani for
      reminding me, in #461 (post-closure), that 1m support was missing from
      that commit.
    - Removed cpp branch of ref_kernels/3/bli_trsm_ref.c that contained the
      omp simd implementation after making a stripped-down copy in 'old'.
      This code has been disabled for some time and it seemed better suited
      to rot away out of sight rather than clutter up a file that is already
      cluttered by the presence of lower and upper versions.
    - Minor comment update to bli_ind_init().

commit c3ed2cbb9f60100fc9beb2a9d75476de9f711dc5
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Jan 4 16:16:32 2021 -0600

    Enable 1m only if real domain ukr is not reference.
    
    Details:
    - Previously, BLIS would automatically enable use of the 1m method
      for a given precision if the complex domain microkernel was a
      reference kernel. This commit adds an additional constraint so that
      1m is only enabled if the corresponding real domain microkernel is
      NOT reference. That is, BLIS now forgos use of 1m if both the real and
      complex domain kernels are reference implementations. Note that this
      does not prevent 1m from being enabled manually under those
      conditions; it only means that 1m will not be enabled automatically
      at initialization-time.

commit ed50c947385ba3b0b5d550015f38f7f0a31755c0
Merge: 0cef09aa 328b4f88
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Jan 4 14:31:44 2021 -0600

    Merge branch 'master' into dev

commit 328b4f8872b4bca9a53d2de8c6e285f3eb13d196
Author: Devin Matthews <damatthews@smu.edu>
Date:   Wed Dec 30 17:54:18 2020 -0600

    Shared object (dylib) was not built correctly for partial build.
    
    The SO build rule used $? instead of $^. Observed on macOS, not sure if it affected Linux or not.

commit ae6ef66ef824da9bc6348bf9d1b588cd4f2ded9b
Author: Devin Matthews <damatthews@smu.edu>
Date:   Wed Dec 30 17:34:55 2020 -0600

    bli_diag_offset_with_trans had wrong return type. Fixes #468.

commit ebcf197fb86fdd0a864ea928140752bc2462e8c6
Merge: 472f138c 21aa67e1
Author: Devin Matthews <damatthews@smu.edu>
Date:   Sat Dec 5 22:26:27 2020 -0600

    Merge pull request #466 from isuruf/patch-3
    
    fix cc_vendor for crosstool-ng toolchains

commit 21aa67e11cebbc5a6dd7c6353154256294df3c33
Author: Isuru Fernando <isuruf@gmail.com>
Date:   Sat Dec 5 21:59:13 2020 -0600

    fix cc_vendor for crosstool-ng toolchains

commit 472f138cb927b7259126ebb9c68919cfcc7a4ea3
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Sat Dec 5 14:13:52 2020 -0600

    Fixed typo in README.md to CodingConventions.md.

commit 0cef09aa92208441a656bf097f197ea8e22b533b
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Dec 4 16:40:59 2020 -0600

    Consolidated code in level-3 _front() functions.
    
    Details:
    - Reduced a code segment that appears in all of the bli_*_front()
      functions except for bli_gemm_front(). Previously, the code looked
      like this (taken from bli_herk_front()):
    
        if ( bli_cntx_method( cntx ) == BLIS_NAT )
        {
            bli_obj_set_pack_schema( BLIS_PACKED_ROW_PANELS, &a_local );
            bli_obj_set_pack_schema( BLIS_PACKED_COL_PANELS, &ah_local );
        }
        else // if ( bli_cntx_method( cntx ) != BLIS_NAT )
        {
            pack_t schema_a = bli_cntx_schema_a_block( cntx );
            pack_t schema_b = bli_cntx_schema_b_panel( cntx );
    
            bli_obj_set_pack_schema( schema_a, &a_local );
            bli_obj_set_pack_schema( schema_b, &ah_local );
        }
    
      This code segment is part of a sort-of-hack that allows us to
      communicate the pack schemas into the level-3 thread decorator, which
      needs them so that they can be passed into bli_l3_cntl_create_if(),
      where the control tree is created. However, the first conditional case
      above is unnecessary because the second case is fully generalized.
      That is, even in the native case, the context contains correct,
      queryable schemas. Thus, these code segments were reduced to something
      like:
    
        pack_t schema_a = bli_cntx_schema_a_block( cntx );
        pack_t schema_b = bli_cntx_schema_b_panel( cntx );
    
        bli_obj_set_pack_schema( schema_a, &a_local );
        bli_obj_set_pack_schema( schema_b, &ah_local );
    
      There's always a small chance that the seemingly unnecessary code
      in the first branch case has some special use that is not apparent to
      me, but the testsuite's default input parameters seem to think this
      commit will be fine.

commit 7038bbaa05484141195822291cf3ba88cbce4980
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Dec 4 16:08:15 2020 -0600

    Optionally disable trsm diagonal pre-inversion.
    
    Details:
    - Implemented a configure-time option, --disable-trsm-preinversion, that
      optionally disables the pre-inversion of diagonal elements of the
      triangular matrix in the trsm operation and instead uses division
      instructions within the gemmtrsm microkernels. Pre-inversion is
      enabled by default. When it is disabled, performance may suffer
      slightly, but numerical robustness should improve for certain
      pathological cases involving denormal (subnormal) numbers that would
      otherwise result in overflow in the pre-inverted value. Thanks to
      Bhaskar Nallani for reporting this issue via #461.
    - Added preprocessor macro guards to bli_trsm_cntl.c as well as the
      gemmtrsm microkernels for 'haswell' and 'penryn' kernel sets pursuant
      to the aforementioned feature.
    - Added macros to frame/include/bli_x86_asm_macros.h related to division
      instructions.

commit 78aee79452cce2691c40f05b3632bdfc122300af
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Dec 2 13:02:36 2020 -0600

    Allow amaxv testsuite module to run with dim = 0.
    
    Details:
    - Exit early from libblis_test_amaxv_check() when the vector dimension
      (length) of x is 0. This allows the module to run when the testsuite
      driver passes in a problem size of 0. Thanks to Meghana Vankadari for
      alerting us to this issue via #459.
    - Note: All other testsuite modules appear to work with problem sizes
      of 0, except for the microkernel modules. I chose not to "fix" those
      modules because a failure (or segmentation fault, as happens in this
      case) is actually meaningful in that it alerts the developer that some
      microkernels cannot be used with k = 0. Specifically, the 'haswell'
      kernel set contains microkernels that preload elements of B. Those
      microkernels would need to be restructured to avoid preloading in
      order to support usage when k = 0.

commit 92d2b12a44ee0990c22735472aeaf1c17deb2d9b
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Dec 2 13:02:00 2020 -0600

    Fixed obscure testsuite gemmt dependency bug.
    
    Details:
    - Fixed a bug in the gemmt testsuite module that only manifested when
      testing of gemmt is enabled but testing of gemv is disabled. The bug
      was due to a copy-paste error dating back to the introduction of gemmt
      in 88ad841.

commit b43dae9a5d2f078c9bbe07079031d6c00a68b7de
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Dec 1 16:44:38 2020 -0600

    Fixed copy-paste bugs in edge-case sup kernels.
    
    Details:
    - Fixed bugs in two sup kernels, bli_dgemmsup_rv_haswell_asm_1x6() and
      bli_dgemmsup_rd_haswell_asm_1x4(), which involved extraneous assembly
      instructions that were left over from when the kernels were first
      written. These instructions would cause segmentation faults in some
      situations where extra memory was not allocated beyond the end of
      the matrix buffers. Thanks to Kiran Varaganti for reporting these
      bugs and to Bhaskar Nallani for identifying the cause and solution.

commit 11dfc176a3c422729f453f6c23204cf023e9954d
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Dec 1 19:51:27 2020 +0000

    Reorganized thread auto-factorization logic.
    
    Details:
    - Reorganized logic of bli_thread_partition_2x2() so that the primary
      guts were factored out into "fast" and "slow" variants. Then added
      logic to the "fast" variant that allows for more optimal thread
      factorizations in some situations where there is at least one factor
      of 2.
    - Changed BLIS_THREAD_RATIO_M from 2 to 1 in bli_kernel_macro_defs.h and
      added comments to that file describing BLIS_THREAD_RATIO_? and
      BLIS_THREAD_MAX_?R.
    - In bli_family_zen.h and bli_family_zen2.h, preprocessed out several
      macros not used in vanilla BLIS and removed the unused macro
      BLIS_ENABLE_ZEN_BLOCK_SIZES from the former file.
    - Disabled AMD's small matrix handling entry points in bli_syrk_front.c
      and bli_trsm_front.c. (These branches of small matrix handling have
      not been reviewed by vanilla BLIS developers.)
    - Added commented-out calls printf() to bli_rntm.c.
    - Whitespace changes to bli_thread.c.

commit 6d3bafacd7aa7ad198762b39490876c172bfbbcb
Author: Devin Matthews <damatthews@smu.edu>
Date:   Sat Nov 28 17:17:56 2020 -0600

    Update BuildSystem.md
    
    Add git version >= 1.8.5 requirement (see #462).

commit 64856ea5a61b01d585750815788b6a775f729647
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Nov 23 16:54:51 2020 -0600

    Auto-reduce (by default) prime numbers of threads.
    
    Details:
    - When requesting multithreaded parallelism by specifying the total
      number of threads (whether it be via environment variable, globally at
      runtime, or locally at runtime), reduce the number of threads actually
      used by one if the original value (a) is prime and (b) exceeds a
      minimum threshold defined by the macro BLIS_NT_MAX_PRIME, which is set
      to 11 by default. If, when specifying the total number of threads (and
      not the individual ways of parallelism for each loop), prime numbers
      of threads are desired, this feature may be overridden by defining the
      BLIS_ENABLE_AUTO_PRIME_NUM_THREADS macro in the bli_family_*.h that
      corresponds to the configuration family targeted at configure-time.
      (For now, there is no configure option(s) to control this feature.)
      Thanks to Jeff Diamond for suggesting this change.
    - Defined a new function in bli_thread.c, bli_is_prime(), that returns a
      bool that determines whether an integer is prime. This function is
      implemented in terms of existing functions in bli_thread.c.
    - Updated docs/Multithreading.md to document the above feature, along
      with unrelated minor edits.

commit 55933b6ff6b9b8a12041715f42bba06273d84b74
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Nov 20 10:39:32 2020 -0600

    Added missing attribution to docs/ReleaseNotes.md.

commit e310f57b4b29fbfee479e0f9fe2040851efdec4f
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Nov 19 13:33:37 2020 -0600

    CHANGELOG update (0.8.0)

commit 9b387f6d5a010969727ec583c0cdd067a5274ed8 (tag: 0.8.0)
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Nov 19 13:33:37 2020 -0600

    Version file update (0.8.0)

commit 2928ec750d3a3e1e5d55de5b57ddc04e9d0bd796
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Nov 18 18:31:35 2020 -0600

    ReleaseNotes.md update in advance of next version.
    
    Details:
    - Updated docs/ReleaseNotes.md in preparation for next version.

commit b9899bedff6854639468daa7a973bb14ca131a74
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Nov 18 16:52:41 2020 -0600

    CREDITS file update.

commit 9bb23e6c2a44b77292a72093938ab1ee6e6cc26a
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Nov 16 15:55:45 2020 -0600

    Added support for systemless build (no pthreads).
    
    Details:
    - Added a configure option, --[enable|disable]-system, which determines
      whether the modest operating system dependencies in BLIS are included.
      The most notable example of this on Linux and BSD/OSX is the use of
      POSIX threads to ensure thread safety for when application-level
      threads call BLIS. When --disable-system is given, the bli_pthreads
      implementation is dummied out entirely, allowing the calling code
      within BLIS to remain unchanged. Why would anyone want to build BLIS
      like this? The motivating example was submitted via #454 in which a
      user wanted to build BLIS for a simulator such as gem5 where thread
      safety may not be a concern (and where the operating system is largely
      absent anyway). Thanks to Stepan Nassyr for suggesting this feature.
    - Another, more minor side effect of the --disable-system option is that
      the implementation of bli_clock() unconditionally returns 0.0 instead
      of the time elapsed since some fixed point in the past. The reasoning
      for this is that if the operating system is truly minimal, the system
      function call upon which bli_clock() would normally be implemented
      (e.g. clock_gettime()) may not be available.
    - Refactored preprocess-guarded code in bli_pthread.c and bli_pthread.h
      to remove redundancies.
    - Removed old comments and commented #include of "bli_pthread_wrap.h"
      from bli_system.h.
    - Documented bli_clock() and bli_clock_min_diff() in BLISObjectAPI.md
      and BLISTypedAPI.md, with a note that both are non-functional when
      BLIS is configured with --disable-system.

commit 88ad84143414644df4c56733b1cf91a36bfacaf8
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Sat Nov 14 09:39:48 2020 -0600

    Squash-merge 'pr' into 'squash'. (#457)
    
    Merged contributions from AMD's AOCL BLIS (#448).
    
    Details:
    - Added support for level-3 operation gemmt, which performs a gemm on
      only the lower or upper triangle of a square matrix C. For now, only
      the conventional/large code path will be supported (in vanilla BLIS).
      This was accomplished by leveraging the existing variant logic for
      herk. However, some of the infrastructure to support a gemmtsup is
      included in this commit, including
      - A bli_gemmtsup() front-end, similar to bli_gemmsup().
      - A bli_gemmtsup_ref() reference handler function.
      - A bli_gemmtsup_int() variant chooser function (with variant calls
        commented out).
    - Added support for inducing complex domain gemmt via the 1m method.
    - Added gemmt APIs to the BLAS and CBLAS compatiblity layers.
    - Added gemmt test module to testsuite.
    - Added standalone gemmt test driver to 'test' directory.
    - Documented gemmt APIs in BLISObjectAPI.md and BLISTypedAPI.md.
    - Added a C++ template header (blis.hh) containing a BLAS-inspired
      wrapper to a set of polymorphic CBLAS-like function wrappers defined
      in another header (cblas.hh). These two headers are installed if
      running the 'install' target with INSTALL_HH is set to 'yes'. (Also
      added a set of unit tests that exercise blis.hh, although they are
      disabled for now because they aren't compatible with out-of-tree
      builds.) These files now live in the 'vendor' top-level directory.
    - Various updates to 'zen' and 'zen2' subconfigurations, particularly
      within the context initialization functions.
    - Added s and d copyv, setv, and swapv kernels to kernels/zen/1, and
      various minor updates to dotv and scalv kernels. Also added various
      sup kernels contributed by AMD to kernels/zen/3. However, these
      kernels are (for now) not yet used, in part because they caused
      AppVeyor clang failures, and also because I have not found time to
      review and vet them.
    - Output the python found during configure into the definition of PYTHON
      in build/config.mk (via build/config.mk.in).
    - Added early-return checks (A, B, or C with zero dimension; alpha = 0)
      to bli_gemm_front.c.
    - Implemented explicit beta = 0 handling in for the sgemm ukernel in
      bli_gemm_armv7a_int_d4x4.c, which was previously missing. This latent
      bug surfaced because the gemmt module verifies its computation using
      gemm with its beta parameter set to zero, which, on a cortexa15 system
      caused the gemm kernel code to unconditionally multiply the
      uninitialized C data by beta. The C matrix likely contained
      non-numeric values such as NaN, which then would have resulted in a
      false failure.
    - Fixed a bug whereby the implementation for bli_herk_determine_kc(),
      in bli_l3_blocksize.c, was inadvertantly being defined in terms of
      helper functions meant for trmm. This bug was probably harmless since
      the trmm code should have also done the right thing for herk.
    - Used cpp macros to neutralize the various AOCL_DTL_TRACE_ macros in
      kernels/zen/3/bli_gemm_small.c since those macros are not used in
      vanilla BLIS.
    - Added cpp guard to definition of bli_mem_clear() in bli_mem.h to
      accommodate C++'s stricter type checking.
    - Added cpp guard to test/*.c drivers that facilitate compilation on
      Windows systems.
    - Various whitespace changes.

commit 234b8b0cf48f1ee965bd7999b291fc7add3b9a54
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Nov 12 19:11:16 2020 -0600

    Increased dotxaxpyf testsuite thresholds.
    
    Details:
    - Increased the test thresholds used by the dotxaxpyf testsuite module
      by a factor of five in order to avoid residuals that unnecessarily
      fall in the MARGINAL range. This commit should fix #455. Thanks to
      @nagsingh for reporting this issue.

commit ed612dd82c50063cfd23576a6b2465213d31b14b
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Sat Nov 7 13:09:42 2020 -0600

    Updated README.md with sgemmsup blurb.
    
    Details:
    - Added an entry to the "What's New" section of the README.md to
      announce the availability of sgemmsup.

commit e14424f55b15d67e8d18384aea45a11b9b772e02
Merge: 0cfe1aac eccdd75a
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Sat Nov 7 13:02:50 2020 -0600

    Merge branch 'dev'

commit 0cfe1aac222008a78dff3ee03ef5183413936706
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Oct 30 17:10:36 2020 -0500

    Relocated operation index to ToC in API docs.
    
    Details:
    - Moved the "Operation index" section of both the BLISObjectAPI.md and
      BLISTypedAPI.md docs to appear immediately after the table of contents
      of each document. This allows the reader to quickly jump to the
      documentation for any operation without having to scroll through much
      of the document (when rendered via a web browser).
    - Fixed a mistake in the BLISObjectAPI.md for the setd operation, which
      does *not* observe the diag property of its matrix argument. Thanks to
      Jeff Diamond for reporting this.

commit 2a0682f8e5998be536da313525292f0da6193147
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Sun Oct 18 18:04:03 2020 -0500

    Implemented runtime subconfig selection (#451).
    
    Details:
    - Implemented support for the user manually overriding the automatic
      subconfiguration selection that happens at runtime. This override
      can be requested by setting the BLIS_ARCH_TYPE environment variable.
      The variable must be set to the arch_t id (as enumerated in
      bli_type_defs.h) corresponding to the desired subconfiguration. If a
      value outside this enumerated range is given, BLIS will abort with an
      error message. If the value is in the valid range but corresponds to a
      subconfiguration that was not activated at configure-time/compile-time,
      BLIS will abort with a (different) error message. Thanks to decandia50
      for suggesting this feature via issue #451.
    - Defined a new function bli_gks_lookup_id to return the address of an
      internal data structure within the gks. If this address is NULL, then
      it indicates that the subconfig corresponding to the arch_t id passed
      into the function was not compiled into BLIS. This function is used
      in the second of the two abort scenarios described above.
    - Defined the enumerated error code BLIS_UNINITIALIZED_GKS_CNTX, which
      is returned for the latter of the two abort scenarios mentioned above,
      along with a corresponding error message and a function to perform
      the error check.
    - Added cpp macro branching to bli_env.c to support compilation of the
      auto-detect.x executable during configure-time. This cpp branch is
      similar to the cpp code already found in bli_arch.c and bli_cpuid.c.
    - Cleaned up the auto_detect() function to facilitate easier maintenance
      going forward. Also added a convenient debug switch that outputs the
      compilation command for the auto-detect.x executable and exits.

commit eccdd75a2d8a0c46e91e94036179c49aa5fa601c
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Oct 9 15:44:16 2020 -0500

    Whitespace tweak in docs/PerformanceSmall.md.

commit 7677e9ba60ac27496e3421c2acc7c239e3f860e9
Merge: addcd46b a0849d39
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Oct 9 15:41:25 2020 -0500

    Merge branch 'dev' of github.com:flame/blis into dev

commit addcd46b0559d401aa7d33d4c7e6f63f5313a8e0
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Oct 9 15:41:09 2020 -0500

    Added Epyc 7742 Zen2 ("Rome") sup perf results.
    
    Details:
    - Added single-threaded and multithreaded sup performance results to
      docs/PerformanceSmall.md for both sgemm and dgemm. These results were
      gathered on an Epyc 7742 "Rome" server featuring AMD's Zen2
      microarchitecture. Special thanks to Jeff Diamond for facilitating
      access to the system via the Oracle Cloud.
    - Updates to octave scripts in test/sup/octave for use with Octave 5.2
      and for use with subplot_tight().
    - Minor updates to octave scripts in test/3/octave.
    - Renamed files containing the previous Zen performance results for
      consistency with the new results.
    - Decreased line thickness slightly in large/conventional Zen2 graphs.
      I'm done tweaking those this time. Really.
    - Added missing line regarding eigen header installation for each
      microarchitecture section.

commit a0849d390d04067b82af937cda8191b049b98915
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Oct 9 20:22:17 2020 +0000

    Register l3 sup kernels in zen2 subconfig.
    
    Details:
    - Registered full suite of sgemm and dgemm sup millikernels, blocksizes,
      and crossover thresholds in bli_cntx_init_zen2.c.
    - Minor updates to test/sup/runme.sh for running on Zen2 Epyc 7742
      system.

commit d98368c32d5fbfaab8966ee331d9bcb5c4fe7a59
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Oct 8 19:05:51 2020 -0500

    Another tweak to line thickness of Zen2 graphs.

commit 1855dfbdaafa37892b36c97fd317fd5d8da76676
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Oct 8 19:01:00 2020 -0500

    Tweaked line thickness in Zen2 graphs once more.
    
    Details:
    - Decreased (relative to previous commit) line thickness in recent Zen2
      graphs.

commit 0991611e7ed82889c53a5c3f1ef1d49552c50d61
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Oct 8 18:54:49 2020 -0500

    Increased line thickness in recent Zen2 graphs.
    
    Details:
    - Increased the width of the lines in the graphs introduced in 74ec6b8.

commit 8273cbacd7799e9af59e5320d66055f2f5d9cb31
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Oct 7 14:51:33 2020 -0500

    README.md, docs/FAQ.md updates.
    
    Details:
    - Added a frequently asked question to docs/FAQ.md regarding the
      difference between upstream (vanilla) BLIS and AMD BLIS.
    - Updated the name of ICES in the README.md to reflect the Oden
      rebranding.

commit a178a822ad3d5021489a0e61f909d8550ae12a8f
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Sep 30 16:00:52 2020 -0500

    Added Zen2 links to docs/Performance.md Contents.

commit 74ec6b8f457cabe37d2382aaab35ba04fc737948
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Sep 30 15:54:18 2020 -0500

    Added Epyc 7742 Zen2 ("Rome") performance results.
    
    Details:
    - Added single-threaded and multithreaded performance results to
      docs/Performance.md. These results were gathered on an Epyc 7742
      "Rome" server with AMD's Zen2 microarchitecture. Special thanks
      to Jeff Diamond for facilitating access to the system via the
      Oracle Cloud.
    - Renamed files containing the previous Zen performance results for
      consistency with the new results.

commit bc4a213a2c3dcf8bbfcbb3a1ef3e9fc9e3226c34
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Sep 30 15:28:20 2020 -0500

    Updated matlab (now octave) plot code in test/3.
    
    Details:
    - Renamed test/3/matlab to test/3/octave.
    - Within test/3, updated and tuned plot_l3_perf.m and plot_panel_4x5.m
      files for use with octave (which is free and doesn't crash on me
      mid-way through my use of subplot).
    - Updated runthese.m scratchpad for zen2 invocations.
    - Added Nikolay S.'s subplot_tight() function, along with its license.

commit c77ddc418187e1884fa6bcfe570eee295b9cb8bc
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Sep 30 20:15:43 2020 +0000

    Added optional numactl usage to test/3/runme.sh.

commit 2d8ec164e7ae4f0c461c27309dc1f5d1966eb003
Author: Nicholai Tukanov <nicholai@utexas.edu>
Date:   Tue Sep 29 16:52:18 2020 -0500

    Add POWER10 support to BLIS (#450)

commit 4fd8d9fec2052257bf2a5c6e0d48ae619ff6c3e4
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Sep 28 23:39:05 2020 +0000

    Tweaked zen2 subconfig's MC cache blocksizes.
    
    Details:
    - Updated the MC cache blocksizes registered by the 'zen2' subconfig.
    - Minor updates to test/3/Makefile and test/3/runme.sh.

commit 5efcdeffd58af621476d179afc0c19c0f912baa8
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Sep 25 14:25:24 2020 -0500

    More minor README.md updates.

commit 9e940f8aad6f065ea1689e791b9a4e1fb7900c40
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Sep 25 13:53:35 2020 -0500

    Added 1m SISC bibtex to README.md.
    
    Details:
    - Added final citation info to 1m bibtex in README.md file.
    - Updated draft 1m paper link.
    - Changed some http to https.

commit e293cae2d1b9067261f613f25eaa0e871356b317
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Sep 15 16:09:11 2020 -0500

    Implemented sgemmsup assembly kernels.
    
    Details:
    - Created a set of single-precision real millikernels and microkernels
      comparable to the dgemmsup kernels that already exist within BLIS.
    - Added prototypes for all kernels within bli_kernels_haswell.h.
    - Registered entry-point millikernels in bli_cntx_init_haswell.c and
      bli_cntx_init_zen.c.
    - Added sgemmsup support to the Makefile, runme.sh script, and source
      file in test/sup. This included edits that allow for separate "small"
      dimensions for single- and double-precision as well as for single-
      vs. multithreaded execution.

commit 2765c6f37c11cb7f71cd4b81c64cea6130636c68
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Sat Sep 12 17:48:15 2020 -0500

    Type saga continues; fixed sgemm ukernel signature.
    
    Details:
    - Changed double* pointers in sgemm function signature to float*. At
      this point I've lost track of whether this was my fault or another
      dormant bug like the one described in ece9f6a, but at this point I
      no longer care. It's one of those days (aka I didn't ask for this).

commit 0779559509e0a1af077530d09ed151dac54f32ee
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Sat Sep 12 17:37:21 2020 -0500

    Fixed missing restrict in knl sgemm prototype.
    
    Details:
    - Added a missing 'restrict' qualifier in the sgemm ukernel prototype
      for knl. (Not sure how that code was ever compiling before now.)

commit ece9f6a3ef1b26b53ecf968cd069df7a85b139fb
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Sat Sep 12 17:22:42 2020 -0500

    Fixed dormant type bugs in bli_kernels_knl.h.
    
    Details:
    - Fixed dormant type mismatches in the use of the prototype-generating
      macros in bli_kernels_knl.h. Specifically, some float prototypes
      were incorrectly using double as their ctype. This didn't actually
      matter until the type changes in 645d771, as previously those types
      were not used since packm was prototyped with void* pointers.

commit 8ebb3b60e1c4c045ddb48e02de6e246cecde24a4
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Sat Sep 12 17:00:47 2020 -0500

    Fixed accidental breakage in 645d771.
    
    Details:
    - In trying to clean up kappa_cast variables in the reference packm
      kernels, which I initally believed to be redundant given the other
      void* -> ctype* changes in 645d771, I accidentally ended up violating
      restrict semantics for 1e/1r packing and possibly other packm kernels.
      (Normally, my pre-commit testsuite run would have caught this, but I
      was unknowingly using an edited input.operations file in which I'd
      disabled most tests as part of unrelated work.) This commit reverts
      the kappa_cast changes in 645d771.

commit 645d771a14ae89aa7131d6f8f4f4a8090329d05e
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Sat Sep 12 15:31:56 2020 -0500

    Minor packm kernel type cleanup (void* -> ctype*).
    
    Details:
    - Changed all void* function arguments in reference packm kernels to
      those of the native type (ctype*). These pointers no longer need to
      be void* and are better represented by their native types anyway.
      (See below for details.) Updated knl packm kernels accordingly.
    - In the definition of the PACKM_KER_PROT prototype macro template in
      frame/1m/bli_l1m_ker_prot.h, changed the pointer types for kappa, a,
      and p from void* to ctype*. They were originally void* because these
      function signatures had to share the same type so they could all be
      stored in a single array of that shared type, from which they were
      queried and called by packm_cxk(). This is no longer how the function
      pointers are stored, and so it no longer makes sense to force the
      caller of packm kernels to use void*, only so that the implementor
      of the packm kernels can typecast back to the native datatype within
      the kernel definition. This change has no effect internally within
      BLIS because currently all packm kernels are called after querying
      the function addresses from the context and then typecasting to the
      appropriate function pointer type, which is based upon type-specific
      function pointers like float* and double*.
    - Removed a comment in frame/1m/bli_l1m_ft_ker.h that was outdated and
      misleading due to changes to the handling of packm kernels since
      moving them into the context.

commit 54bf6c35542a297e25bc8efec6067a6df80536f4
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Sep 10 15:42:01 2020 -0500

    Minor README.md update.
    
    Details:
    - Added a new entry to the "What people are saying about BLIS" section.

commit e50b4d40462714ae33df284655a2faf7fa35f37c
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Sep 9 14:12:53 2020 -0500

    Minor update to README.md (SIAM Best Paper Prize).

commit a8efb72074691e2610372108becd88b4b392299e
Merge: b0c4da17 97e87f2c
Author: Devin Matthews <damatthews@smu.edu>
Date:   Mon Sep 7 16:18:19 2020 -0500

    Merge pull request #434 from flame/intel-zdot
    
    Add an option to change the complex return type.

commit 97e87f2c9f3878a05e1b7c6ec237ee88d9a72a42
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Sep 7 15:56:42 2020 -0500

    Whitespace/comment updates to #434 PR.

commit b0c4da1732b6c6a9ff66f70c36e4722e0f9645ae
Merge: 810e90ee b1b5870d
Author: Devin Matthews <damatthews@smu.edu>
Date:   Mon Sep 7 15:47:54 2020 -0500

    Merge pull request #436 from flame/s390x
    
    Add checks so that s390x is detected as 64-bit.

commit 810e90ee806510c57504f0cf8eeaf608d38bd9dd
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Sep 1 16:11:40 2020 -0500

    Minor README.md update.
    
    Details:
    - Added HPE to list of funders.
    - Changed http to https in funders' website links.

commit 7d411282196e036991c26e52cb5e5f85769c8059
Author: Devin Matthews <damatthews@smu.edu>
Date:   Thu Aug 13 17:50:58 2020 -0500

    Use -O2 for all framework code. (#435)
    
    It seems that -O3 might be causing intermittent problems with the f2c'ed packed and banded code. -O3 is retained for kernel code. Fixes #341 and fixes #342.

commit 9c5b485d356367b0a1288761cd623f52036e7344
Author: Dave Love <dave.love@manchester.ac.uk>
Date:   Fri Aug 7 20:11:18 2020 +0000

    Don't override -mcpu with -march on ARM (#353)
    
    * Use -mcpu for ARM
    See the GCC doc about -march, -mtune, and -mpu and maybe
    https://community.arm.com/developer/tools-software/tools/b/tools-software-ides-blog/posts/compiler-flags-across-architectures-march-mtune-and-mcpu
    
    * Fix typo in flags
    
    * Fix typo in cortexa9 flags
    
    * Modify cortexa53 compilation flags to fix failing BLAS check (#341)

commit c253d14a72a746b670b3ffbb6e81bcafc73d1133
Author: Devin Matthews <damatthews@smu.edu>
Date:   Fri Aug 7 09:39:04 2020 -0500

    Also handle Intel-style complex return in CBLAS interface.

commit 5d653a11a0cc71305d0995507b1733995856f475
Author: Devin Matthews <damatthews@smu.edu>
Date:   Thu Aug 6 17:58:26 2020 -0500

    Update Multithreading.md
    
    Addresses the issue raised in #426.

commit b1b5870dd3f9b1c78cf5f58a53514d73f001fc4c
Author: Devin Matthews <damatthews@smu.edu>
Date:   Thu Aug 6 17:34:20 2020 -0500

    Add checks so that s390x is detected as 64-bit.

commit 882dcb11bfc9ea50aa2f9044621833efd90d42be
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Aug 6 17:28:14 2020 -0500

    Mention example code at top of documentation docs.
    
    Details:
    - Steer the reader towards the example code section of each
      documentation doc (object and typed).
    - Trivial update to examples/oapi/README, examples/tapi/README.

commit f4894512e5bf56ff83701c07dd02972e300741a5
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Aug 6 17:20:00 2020 -0500

    Very minor updates to previous commit.

commit adedb893ae8dfacd1dc54035979e15c44d589dbb
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Aug 6 17:14:01 2020 -0500

    Documented mutator functions in BLISObjectAPI.md.
    
    Details:
    - Added documentation for commonly-used object mutator functions in
      BLISObjectAPI.md. Previously, only accessor functions were documented.
      Thanks to Jeff Diamond for pointing out this omission.
    - Explicitly set the 'diag' property of objects in oapi example modules
      (08level2.c and 09level3.c).

commit 5b5278ff494888509543a79c09ea82089f6c95d9
Author: Devin Matthews <damatthews@smu.edu>
Date:   Thu Aug 6 14:19:37 2020 -0500

    Use #ifdef instead of #if as macro may be undefined.

commit 7fdc0fc893d0c6727b725ea842053b65be2c20ba
Author: Devin Matthews <damatthews@smu.edu>
Date:   Thu Aug 6 14:03:55 2020 -0500

    Add an option to change the complex return type.
    
    ifort apparently does not return complex numbers in registers as in C/C++ (or gfortran), but instead creates a "hidden" first parameter for the return value. The option --complex-return=gnu|intel has been added, as well as a guess based on a provided FC if not specified (otherwise default to gnu). This option affects the signatures of cdotc, cdotu, zdotc, and zdotu, and a single library cannot be used with both GNU and Intel Fortran compilers. Fixes #433.

commit 6e522e5823b762d4be09b6acdca30faafba56758
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Jul 30 19:31:37 2020 -0500

    Mention disabling of sup in docs/Sandboxes.md.
    
    Details:
    - Added language to remind the reader to disable sup if the intended
      behavior is for the sandbox implementation to handle all problem
      sizes, even the smaller ones that would normally be handled by the
      sup code path.

commit 00e14cb6d849e963a2e1ac35e7dbbe186af00a58
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Jul 29 14:24:34 2020 -0500

    Replaced use of bool_t type with C99 bool.
    
    Details:
    - Textually replaced nearly all non-comment instances of bool_t with the
      C99 bool type. A few remaining instances, such as those in the files
      bli_herk_x_ker_var2.c, bli_trmm_xx_ker_var2.c, and
      bli_trsm_xx_ker_var2.c, were promoted to dim_t since they were being
      used not for boolean purposes but to index into an array.
    - This commit constitutes the third phase of a transition toward using
      C99's bool instead of bool_t, which was raised in issue #420. The first
      phase, which cleaned up various typecasts in preparation for using
      bool as the basis for bool_t (instead of gint_t), was implemented by
      commit a69a4d7. The second phase, which redefined the bool_t typedef
      in terms of bool (from gint_t), was implemented by commit 2c554c2.

commit 2c554c2fce885f965a425e727a0314d3ba66c06d
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Jul 24 15:57:19 2020 -0500

    Redefined bool_t typedef in terms of C99 bool.
    
    Details:
    - Changed the typedef that defines bool_t from:
    
        typedef gint_t bool_t;
    
      where gint_t is a signed integer that forms the basis of most other
      integers in BLIS, to:
    
        typedef bool bool_t;
    
    - Changed BLIS's TRUE and FALSE macro definitions from being in terms of
      integer literals:
    
        #define TRUE  1
        #define FALSE 0
    
      to being in terms of C99 boolean constants:
    
        #define TRUE  true
        #define FALSE false
    
      which are provided by stdbool.h.
    - This commit constitutes the second phase of a transition toward using
      C99's bool instead of bool_t, which will address issue #420. The first
      phase, which cleaned up various typecasts in preparation for using
      bool as the basis for bool_t (instead of gint_t), was implemented by
      commit a69a4d7.

commit e01dd125581cec87f61e15590922de0dc938ec42
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Jul 24 15:41:46 2020 -0500

    Fail-safe updates to Makefiles in 'test' dir.
    
    Details:
    - Updated Makefiles in test, test/3, and test/sup so that running any of
      the usual targets without having first built BLIS results in a helpful
      error message. For example, if BLIS is not yet configured, make will
      output:
    
        Makefile:327: *** Cannot proceed: config.mk not detected! Run
        configure first.  Stop.
    
      Similarly, if BLIS is configured but not yet built, make will output:
    
        Makefile:340: *** Cannot proceed: BLIS library not yet built! Run
        make first.  Stop.
    
      In previous commits, these actions would result in a rather cryptic
      make error such as:
    
        make: *** No rule to make target 'test_sgemm_2400_asm_blis_st.x',
        needed by 'blis-nat-st'.  Stop.

commit b4f47f7540062da3463e2cb91083c12fdda0d30a
Author: Devin Matthews <damatthews@smu.edu>
Date:   Fri Jul 24 13:56:13 2020 -0500

    Add BLIS_EXPORT_BLIS to bli_abort. (#429)
    
    Fixes #428.

commit a69a4d7e2f4607c919db30b14535234ce169c789
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Jul 22 16:13:09 2020 -0500

    Cleaned up bool_t usage and various typecasts.
    
    Details:
    - Fixed various typecasts in
    
        frame/base/bli_cntx.h
        frame/base/bli_mbool.h
        frame/base/bli_rntm.h
        frame/include/bli_misc_macro_defs.h
        frame/include/bli_obj_macro_defs.h
        frame/include/bli_param_macro_defs.h
    
      that were missing or being done improperly/incompletely. For example,
      many return values were being typecast as
        (bool_t)x && y
      rather than
        (bool_t)(x && y)
      Thankfully, none of these deficiencies had manifested as actual bugs
      at the time of this commit.
    - Changed the return type of bli_env_get_var() from dim_t to gint_t.
      This reflects the fact that bli_env_get_var() needs to be able to
      return a signed integer, and even though dim_t is currently defined
      as a signed integer, it does not intuitively appear to necessarily be
      signed by inspection (i.e., an integer named "dim_t" for matrix
      "dimension"). Also, updated use of bli_env_get_var() within
      bli_pack.c to reflect the changed return type.
    - Redefined type of thrcomm_t.barrier_sense field from bool_t to gint_t
      and added comments to the bli_thrcomm_*.h files that will explain a
      planned replacement of bool_t with C99's bool type.
    - Note: These changes are being made to facilitate the substitution of
      'bool' for 'bool_t', which will eliminate the namespace conflict with
      arm_sve.h as reported in issue #420. This commit implements the first
      phase of that transition. Thanks to RuQing Xu for reporting this
      issue.
    - CREDITS file update.

commit a6437a5c11d364c6c88af527294d29734d7cc7d6
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Jul 20 19:21:07 2020 -0500

    Replaced broken ref99 sandbox w/ simpler version.
    
    Details:
    - The 'ref99' sandbox was broken by multiple refactorings and internal
      API changes over the last two years. Rather than try to fix it, I've
      replaced it with a much simpler version based on var2 of gemmsup.
      Why not fix the previous implementation? It occurred to me that the
      old implementation was trying to be a lightly simplified duplication
      of what exists in the framework. Duplication aside, this sandbox
      would have worked fine if it had been completely independent of the
      framework code. The problem was that it was only partially
      independent, with many function calls calling a function in BLIS
      rather than a duplicated/simplified version within the sandbox. (And
      the reason I didn't make it fully independent to begin with was that
      it seemed unnecessarily duplicative at the time.) Maintaining two
      versions of the same implementation is problematic for obvious
      reasons, especially when it wasn't even done properly to begin with.
      This explains the reimplementation in this commit. The only catch is
      that the newer implementation is single-threaded only and does not
      perform any packing on either input matrix (A or B). Basically, it's
      only meant to be a simple placeholder that shows how you could plug
      in your own implementation. Thanks to Francisco Igual for reporting
      this brokenness.
    - Updated the three reference gemmsup kernels (defined in
      ref_kernels/3/bli_gemmsup_ref.c) so that they properly handle
      conjugation of conja and/or conjb. The general storage kernel, which
      is currently identical to the column-storage kernel, is used in the
      new ref99 sandbox to provide basic support for all datatypes
      (including scomplex and dcomplex).
    - Minor updates to docs/Sandboxes.md, including adding the threading
      and packing limitations to the Caveats section.
    - Fixed a comment typo in bli_l3_sup_var1n2m.c (upon which the new
      sandbox implementation is based).

commit bca040be9da542dd9c75d91890fa7731841d733d
Merge: 2605eb4d 171ecc1d
Author: Devin Matthews <damatthews@smu.edu>
Date:   Mon Jul 20 09:27:30 2020 -0500

    Merge pull request #425 from gmargari/patch-1
    
    Update Multithreading.md

commit 171ecc1dc6f055ea39da30e508f711b49a734359
Author: Giorgos Margaritis <gmargari@protonmail.com>
Date:   Mon Jul 20 12:24:06 2020 +0300

    Update Multithreading.md

commit 2605eb4d99d3813c37a624c011aa2459324a6d89
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Jul 15 15:25:19 2020 -0500

    Added missing rv_d?x6 edge cases to sup kernel.
    
    Details:
    - Added support to bli_gemmsup_rv_haswell_asm_d6x8n.c for handling
      various n = 6 edge cases with a single sup kernel call. Previously,
      only n = {4,2,1} were handled explicitly as single kernel calls;
      that is, cases where n = 6 were previously being executed via two
      kernel calls (n = 4 and n = 2).
    - Added commented debug line to testsuite's test_libblis.c.

commit 72f6ed0637dfcb021de04ac7d214d5c87e55d799
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Jul 3 17:55:54 2020 -0500

    Declare/define static functions via BLIS_INLINE.
    
    Details:
    - Updated all static function definitions to use the cpp macro
      BLIS_INLINE instead of the static keyword. This allows blis.h to
      use a different keyword (inline) to define these functions when
      compiling with C++, which might otherwise trigger "defined but
      not used" warning messages. Thanks to Giorgos Margaritis for
      reporting this issue and Devin Matthews for suggesting the fix.
    - Updated the following files, which are used by configure's
      hardware auto-detection facility, to unconditionally #define
      BLIS_INLINE to the static keyword (since we know BLIS will be
      compiled with C, not C++):
        build/detect/config/config_detect.c
        frame/base/bli_arch.c
        frame/base/bli_cpuid.c
    - CREDITS file update.

commit 5fc701ac5f94c6300febbb2f24e731aa34f0f34a
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Jul 1 15:48:58 2020 -0500

    Added -fomit-frame-pointer option to CKOPTFLAGS.
    
    Details:
    - Added the -fomit-frame-pointer compiler option to the CKOPTFLAGS
      variable in the following make_defs.mk files:
        config/haswell/make_defs.mk
        config/skx/make_defs.mk
      as well as comments that mention why the compiler option is needed.
      This option is needed to prevent the compiler from using the rbp
      frame register (in the very early portion of kernel code, typically
      where k_iter and k_left are defined and computed), which, as of
      1c719c9, is used explicitly by the gemmsup millikernels. Thanks to
      Devin Matthews for identifying this missing option and to Jeff
      Diamond for reporting the original bug in #417.
    - The file
        config/zen/amd_config.mk
      which feeds into the make_defs.mk for both zen and zen2 subconfigs,
      was also touched, but only to add a commented-out compiler option
      (and the aforementioned explanatory comment) since that file already
      uses -fomit-frame-pointer in COPTFLAGS, which forms the basis of
      CKOPTFLAGS.

commit 6af59b705782dada47e45df6634b479fe781d4fe
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Jul 1 14:54:23 2020 -0500

    Fixed disabled edge case optimization in gemmsup.
    
    Details:
    - Fixed an inadvertently disabled edge case optimization in the two
      gemmsup variants in bli_l3_sup_var1n2m.c. Background: These edge case
      optimizations allow the last millikernel operation in the jr loop to
      be executed with inflated an register blocksize if it is the last
      (or only) iteration. For example, if mr=6 and nr=8 and the gemmsup
      problem is m=8, n=100, k=100. (In this case, the panel-block variant
      (var1n) is executed, which places the jr loop in the m dimension.)
      In principle, this problem could be executed as two millikernels: one
      with dimensions 6x100x100, and one as 2x100x100. However, with the
      support for inflated blocksizes in the kernel, the entire 8x100x100
      problem can be passed to the millikernel function, which will then
      execute it more favorably as two 4x100x100 millikernel sub-calls.
      Now, this optimization is disabled under certain circumstances, such
      as when multithreading. Previously, the is_mt predicate was being set
      incorrectly such that it was non-zero even when running
      single-threaded.
    - Upon fixing the is_mt issue above, another bit of code needed to be
      moved so that the result of the optimization could have an impact on
      the assignment of loop bounds ranges to threads.

commit b37634540fab0f9b8d4751b8356ee2e17c9e3b00
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Jun 25 16:05:12 2020 -0500

    Support ldims, packing in sup/test drivers.
    
    Details:
    - Updated the test/sup source file (test_gemm.c) and Makefile to support
      building matrices with small or large leading dimensions, and updated
      runme.sh to support executing both kinds of test drivers.
    - Updated runme.sh to allow for executing sup drivers with unpacked (the
      default) or packed matrices (via setting BLIS_PACK_A, BLIS_PACK_B
      environment variables), and for capturing output to files that encode
      both the leading dimension (small or large) and packing status into
      the filenames.
    - Consolidated octave scripts in test/sup/octave_st, test/sup/octave_mt
      into test/sup/octave and updated the octave code in that consolidated
      directory to read the new output filename format (encoding ldim and
      packing). Also added comments and streamlined code, particularly in
      plot_panel_trxsh.m. Tested the octave scripts with octave 5.2.0.
    - Moved old octave_st, octave_mt directories to test/sup/old.

commit ceb9b95a96cc3844ecb43d9af48ab289584e76b6
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Jun 18 17:15:25 2020 -0500

    Fixed incorrect link to shiftd in BLISTypedAPI.md.
    
    Details:
    - Previously, the entry for shiftd in the Operation index section of
      BLISTypedAPI.md was incorrectly linking to the shiftd operation entry
      in BLISObjectAPI.md. This has been fixed. Thanks to Jeff Diamond for
      helping find this incorrect link.

commit b3c42016818797f79e55b32c8b7d090f9d0aa0ea
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Jun 18 14:00:56 2020 -0500

    CREDITS file update.

commit 31af73c11abae03248d959da0f81eacea015b57a
Author: Isuru Fernando <isuruf@gmail.com>
Date:   Thu Jun 18 13:35:54 2020 -0500

    Expand windows instructions (#414)
    
    * Expand windows instructions
    
    * Windows: both static and shared don't work at the same time

commit b5b604e106076028279e6d94dc0e51b8ad48e802
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Jun 17 16:42:24 2020 -0500

    Ensure random objects' 1-norms are non-zero.
    
    Details:
    - Fixed an innocuous bug that manifested when running the testsuite on
      extremely small matrices with randomization via the "powers of 2 in
      narrow precision range" option enabled. When the randomization
      function emits a perfect 0.0 to fill a 1x1 matrix, the testsuite will
      then compute 0.0/0.0 during the normalization process, which leads to
      NaN residuals. The solution entails smarter implementaions of randv,
      randnv, randm, and randnm, each of which will compute the 1-norm of
      the vector or matrix in question. If the object has a 1-norm of 0.0,
      the object is re-randomized until the 1-norm is not 0.0. Thanks to
      Kiran Varaganti for reporting this issue (#413).
    - Updated the implementation of randm_unb_var1() so that it loops over
      a call to the randv_unb_var1() implementation directly rather than
      calling it indirectly via randv(). This was done to avoid the overhead
      of multiple calls to norm1v() when randomizing the rows/columns of a
      matrix.
    - Updated comments.

commit 35e38fb693e7cbf2f3d7e0505a63b2c05d3f158d
Author: Isuru Fernando <isuruf@gmail.com>
Date:   Tue Jun 16 10:59:41 2020 -0500

    FIx typo in FAQ

commit 1c719c91a3ef0be29a918097652beef35647d4b2
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Jun 4 17:21:08 2020 -0500

    Bugfixes, cleanup of sup dgemm ukernels.
    
    Details:
    - Fixed a few not-really-bugs:
      - Previously, the d6x8m kernels were still prefetching the next upanel
        of A using MR*rs_a instead of ps_a (same for prefetching of next
        upanel of B in d6x8n kernels using NR*cs_b instead of ps_b). Given
        that the upanels might be packed, using ps_a or ps_b is the correct
        way to compute the prefetch address.
      - Fixed an obscure bug in the rd_d6x8m kernel that, by dumb luck,
        executed as intended even though it was based on a faulty pointer
        management. Basically, in the rd_d6x8m kernel, the pointer for B
        (stored in rdx) was loaded only once, outside of the jj loop, and in
        the second iteration its new position was calculated by incrementing
        rdx by the *absolute* offset (four columns), which happened to be the
        same as the relative offset (also four columns) that was needed. It
        worked only because that loop only executed twice. A similar issue
        was fixed in the rd_d6x8n kernels.
    - Various cleanups and additions, including:
      - Factored out the loading of rs_c into rdi in rd_d6x8[mn] kernels so
        that it is loaded only once outside of the loops rather than
        multiple times inside the loops.
      - Changed outer loop in rd kernels so that the jump/comparison and
        loop bounds more closely mimic what you'd see in higher-level source
        code. That is, something like:
          for( i = 0; i < 6; i+=3 )
        rather than something like:
          for( i = 0; i <= 3; i+=3 )
      - Switched row-based IO to use byte offsets instead of byte column
        strides (e.g. via rsi register), which were known to be 8 anyway
        since otherwise that conditional branch wouldn't have executed.
      - Cleaned up and homogenized prefetching a bit.
      - Updated the comments that show the before and after of the
        in-register transpositions.
      - Added comments to column-based IO cases to indicate which columns
        are being accessed/updated.
      - Added rbp register to clobber lists.
      - Removed some dead (commented out) code.
      - Fixed some copy-paste typos in comments in the rv_6x8n kernels.
      - Cleaned up whitespace (including leading ws -> tabs).
      - Moved edge case (non-milli) kernels to their own directory, d6x8,
        and split them into separate files based on the "NR" value of the
        kernels (Mx8, Mx4, Mx2, etc.).
      - Moved config-specific reference Mx1 kernels into their own file
        (e.g. bli_gemmsup_r_haswell_ref_dMx1.c) inside the d6x8 directory.
      - Added rd_dMx1 assembly kernels, which seems marginally faster than
        the corresponding reference kernels.
      - Updated comments in ref_kernels/bli_cntx_ref.c and changed to using
        the row-oriented reference kernels for all storage combos.

commit 943a21def0bedc1732c0a2453afe7c90d7f62e95
Author: Isuru Fernando <isuruf@gmail.com>
Date:   Thu May 21 14:09:21 2020 -0500

    Add build instructions for Windows (#404)

commit fbef422f0d968df10e598668b427af230cfe07e8
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu May 21 10:30:41 2020 -0500

    Separate OS X and Windows into separate FAQs.
    
    Details:
    - Separated the unified Mac OS X / Windows frequently asked question
      into two separate questions, one for each OS.

commit 28be1a4265ea67e3f177c391aba3dbbcf840bd52
Author: Guodong Xu <guodong.xu@linaro.org>
Date:   Thu May 21 02:22:22 2020 +0800

    avoid loading twice in armv8a gemm kernel (#403)
    
    This bug happens at a corner case, when k_iter == 0 and we jump to
    CONSIDERKLEFT.
    
    In current design, first row/col. of a and b are loaded twice.
    
    The fix is to rearrange a and b (first row/col.) loading instructions.
    
    Signed-off-by: Guodong Xu <guodong.xu@linaro.org>

commit d51245e58b0beff2717156b980007c90337150d8
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri May 8 18:00:54 2020 -0500

    Add support for Intel oneAPI in configure.
    
    Details:
    - Properly select cc_vendor based on the output of invoking CC with the
      --version option, including cases where CC is the variant of clang
      that is included with Intel oneAPI. (However, we continue to treat
      the compiler as clang for other purposes, not icc.) Thanks to Ajay
      Panyala and Devin Matthews for reporting on this issue via #402.

commit 787adad73bd5eb65c12c39d732723a1ac0448748
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri May 8 16:18:20 2020 -0500

    Defined netlib equivalent of xerbla_array().
    
    Details:
    - Added a function definition for xerbla_array_(), which largely mirrors
      its netlib implementation. Thanks to Isuru Fernando for suggesting the
      addition of this function.

commit c53b5153bee585685bf95ce22e058a7af72ecef0
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue May 5 12:39:12 2020 -0500

    Documented Perl prerequisite for build system.
    
    Details:
    - Added Perl to list of prerequisites for building BLIS. This is in part
      (and perhaps completely?) due to some substitution commands used at
      the end of configure that include '\n' characters that are not
      properly interpreted by the version of sed included on some versions
      of OS X. This new documentation addresses issue #398.

commit f032d5d4a6ed34c8c3e5ba1ed0b14d1956d0097c
Author: Guodong Xu <guodong.xu@linaro.org>
Date:   Thu Apr 30 01:08:46 2020 +0800

    New kernel set for Arm SVE using assembly (#396)
    
    Here adds two kernels for Arm SVE vector extensions.
    1. a gemm  kernel for double at sizes 8x8.
    2. a packm kernel for double at dimension 8xk.
    
    To achive best performance, variable length agonostic programming
    is not used. Vector length (VL) of 256 bits is mandated in both kernels.
    Kernels to support other VLs can be added later.
    
    "SVE is a vector extension for AArch64 execution mode for the A64
    instruction set of the Armv8 architecture. Unlike other SIMD architectures,
    SVE does not define the size of the vector registers, but constrains into
    a range of possible values, from a minimum of 128 bits up to a maximum of
    2048 in 128-bit wide units. Therefore, any CPU vendor can implement the
    extension by choosing the vector register size that better suits the
    workloads the CPU is targeting. Instructions are provided specifically
    to query an implementation for its register size, to guarantee that
    the applications can run on different implementations of the ISA without
    the need to recompile the code."  [1]
    
    [1] https://developer.arm.com/solutions/hpc/resources/hpc-white-papers/arm-scalable-vector-extensions-and-application-to-machine-learning
    
    Signed-off-by: Guodong Xu <guodong.xu@linaro.org>

commit 4d87eb24e8e1f5a21e04586f6df4f427bae0091b
Author: Yingbo Ma <mayingbo5@gmail.com>
Date:   Mon Apr 27 17:02:47 2020 -0400

    Update KernelsHowTo.md (#395)

commit 477ce91c5281df2bbfaddc4d86312fb8c8f879e2
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Apr 22 14:26:49 2020 -0500

    Moved #include "cpuid.h" to bli_cpuid.c.
    
    Details:
    - Relocated the #include "cpuid.h" directive from bli_cpuid.h to
      bli_cpuid.c. This was done because cpuid.h (which is pulled into
      the post-build blis.h developer header) doesn't protect its
      definitions with a preprocessor guard of the form:
    
        #ifndef FOOBAR_H
        #define FOOBAR_H
        // header contents.
        #endif
    
      and as a result, applications (previously) could not #include both
      blis.h and cpuid.h (since the former was already including the
      latter). Thanks to Bhaskar Nallani for raising this issue via #393
      and to Devin Matthews for suggesting this fix.
    - CREDITS file update.

commit 8bde63ffd7474a97c3a3b0b0dc1eae45be0ab889
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Sat Apr 18 12:50:12 2020 -0500

    Adding missing conjy to her2/syr2 in typed API doc.
    
    Details:
    - Fixed a missing argument (conjy) in the function signatures of
      bli_?her2() and bli_?syr2() in docs/BLISTypedAPI.md. Thanks to Robert
      van de Geijn for reporting this omission.

commit 976902406b610afdbacb2d80a7a2b4b43ff30321
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Apr 17 15:11:10 2020 -0500

    Disable packing by default in expert rntm_t init.
    
    Details:
    - Changed the behavior of bli_rntm_init() as well as the static
      initializer, BLIS_RNTM_INITIALIZER, so that user-initialized rntm_t
      objects by default specify the disabling of packing for A and B.
      Packing of A/B was already disabled by default when calling non-expert
      APIs (and enabled only when the user set environment variables
      BLIS_PACK_A or BLIS_PACK_B). With this commit, the default behavior of
      using user-initialized rntm_t objects with expert APIs comes into line
      with the default behavior of non-expert APIs--that is, they now both
      lead to the avoidance of packing in the sup code path. (Note: The
      conventional code path is unaffected by the environment variables
      BLIS_PACK_A/BLIS_PACK_B and/or the disabling of packing in a rntm_t
      object when calling an expert API.) This addresses issue #392. Thanks
      to Kiran Varaganti for bringing this inconsistency to our attention.
    - The above change was accomplished by changing the the definitions of
      static functions bli_rntm_clear_pack_a() and bli_rntm_clear_pack_b()
      in bli_rntm.h, which are both for internal use only.

commit 5f2aee7c5fa5d562acaf8fbde3df0e2a04e1dd1b
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Apr 7 14:55:15 2020 -0500

    README.md update to promote supmt dgemm.
    
    Details:
    - Updated the sup entry in the "What's New" section of the README.md
      file to promote the multithreaded dgemm sup feature introduced in
      c0558fd.

commit f5923cd9ff5fbd91190277dea8e52027174a1d57
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Apr 7 14:41:45 2020 -0500

    CHANGELOG update (0.7.0)

commit 68b88aca6692c75a9f686187e6c4a4e196ae60a9 (tag: 0.7.0)
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Apr 7 14:41:44 2020 -0500

    Version file update (0.7.0)

commit b04de636c1702e4cb8e7ad82bab3cf43d2dbdfc6
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Apr 7 14:37:43 2020 -0500

    ReleaseNotes.md update in advance of next version.
    
    Details:
    - Updated docs/ReleaseNotes.md in preparation for next version.

commit 2cb604ba472049ad498df72d4a2dc47a161d4c3c
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Apr 6 16:42:14 2020 -0500

    Rename more bli_thread_obarrier(), _obroadcast().
    
    Details:
    - Renamed instances of bli_thread_obarrier() and bli_thread_obroadcast()
      that were made in the supmt-specific code commited to the 'amd'
      branch, which has now been merged with 'master'. Prior to the merge,
      'master' received commit c01d249, which applied these renamings to
      the existing, non-sup codebase.

commit efb12bc895de451067649d5dceb059b7827a025f
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Apr 6 15:01:53 2020 -0500

    Minor updates/elaborations to RELEASING file.

commit 2e3b3782cfb7a2fd0d1a325844983639756def7d
Merge: 9f3a8d4d da0c086f
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Apr 6 14:55:35 2020 -0500

    Merge branch 'master' into amd

commit da0c086f4643772e111318f95a712831b0f981a8
Author: Satish Balay <balay@mcs.anl.gov>
Date:   Tue Mar 31 17:09:41 2020 -0500

    OSX: specify the full path to the location of libblis.dylib (#390)
    
    * OSX: specify the full path to the location of libblis.dylib so that it can be found at runtime
    
    Before this change:
    
    Appication gives runtime error [when linked with blis]
    dyld: Library not loaded: libblis.3.dylib
    
    balay@kpro lib % otool -L libblis.dylib
    libblis.dylib:
            libblis.3.dylib (compatibility version 0.0.0, current version 0.0.0)
            /usr/lib/libSystem.B.dylib (compatibility version 1.0.0, current version 1281.0.0)
    
    After this change:
    balay@kpro lib % otool -L libblis.dylib
    libblis.dylib:
            /Users/balay/petsc/arch-darwin-c-debug/lib/libblis.3.dylib (compatibility version 0.0.0, current version 0.0.0)
            /usr/lib/libSystem.B.dylib (compatibility version 1.0.0, current version 1281.0.0)
    
    * INSTALL_LIBDIR -> libdir as INSTALL_LIBDIR has DESTDIR
    
    Co-Authored-By: Jed Brown <jed@jedbrown.org>
    
    * CREDITS file update.
    
    Co-authored-by: Jed Brown <jed@jedbrown.org>
    Co-authored-by: Field G. Van Zee <field@cs.utexas.edu>

commit 2bca03ea9d87c0da829031a5332545d05e352211
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Sat Mar 28 22:10:00 2020 +0000

    Updates, tweaks to runme.sh in test/1m4m.
    
    Details:
    - Made several updates to test/1m4m/runme.sh, including:
      - Added missing handling for 1m and 4m1a implementations when setting
        the BLIS_??_NT environment variables.
      - Added support for using numactl to run the test executables.
      - Several other cleanups.

commit c40a33190b94af5d5c201be63366594859b1233f
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Mar 26 16:55:00 2020 -0500

    Warn user when auto-detection returns 'generic'.
    
    Details:
    - Added logic to configure that causes the script to output a warning
      to the user if/when "./configure auto" is run and the underlying
      hardware feature detection code is unable to identify the hardware.
      In these cases, the auto-detect code will return 'generic', which
      is likely not what the user expected, and a flag will be set so that
      a message is printed at the end of the configure output. (Thankfully,
      we don't expect this scenario to play out very often.) Thanks to
      Devin Matthews for suggesting this fix #384.

commit 492a736fab5b9c882996ca024b64646877f22a89
Author: Devin Matthews <damatthews@smu.edu>
Date:   Tue Mar 24 17:28:47 2020 -0500

    Fix vectorized version of bli_amaxv (#382)
    
    * Fix vectorized version of bli_amaxv
    
    To match Netlib, i?amax should return:
    - the lowest index among equal values
    - the first NaN if one is encountered
    
    * Fix typos.
    
    * And another one...
    
    * Update ref. amaxv kernel too.
    
    * Re-enabled optimized amaxv kernels.
    
    Details:
    - Re-enabled the optimized, intrinsics-based amaxv kernels in the 'zen'
      kernel set for use in haswell, zen, zen2, knl, and skx subconfigs.
      These two kernels (for s and d datatypes) were temporarily disabled in
      e186d71 as part of issue #380. However, the key missing semantic
      properties that prompted the disabling of these kernels--returning the
      index of the *first* rather than of the last element with largest
      absolute value, and returning the index of the first NaN if one is
      encountered--were added as part of #382 thanks to Devin Matthews.
      Thus, now that the kernels are working as expected once more, this
      commit causes these kernels to once again be registered for the
      affected subconfigs, which effectively reverts all code changes
      included in e186d71.
    - Whitespace/formatting updates to new macros in bli_amaxv_zen_int.c.
    
    Co-authored-by: Field G. Van Zee <field@cs.utexas.edu>

commit e186d7141a51f2d7196c580e24e7b7db8f209db9
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Sat Mar 21 18:40:36 2020 -0500

    Disabled optimized amaxv kernels.
    
    Details:
    - Disabled use of optimized amaxv kernels, which use vector intrinsics
      for both 's' and 'd' datatypes. We disable these kernels because the
      current implementations fail to observe a semantic property of the
      BLAS i?amax_() subroutine, which is to return the index of the
      *first* element containing the maximum absolute value (that is, the
      first element if there exist two or more elements that contain the
      same value). With the optimized kernels disabled, the affected
      subconfigurations (haswell, zen, zen2, knl, and skx) will use the
      default reference implementations. Thanks to Mat Cross for reporting
      this issue via #380.
    - CREDITS file update.

commit 9f3a8d4d851725436b617297231a417aa9ce8c6a
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Sat Mar 14 17:48:43 2020 -0500

    Added missing return to bli_thread_partition_2x2().
    
    Details:
    - Added a missing return statement to the body of an early case handling
      branch in bli_thread_partition_2x2(). This bug only affected cases
      where n_threads < 4, and even then, the code meant to handle cases
      where n_threads >= 4 executes and does the right thing, albeit using
      more CPU cycles than needed. Nonetheless, thanks to Kiran Varaganti
      for reporting this bug via issue #377.
    - Whitespace changes to bli_thread.c (spaces -> tabs).

commit 8c3d9b9eeb6f816ec8c32a944f632a5ad3637593
Merge: 71249fe8 0f9e0399
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Mar 10 14:03:33 2020 -0500

    Merge branch 'amd' of github.com:flame/blis into amd

commit 71249fe8ddaa772616698f1e3814d40e012909ea
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Mar 10 13:55:29 2020 -0500

    Merged test/sup, test/supmt into test/sup.
    
    Details:
    - Updated the Makefile, test_gemm.c, and runme.sh in test/sup to be able
      to compile and run both single-threaded and multithreaded experiments.
      This should help with maintenance going forward.
    - Created a test/sup/octave_st directory of scripts (based on the
      previous test/sup/octave scripts) as well as a test/sup/octave_mt
      directory (based on the previous test/supmt/octave scripts). The
      octave scripts are slightly different and not easily mergeable, and
      thus for now I'll maintain them separately.
    - Preserved the previous test/sup directory as test/sup/old/supst and
      the previous test/supmt directory as test/sup/old/supmt.

commit 0f9e0399e16e96da2620faf2c0c3c21274bb2ebd
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Mar 5 17:03:21 2020 -0600

    Updated sup performance graphs; added mt results.
    
    Details:
    - Reran all existing single-threaded performance experiments comparing
      BLIS sup to other implementations (including the conventional code
      path within BLIS), using the latest versions (where appropriate).
    - Added multithreaded results for the three existing hardware types
      showcased in docs/PerformanceSmall.md: Kaby Lake, Haswell, and Epyc
      (Zen1).
    - Various minor updates to the text in docs/PerformanceSmall.md.
    - Updates to the octave scripts in test/sup/octave, test/supmt/octave.

commit 90db88e5729732628c1f3acc96eeefab49f2da41
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Mar 2 15:06:48 2020 -0600

    Updated sup[mt] Makefiles for variable dim ranges.
    
    Details:
    - Updated test/sup/Makefile and test/supmt/Makefile to allow specifying
      different problem size ranges for the drivers where one, two, or three
      matrix dimensions is large. This will facilitate the generation of
      more meaningful graphs, particularly when two dimensions are tiny.

commit 31f11a06ea9501724feec0d2fc5e4644d7dd34fc
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Feb 27 14:33:20 2020 -0600

    Updates to octave scripts in test/sup[mt]/octave.
    
    Details:
    - Optimized scripts in test/sup/octave and test/supmt/octave for use
      with octave 5.2.0 on Ubuntu 18.04.
    - Fixed stray 'end' keywords in gen_opsupnames.m and plot_l3sup_perf.m,
      which were not only unnecessary but also causing issues with versions
      5.x.

commit c01d249d7c546fe2e3cee3fe071cd4c4c88b9115
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Feb 25 14:50:53 2020 -0600

    Renamed bli_thread_obarrier(), _obroadcast().
    
    Details:
    - Renamed two bli_thread_*() APIs:
        bli_thread_obarrier()   -> bli_thread_barrier()
        bli_thread_obroadcast() -> bli_thread_broadcast()
      The 'o' was a leftover from when thrcomm_t objects tracked both
      "inner" and "outer" communicators. They have long since been
      simplified to only support the latter, and thus the 'o' is
      superfluous.

commit f6e6bf73e695226c8b23fe7900da0e0ef37030c1
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Feb 24 17:52:23 2020 -0600

    List Gentoo under supported external packages.
    
    Details:
    - Add mention of Gentoo Linux under the list of external packages in
      the README.md file. Thanks to M. Zhou for maintaining this package.

commit 9e5f7296ccf9b3f7b7041fe1df20b927cd0e914b
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Feb 18 15:16:03 2020 -0600

    Skip building thrinfo_t tree when mt is disabled.
    
    Details:
    - Return early from bli_thrinfo_sup_grow() if the thrinfo_t object
      address is equal to either &BLIS_GEMM_SINGLE_THREADED or
      &BLIS_PACKM_SINGLE_THREADED.
    - Added preprocessor logic to bli_l3_sup_thread_decorator() in
      bli_l3_sup_decor_single.c that (by default) disables code that
      creates and frees the thrinfo_t tree and instead passes
      &BLIS_GEMM_SINGLE_THREADED as the thrinfo_t pointer into the
      sup implementation.
    - The net effect of the above changes is that a small amount of
      thrinfo_t overhead is avoided when running small/skinny dgemm
      problems when BLIS is compiled with multithreading disabled.

commit 90081e6a64b5ccea9211bdef193c2d332c68492f
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Feb 17 14:57:25 2020 -0600

    Fixed bug(s) in mt sup when single-threaded.
    
    Details:
    - Fixed a syntax bug in bli_l3_sup_decor_single.c as a result of
      changing function interface for the thread entry point function
      (of type l3supint_t).
    - Unfortunately, fixing the interface was not enough, as it caused
      a memory leak in the sba at bli_finalize() time. It turns out that,
      due to the new multithreading-capable variant code useing thrinfo_t
      objects--specifically, their calling of bli_thrinfo_grow()--we
      have to pass in a real thrinfo_t object rather than the global
      objects &BLIS_PACKM_SINGLE_THREADED or &BLIS_GEMM_SINGLE_THREADED.
      Thus, I inserted the appropriate logic from the OpenMP and pthreads
      versions so that single-threaded execution would work as intended
      with the newly upgraded variants.

commit c0558fde4511557c8f08867b035ee57dd2669dc6
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Feb 17 14:08:08 2020 -0600

    Support multithreading within the sup framework.
    
    Details:
    - Added multithreading support to the sup framework (via either OpenMP
      or pthreads). Both variants 1n and 2m now have the appropriate
      threading infrastructure, including data partitioning logic, to
      parallelize computation. This support handles all four combinations
      of packing on matrices A and B (neither, A only, B only, or both).
      This implementation tries to be a little smarter when automatic
      threading is requested (e.g. via BLIS_NUM_THREADS) in that it will
      recalculate the factorization in units of micropanels (rather than
      using the raw dimensions) in bli_l3_sup_int.c, when the final
      problem shape is known and after threads have already been spawned.
    - Implemented bli_?packm_sup_var2(), which packs to conventional row-
      or column-stored matrices. (This is used for the rrc and crc storage
      cases.) Previously, copym was used, but that would no longer suffice
      because it could not be parallelized.
    - Minor reorganization of packing-related sup functions. Specifically,
      bli_packm_sup_init_mem_[ab]() are called from within packm_sup_[ab]()
      instead of from the variant functions. This has the effect of making
      the variant functions more readable.
    - Added additional bli_thrinfo_set_*() static functions to bli_thrinfo.h
      and inserted usage of these functions within bli_thrinfo_init(), which
      previously was accessing thrinfo_t fields via the -> operator.
    - Renamed bli_partition_2x2() to bli_thread_partition_2x2().
    - Added an auto_factor field to the rntm_t struct in order to track
      whether automatic thread factorization was originally requested.
    - Added new test drivers in test/supmt that perform multithreaded sup
      tests, as well as appropriate octave/matlab scripts to plot the
      resulting output files.
    - Added additional language to docs/Multithreading.md to make it clear
      that specifying any BLIS_*_NT variable, even if it is set to 1, will
      be considered manual specification for the purposes of determining
      whether to auto-factorize via BLIS_NUM_THREADS.
    - Minor comment updates.

commit d7a7679182d72a7eaecef4cd9b9a103ee0a7b42b
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Feb 7 17:37:03 2020 -0600

    Fixed int-to-packbuf_t conversion error (C++ only).
    
    Details:
    - Fixed an error that manifests only when using C++ (specifically,
      modern versions of g++) to compile drivers in 'test' (and likely most
      other application code that #includes blis.h. Thanks to Ajay Panyala
      for reporting this issue (#374).

commit d626112b8d5302f9585fb37a8e37849747a2a317
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Jan 15 13:27:02 2020 -0600

    Removed sorting on LDFLAGS in common.mk (#373).
    
    Details:
    - Removed a line of code in common.mk that passed LDFLAGS through the
      sort function. The purpose was not to sort the contents, but rather
      to remove duplicates. However, there is valid syntax in a string of
      linker flags that, when sorted, yields different/broken behavior.
      So I've removed the line in common.mk that sorts LDFLAGS. Also, for
      future use, I've added a new function, rm-dupls, that removes
      duplicates without sorting. (This function was based on code from a
      stackoverflow thread that is linked to in the comments for that
      code.) Thanks to Isuru Fernando for reporting this issue (#373).

commit e67deb22aaeab5ed6794364520190936748ef272
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Jan 14 16:01:34 2020 -0600

    CHANGELOG update (0.6.1)

commit 10949f528c5ffc5c3a2cad47fe16a802afb021be (tag: 0.6.1)
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Jan 14 16:01:33 2020 -0600

    Version file update (0.6.1)

commit 5db8e710a2baff121cba9c63b61ca254a2ec097a
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Jan 14 15:59:59 2020 -0600

    ReleaseNotes.md update in advance of next version.
    
    Details:
    - Updated ReleaseNotes.md in preparation for next version.

commit cde4d9d7a26eb51dcc5a59943361dfb8fda45dea
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Jan 14 15:19:25 2020 -0600

    Removed 'attic/windows' (to prevent confusion).
    
    Details:
    - Finally removed 'attic/windows' and its contents. This directory once
      contained "proto" Windows support for BLIS, but we've since moved on
      to (thanks to Isuru Fernando) providing Windows DLL support via
      AppVeyor's build artifacts. Furthermore, since 'windows' was the only
      subdirectory within 'attic', the directory path would show up in
      GitHub's listing at https://github.com/flame/blis, which probably led
      to someone being confused about how BLIS provides Windows support. I
      assume (but don't know for sure) that nobody is using these files, so
      this is admittedly a case of shoot first and ask questions later.

commit 7d3407d4681c6449f4bbb8ec681983700ab968f3
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Jan 14 15:17:53 2020 -0600

    CREDITS file update.

commit f391b3e2e7d11a37300d4c8d3f6a584022a599f5
Author: Dave Love <dave.love@manchester.ac.uk>
Date:   Mon Jan 6 20:15:48 2020 +0000

    Fix parsing in vpu_count on workstation SKX (#351)
    
    * Fix parsing in vpu_count on workstation SKX
    
    * Document Skylake-X as Haswell for single FMA
    
    * Update vpu_count for Skylake and Cascade Lake models
    
    * Support printing the configuration selected, controlled by the environment
    
    Intended particularly for diagnosing mis-selection of SKX through
    unknown, or incorrect, number of VPUs.
    
    * Move bli_log outside the cpp condition, and use it where intended
    
    * Add Fixme comment (Skylake D)
    
    * Mostly superficial edits to commits towards #351.
    
    Details:
    - Moved architecture/sub-config logging-related code from bli_cpuid.c
      to bli_arch.c, tweaked names, and added more set/get layering.
    - Tweaked log messages output from bli_cpuid_is_skx() in bli_cpuid.c.
    - Content, whitespace changes to new bullet in HardwareSupport.md that
      relates to single-VPU Skylake-Xs.
    
    * Fix comment typos
    
    Co-authored-by: Field G. Van Zee <field@cs.utexas.edu>

commit 5ca1a3cfc1c1cc4dd9da6a67aa072ed90f07e867
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Jan 6 12:29:12 2020 -0600

    Fixed 'configure' breakage introduced in 6433831.
    
    Details:
    - Added a missing 'fi' (endif) keyword to a conditional block added in
      the configure script in commit 6433831.

commit e7431b4a834ef4f165c143f288585ce8e2272a23
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Jan 6 12:01:41 2020 -0600

    Updated 1m draft article link in README.md.

commit 6433831cc3988ad205637ebdebcd6d8f7cfcf148
Author: Jeff Hammond <jeff.r.hammond@intel.com>
Date:   Fri Jan 3 17:52:49 2020 -0800

    blacklist ICC 18 for knl/skx due to test failures
    
    Signed-off-by: Jeff Hammond <jeff.r.hammond@intel.com>

commit af3589f1f98781e3a94a8f9cea8d5ea6f155f7d2
Author: Jeff Hammond <jeff.science@gmail.com>
Date:   Fri Jan 3 13:23:24 2020 -0800

    blacklist Intel 19+
    
    Signed-off-by: Jeff Hammond <jeff.r.hammond@intel.com>

commit 60de939debafb233e57fd4e804ef21b6de198caf
Author: Jeff Hammond <jeff.science@gmail.com>
Date:   Wed Jan 1 21:30:38 2020 -0800

    fix link to docs
    
    the comment contains an incorrect link, which is trivially fixed here.
    
    @fgvanzee I hope you don't mind that I committed directly to master but this cannot break anything.

commit 52711073789b6b84eb99bb0d6883f457ed3fcf80
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Dec 16 16:30:26 2019 -0600

    Fixed bugs in cblas_sdsdot(), sdsdot_().
    
    Details:
    - Fixed a bug in sdsdot_sub() that redundantly added the "alpha" scalar,
      named 'sb'. This value was already being added by the underlying
      sdsdot_() function. Thus, we no longer add 'sb' within sdsdot_sub().
      Thanks to Simon Lukas Märtens for reporting this bug via #367.
    - Fixed a second bug in order of typecasting intermediate products in
      sdsdot_(). Previously, the "alpha" scalar was being added after the
      "outer" typecast to float. However, the operation is supposed to first
      add the dot product to the (promoted) scalar and THEN downcast the sum
      to float. Thanks to Devin Matthews for catching this bug.

commit fe2560a4b1d8ef8d0a446df6002b1e7decc826e9
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Dec 6 17:12:44 2019 -0600

    Annoted missing thread-related symbols for export.
    
    Details:
    - Added BLIS_EXPORT_BLIS annotation to function prototypes for
    
        bli_thrcomm_bcast()
        bli_thrcomm_barrier()
        bli_thread_range_sub()
    
      so that these functions are exported to shared libraries by default.
      This (hopefully) fixes issue #366. Thanks to Kyungmin Lee for
      reporting this bug.
    - CREDITS file update.

commit 2853825234001af8f175ad47cef5d6ff9b7a5982
Merge: efa61a6c 61b1f0b0
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Dec 6 16:06:46 2019 -0600

    Merge branch 'master' into amd

commit 61b1f0b0602faa978d9912fe58c6c952a33af0ac
Author: Nicholai Tukanov <nicholai@utexas.edu>
Date:   Wed Dec 4 14:18:47 2019 -0600

    Add prototypes for POWER9 reference kernels (#365)
    
    Updates and fixes to power9 subconfig.
    
    Details:
    - Register s,c,z reference gemm and trsm ukernels that assume elements
      of B have been broadcast.
    - Added prototypes for level-3 ukernels that assume elements of B have
      been broadcast. Also added prototype for an spackm function that
      employs a duplication/broadcast factor of 4.
    - Register virtual gemmtrsm ukernels that work with broadcasting of B.
    - Disable right-side hemm, symm, trmm, and trmm3 in bli_family_power9.h.
    - Thanks to Nicholai Tukanov for providing these updates.

commit efa61a6c8b1cfa48781fc2e4799ff32e1b7f8f77
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Nov 29 16:17:04 2019 -0600

    Added missing bli_l3_sup_thread_decorator() symbol.
    
    Details:
    - Defined dummy versions of bli_l3_sup_thread_decorator() for Openmp
      and pthreads so that those builds don't fail when performing shared
      library linking (especially for Windows DLLs via AppVeyor). For now,
      these dummy implementations of bli_l3_sup_thread_decorator() are
      merely carbon-copies of the implementation provided for single-
      threaded execution (ie: the one found in bli_l3_sup_decor_single.c).
      Thus, an OpenMP or pthreads build will be able to use the gemmsup
      code (including the new selective packing functionality), as it did
      before 39fa7136, even though it will not actually employ any
      multithreaded parallelism.

commit 39fa7136f4a4e55ccd9796fb79ad5f121b872ad9
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Nov 29 15:27:07 2019 -0600

    Added support for selective packing to gemmsup.
    
    Details:
    - Implemented optional packing for A or B (or both) within the sup
      framework (which currently only supports gemm). The request for
      packing either matrix A or matrix B can be made via setting
      environment variables BLIS_PACK_A or BLIS_PACK_B (to any
      non-zero value; if set, zero means "disable packing"). It can also
      be made globally at runtime via bli_pack_set_pack_a() and
      bli_pack_set_pack_b() or with individual rntm_t objects via
      bli_rntm_set_pack_a() and bli_rntm_set_pack_b() if using the expert
      interface of either the BLIS typed or object APIs. (If using the
      BLAS API, environment variables are the only way to communicate the
      packing request.)
    - One caveat (for now) with the current implementation of selective
      packing is that any blocksize extension registered in the _cntx_init
      function (such as is currently used by haswell and zen subconfigs)
      will be ignored if the affected matrix is packed. The reason is
      simply that I didn't get around to implementing the necessary logic
      to pack a larger edge-case micropanel, though this is entirely
      possible and should be done in the future.
    - Spun off the variant-choosing portion of bli_gemmsup_ref() into
      bli_gemmsup_int(), in bli_l3_sup_int.c.
    - Added new files, bli_l3_sup_packm_a.c, bli_l3_sup_packm_b.c, along
      with corresponding headers, in which higher-level packm-related
      functions are defined for use within the sup framework. The actual
      packm variant code resides in bli_l3_sup_packm_var.c.
    - Pass the following new parameters into var1n and var2m: packa, packb
      bool_t's, pointer to a rntm_t, pointer to a cntl_t (which is for now
      always NULL), and pointer to a thrinfo_t* (which for nowis the address
      of the global single-threaded packm thread control node).
    - Added panel strides ps_a and ps_b to the auxinfo_t structure so that
      the millikernel can query the panel stride of the packed matrix and
      step through it accordingly. If the matrix isn't packed, the panel
      stride of interest for the given millikernel will be set to the
      appropriate value so that the mkernel may step through the unpacked
      matrix as it normally would.
    - Modified the rv_6x8m and rv_6x8n millikernels to read the appropriate
      panel strides (ps_a and ps_b, respectively) instead of computing them
      on the fly.
    - Spun off the environment variable getting and setting functions into
      a new file, bli_env.c (with a corresponding prototype header). These
      functions are now used by the threading infrastructure (e.g.
      BLIS_NUM_THREADS, BLIS_JC_NT, etc.) as well as the selective packing
      infrastructure (e.g. BLIS_PACK_A, BLIS_PACK_B).
    - Added a static initializer for mem_t objects, BLIS_MEM_INITIALIZER.
    - Added a static initializer for pblk_t objects, BLIS_PBLK_INITIALIZER,
      for use within the definition of BLIS_MEM_INITIALIZER.
    - Moved the global_rntm object to bli_rntm.c and extern it where needed.
      This means that the function bli_thread_init_rntm() was renamed to
      bli_rntm_init_from_global() and relocated accordingly.
    - Added a new bli_pack.c function, which serves as the home for
      functions that manage the pack_a and pack_b fields of the global
      rntm_t, including from environment variables, just as we have
      functions to manage the threading fields of the global rntm_t in
      bli_thread.c.
    - Reorganized naming for files in frame/thread, which mostly involved
      spinning off the bli_l3_thread_decorator() functions into their own
      files. This change makes more sense when considering the further
      addition of bli_l3_sup_thread_decorator() functions (for now limited
      only to the single-threaded form found in the  _single.c file).
    - Explicitly initialize the reference sup handlers in both
      bli_cntx_init_haswell.c and bli_cntx_init_zen.c so that it's more
      obvious how to customize to a different handler, if desired.
    - Removed various snippets of disabled code.
    - Various comment updates.

commit bbb21fd0a9be8c5644bec37c75f9396eeeb69e48
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Nov 21 18:15:16 2019 -0600

    Tweaked SIAM/SC Best Prize language in README.md.

commit 043366f92d5f5f651d5e3371ac3adb36baf4adce
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Nov 21 18:13:51 2019 -0600

    Fixed typo in previous commit (SIAM/SC prize).

commit 05a4d583e65a46ff2a1100ab4433975d905d91f9
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Nov 21 18:12:24 2019 -0600

    Added SIAM/SC prize to "What's New" in README.md.

commit 881b05ecd40c7bc0422d3479a02a28b1cb48383f
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Nov 21 16:34:27 2019 -0600

    Fixed blastest failure for 'generic' subconfig.
    
    Details:
    - Fixed a subtle and complicated bug that only manifested via the BLAS
      test drivers in the generic subconfiguration, and possibly any other
      subconfiguration that did not register complex-domain gemm ukernels,
      or registered ONLY real-domain ukernels as row-preferential. This is
      a long story, but it boils down to an exception to the "transpose the
      operation to bring storage of C into agreement with ukernel pref"
      optimization in bli_hemm_front.c and bli_symm_front.c sabotaging the
      proper functioning of the 1m method, but only when the imaginary
      component of beta is zero. See the comments in issue #342 for more
      details. Thanks to Dave Love for identifying the commit in which this
      bug was introduced, and other feedback related to this bug.

commit 0c7165fb01cdebbc31ec00124d446161b289942f
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Nov 14 16:48:14 2019 -0600

    Fixed obscure bug in bli_acquire_mpart_[mn]dim().
    
    Details:
    - Fixed a bug in bli_acquire_mpart_mdim(), bli_acquire_mpart_ndim(),
      and bli_acquire_mpart_mndim() that allowed the use of a blocksize b
      that is too large given the current row/column index (i.e., the i/j
      argument) and the size of the dimension being partitioned (i.e., the
      m/n argument). This bug only affected backwards partitioning/motion
      through the dimension and was the result of a misplaced conditional
      check-and-redirect to the backwards code path. It should be noted
      that this bug was discovered not because it manifested the way it
      could (thanks to the callers in BLIS making sure to always pass in
      the "correct" blocksize b), but could have manifested if the
      functions were used by 3rd party callers. Thanks to Minh Quan Ho for
      reporting the bug via issue #363.

commit fb8bef9982171ee0f60bc39e41a33c4d31fd59a9
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Nov 14 13:05:28 2019 -0600

    Fixed copy-paste bug in bli_spackm_6xk_bb4_ref().
    
    Details:
    - Fixed a copy-paste bug in the new bli_spackm_6xk_bb4_ref() that
      manifested as failures in single-precision real level-3 operations.
      Also replaced the duplication factor constants with a const-qualifed
      varialbe, dfac, so that this won't happen again.
    - Changed NC for single-precision real from 4080 to 8160 so that the
      packed matrix B will have the same byte footprint in both single
      and double real.

commit 8f399c89403d5824ba767df1426706cf2d19d0a7
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Nov 12 15:32:57 2019 -0600

    Tweaked/added notes to docs/Multithreading.md.
    
    Details:
    - Added language to docs/Multithreading.md cautioning the reader about
      the nuances of setting multithreading parameters via the manual and
      automatic ways simultaneously, and also about how these parameters
      behave when multithreading is disabled at configure-time. These
      changes are an attempt to address the issues that arose in issue #362.
      Thanks to Jérémie du Boisberranger for his feedback on this topic.
    - CREDITS file update.

commit bdc7ee3394500d8e5b626af6ff37c048398bb27e
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Nov 11 15:47:17 2019 -0600

    Various fixes to support packing duplication in B.
    
    Details:
    - Added cpp macros to trmm and trmm3 front-ends to optionally force
      those operations to be cast so the structured matrix is on the left.
      symm and hemm already had such macros, but these too were renamed so
      that the macros were individual to the operation. We now have four
      such macros:
        #define BLIS_DISABLE_HEMM_RIGHT
        #define BLIS_DISABLE_SYMM_RIGHT
        #define BLIS_DISABLE_TRMM_RIGHT
        #define BLIS_DISABLE_TRMM3_RIGHT
      Also, updated the comments in the symm and hemm front-ends related to
      the first two macro guards, and added corresponding comments to the
      trmm and trmm3 front-ends for the latter two guards. (They all
      functionally do the same thing, just for their specific operations.)
      Thanks to Jeff Hammond for reporting the bugs that led me to this
      change (via #359).
    - Updated config/old/haswellbb subconfiguration (used to debug issues
      related to duplicating B during packing) to register: a packing
      kernel for single-precision real; gemmbb ukernels for s, c, and z;
      trsmbb ukernels for s, c, and z; gemmtrsmbb virtual ukrnels for s, c
      and z; and to use non-default cache and register blocksizes for s, c,
      and z datatypes. Also declared prototypes for all of the gemmbb,
      trsmbb, and gemmtrsmbb ukernel functions within the
      bli_cntx_init_haswellbb() function. This should, once applied to the
      power9 configuration, fix the remaining issues in #359.
    - Defined bli_spackm_6xk_bb4_ref(), which packs single reals with a
      duplication factor of 4. This function is defined in the same file as
      bli_dpackm_6xk_bb2_ref() (bli_packm_cxk_bb_ref.c).

commit 0eb79ca8503bd7b237994335b9687457227d3290
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Nov 8 14:48:48 2019 -0600

    Avoid unused variable warning in lread.c (#356).
    
    Details:
    - Replaced the line
    
        f = f;
    
      with
    
        ( void )f;
    
      for the unused variable 'f' in blastest/f2c/lread.c. (Hopefully)
      addresses issue #356, but since we don't use xlc who knows. Thanks
      to Jeff Hammond for reporting this.

commit f377bb448512f0b578263387eed7eaf8f2b72bb7
Author: Jérôme Duval <jerome.duval@gmail.com>
Date:   Thu Nov 7 23:39:29 2019 +0100

    Add Haiku to the known OS list (#361)

commit e29b1f9706b6d9ed798b7f6325f275df4e6be973
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Nov 5 17:15:19 2019 -0600

    Fixed failing testsuite gemmtrsm_ukr for power9.
    
    Details:
    - Added code that fixes false failures in the gemmtrsm_ukr module of the
      testsuite. The tests were failing because the computation (bli_gemv())
      that performs the numerical check was not able to properly travserse
      the matrix operands bx1 and b11 that are views into the micropanel of
      B, which has duplicated/broadcast elements under the power9 subconfig.
      (For example, a micropanel of B with duplication factor of 2 needs to
      use a column stride of 2; previously, the column stride was being
      interpreted as 1.)
    - Defined separate bli_obj_set_row_stride() and bli_obj_set_col_stride()
      static functions in bli_obj_macro_defs.h. (Previously, only the
      function bli_obj_set_strides() was defined. Amazing to think that we
      got this far without these former functions.)
    - Updated/expounded upon comments.

commit 49177a6b9afcccca5b39a21c6fd8e243525e1505
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Nov 4 18:09:37 2019 -0600

    Fixed latent testsuite ukr module bugs for power9.
    
    Details:
    - Fixed a latent bug in the testsuite ukernel modules (gemm, trsm, and
      gemmtrsm) that only manifested once we began running with parameters
      that mimic those of power9. The problem was rooted in the way those
      modules were creating objects (and thus allocating memory) for the
      micropanel operands to the microkernel being tested. Since power9
      duplicates/broadcasts elements of B in memory, we needed an easy way
      of asking for more than one storage element per logical element in
      the matrix. I incorrectly expressed this as:
    
        bli_obj_create( datatype, k, n, ldbp, 1, &bp );
    
      The problem here is that bli_obj_create() is exceedingly efficient
      at calculating the size it passes to malloc() and doesn't allocate a
      full leading dimension's worth of elements for the last column (or
      row, in this example). This would normally not bother anyone since
      you're not supposed to access that memory anyway. But here, my
      attempted "hack" for getting extra elements was insufficient, and
      needed to be changed to:
    
        bli_obj_create( datatype, k, ldbp, ldbp, 1, &bp );
    
      That is, the extra elements needed to be baked into the dimensions of
      the matrix object in order to have the intended effect on the number
      of elements actually allocated. Thanks to Jeff Hammond for reporting
      this bug.
    - Fixed a typically harmless memory leak in the aforementioned test
      modules (the objects for the packed micropanels were not being freed).
    - Updated/expanded a common comment across all three ukr test modules.

commit c84391314d4f1b3f73d868f72105324e649f2a72
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Nov 4 13:57:12 2019 -0600

    Reverted minor temp/wspace changes from b426f9e.
    
    Details:
    - Added missing license header to bli_pwr9_asm_macros_12x6.h.
    - Reverted temporary changes to various files in 'test' and 'testsuite'
      directories.
    - Moved testsuite/jobscripts into testsuite/old.
    - Minor whitespace/comment changes across various files.

commit 4870260f6b8c06d2cc01b7147d7433ddee213f7f
Author: Jeff Hammond <jeff.r.hammond@intel.com>
Date:   Mon Nov 4 11:55:47 2019 -0800

    blacklist GCC 5 and older for POWER9 (#360)

commit b426f9e04e5499c6f9c752e49c33800bfaadda4c
Author: Nicholai Tukanov <nicholai@utexas.edu>
Date:   Fri Nov 1 17:57:03 2019 -0500

    POWER9 DGEMM  (#355)
    
    Implemented and registered power9 dgemm ukernel.
    
    Details:
    - Implemented 12x6 dgemm microkernel for power9. This microkernel
      assumes that elements of B have been duplicated/broadcast during the
      packing step. The microkernel uses a column orientation for its
      microtile vector registers and thus implements column storage and
      general stride IO cases. (A row storage IO case via in-register
      transposition may be added at a future date.) It should be noted that
      we recommend using this microkernel with gcc and *not* xlc, as issues
      with the latter cropped up during development, including but not
      limited to slightly incompatible vector register mnemonics in the GNU
      extended inline assembly clobber list.

commit 58102aeaa282dc79554ed045e1b17a6eda292e15
Merge: 52059506 b9bc222b
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Oct 28 17:58:31 2019 -0500

    Merge branch 'amd'

commit 52059506b2d5fd4c3738165195abeb356a134bd4
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Oct 23 15:26:42 2019 -0500

    Added "How to Download BLIS" section to README.md.
    
    Details:
    - Added a new section to the README.md, just prior to the "Getting
      Started" section, titled "How to Download BLIS". This section details
      the user's options for obtaining BLIS and lays out four common ways
      of downloading the library. Thanks to Jeff Diamond for his feedback
      on this topic.

commit e6f0a96cc59aef728470f6850947ba856148c38a
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Oct 14 17:05:39 2019 -0500

    Updated README.md to ack Facebook as funder.

commit b9bc222bfc3db4f9ae5d7b3321346eed70c2c3fb
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Oct 14 16:38:15 2019 -0500

    Call bli_syrk_small() before error checking.
    
    Details:
    - In bli_syrk_front(), moved the conditional call to bli_syrk_check()
      (if error checking is enabled) and the conditional scaling of C by
      beta (if alpha is zero) so that they occur after, instead of before,
      the call to bli_syrk_small(). This sequencing now matches that of
      bli_gemm_small() in bli_gemm_front() and bli_trsm_small() in
      bli_trsm_front().

commit f0959a81dbcf30d8a1076d0a6348a9835079d31a
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Oct 14 15:46:28 2019 -0500

    When manual config is blacklisted, output error.
    
    Details:
    - Fixed and adjusted the logic in configure so that a more informative
      error message is output when a user runs './configure ... <conf>' and
      <conf> is present in the configuration blacklist. Previously, this
      particular set of conditions would result in the message:
    
        'user-specified configuration '' is NOT registered!
    
      That is, the error message mis-identified the targeted configuration
      as the empty string, and (more importantly) mis-identifies the
      problem. Thanks to Tze Meng Low for reporting this issue.
    - Fixed a nearby error messages somewhat unrelated to the issue above.
      Specifically, the wrong string was being printed when the error
      message was identifying an auto-detected configuration that did not
      appear to be registered.

commit 6218ac95a525eefa8921baf8d0d7057dfacebe9c
Merge: 0016d541 a617301f
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Oct 11 11:53:51 2019 -0500

    Merge branch 'master' into amd

commit 0016d541e6b0da617b1fae6612d2b314901b7a75
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Oct 11 11:09:44 2019 -0500

    Changed -march=znver2 to =znver1 for clang on zen2.
    
    Details:
    - In config/zen2/make_defs.mk, changed the -march= flag so that
      -march=znver1 is used instead of -march=znver2 when CC_VENDOR is
      clang. (The gcc branch attempts to differentiate between various
      versions, but the equivalent version cutoffs for clang are not
      yet known by us, so we have to use a single flag for all versions
      of clang. Hopefully -march=znver1 is new enough. If not, we'll
      fall back to -march=bdver4 -mno-fma4 -mno-tbm -mno-xop -mno-lwp.)
      This issue was discovered thanks to AppVeyor.

commit e94a0530e5ac4c78a18f09105f40003be2b517f7
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Oct 11 10:48:27 2019 -0500

    Corrected zen NC that was non-multiple of NR.
    
    Details:
    - Updated an incorrectly set cache blocksize NC for single real within
      config/zen/bli_cntx_init_zen.c that was non a multiple of the
      corresponding value of NR. This issue, which was caught by Travis CI,
      was introduced in 29b0e1e.

commit a2ffac752076bf55eb8c1fe2c5da8d9104f1f85b
Merge: 1cfe8e25 29b0e1ef
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Oct 11 10:31:18 2019 -0500

    Merge branch 'amd-master' into amd

commit 29b0e1ef4e8b84ce76888d73c090009b361f1306
Merge: 1cfe8e25 fdce1a56
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Oct 11 10:24:24 2019 -0500

    Code review + tweaks to AMD's AOCL 2.0 PR (#349).
    
    Details:
    - NOTE: This is a merge commit of 'master' of git://github.com/amd/blis
      into 'amd-master' of flame/blis.
    - Fixed a bug in the downstream value of BLIS_NUM_ARCHS, which was
      inadvertantly not incremented when the Zen2 subconfiguration was
      added.
    - In bli_gemm_front(), added a missing conditional constraint around the
      call to bli_gemm_small() that ensures that the computation precision
      of C matches the storage precision of C.
    - In bli_syrk_front(), reorganized and relocated the notrans/trans logic
      that existed around the call to bli_syrk_small() into bli_syrk_small()
      to minimize the calling code footprint and also to bring that code
      into stylistic harmony with similar code in bli_gemm_front() and
      bli_trsm_front(). Also, replaced direct accessing of obj_t fields with
      proper accessor static functions (e.g. 'a->dim[0]' becomes
      'bli_obj_length( a )').
    - Added #ifdef BLIS_ENABLE_SMALL_MATRIX guard around prototypes for
      bli_gemm_small(), bli_syrk_small(), and bli_trsm_small(). This is
      strictly speaking unnecessary, but it serves as a useful visual cue to
      those who may be reading the files.
    - Removed cpp macro-protected small matrix debugging code from
      bli_trsm_front.c.
    - Added a GCC_OT_9_1_0 variable to build/config.mk.in to facilitate gcc
      version check for availability of -march=znver2, and added appropriate
      support to configure script.
    - Cleanups to compiler flags common to recent AMD microarchitectures in
      config/zen/amd_config.mk, including: removal of -march=znver1 et al.
      from CKVECFLAGS (since the -march flag is added within make_defs.mk);
      setting CRVECFLAGS similarly to CKVECFLAGS.
    - Cleanups to config/zen/bli_cntx_init_zen.c.
    - Cleanups, added comments to config/zen/make_defs.mk.
    - Cleanups to config/zen2/make_defs.mk, including making use of newly-
      added GCC_OT_9_1_0 and existing GCC_OT_6_1_0 to choose the correct
      set of compiler flags based on the version of gcc being used.
    - Reverted downstream changes to test/test_gemm.c.
    - Various whitespace/comment changes.

commit a617301f9365ac720ff286514105d1b78951368b
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Oct 8 17:14:05 2019 -0500

    Updates to docs/CodingConventions.md.

commit 171f10069199f0cd280f18aac184546bd877c4fe
Merge: 702486b1 05d58edf
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Oct 4 11:18:23 2019 -0500

    Merge remote-tracking branch 'loveshack/emacs'

commit 702486b12560b5c696ba06de9a73fc0d5107ca44
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Oct 2 16:35:41 2019 -0500

    Removed stray FAQ section introduced in 1907000.

commit 1907000ad6ea396970c010f07ae42980b7b14fa0
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Oct 2 16:31:54 2019 -0500

    Updated to FAQ (AMD-related questions).
    
    Details:
    - Added a couple potential frequently-asked questions/answers releated
      to AMD's fork of BLIS.
    - Updated existing answers to other questions.

commit 834f30a0dad808931c9d80bd5831b636ed0e1098
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Oct 2 12:45:56 2019 -0500

    Mention mixeddt paper in docs/MixedDatatypes.md.

commit 05d58edfe0ea9279971d74f17a5f7a69c4672ed5
Author: Dave Love <dave.love@manchester.ac.uk>
Date:   Wed Oct 2 10:33:44 2019 +0100

    Note .dir-locals.el in docs

commit 531110c339f199a4d165d707c988d89ab4f5bfe8
Author: Dave Love <dave.love@manchester.ac.uk>
Date:   Wed Oct 2 10:16:22 2019 +0100

    Modify Emacs config
    Confine it to cc-mode and add comment-start/end.

commit 4bab365cab98202259c70feba6ec87408cba28d8
Author: Dave Love <dave.love@manchester.ac.uk>
Date:   Tue Oct 1 19:22:47 2019 +0000

    Add .dir-locals.el for Emacs (#348)
    
    A minimal version that could probably do with extending, but at least
    gets the indentation roughly right.

commit 4ec8dad66b3d37b0a2b47d19b7144bb62d332622
Author: Dave Love <dave.love@manchester.ac.uk>
Date:   Thu Sep 26 16:27:53 2019 +0100

    Add .dir-locals.el for Emacs
    
    A minimal version that could probably do with extending, but at least
    gets the indentation roughly right.

commit bc16ec7d1e2a30ce4a751255b70c9cbe87409e4f
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Sep 23 15:37:33 2019 -0500

    Set execute bits of shared library at install-time.
    
    Details:
    - Modified the 0644 octal code used during installation of shared
      libraries to 0755 (for Linux/OSX only). Thanks to Adam J. Stewart
      for reporting this issue via #343.
    - CREDITS file update.

commit c60db26aee9e7b4e5d0b031b0881e58d23666b53
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Sep 17 18:04:17 2019 -0500

    Fixed bad loop counter in bli_[cz]scal2bbs_mxn().
    
    Details:
    - Fixed a typo in the loop counter for the 'd' (duplication) dimension
      in the complex macros of frame/include/level0/bb/bli_scal2bbs_mxn.h.
      They shouldn't be used by anyone yet, but thankfully clang via
      AppVeyor spit out warnings that alerted me to the issue.

commit c766c81d628f0451d8255bf5e4b8be0a4ef91978
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Sep 17 18:00:29 2019 -0500

    Added missing schema arg to knl packm kernels.
    
    Details:
    - Added the pack_t schema argument to the knl packm kernel functions.
      This change was intended for inclusion in 31c8657. (Thank you SDE +
      Travis CI.)

commit 31c8657f1d6d8f6efd8a73fd1995e995fc56748b
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Sep 17 17:42:10 2019 -0500

    Added support for pre-broadcast when packing B.
    
    Details:
    - Added support for being able to duplicate (broadcast) elements in
      memory when packing matrix B (ie: the left-hand operand) in level-3
      operations. This turns out advantageous for some architectures that
      can afford the cost of the extra bandwidth and somehow benefit from
      the pre-broadcast elements (and thus being able to avoid using
      broadcast-style load instructions on micro-rows of B in the gemm
      microkernel).
    - Support optionally disabling right-side hemm and symm. If this occurs,
      hemm_r is implemented in terms of hemm_l (and symm_r in terms of
      symm_l). This is needed when broadcasting during packing because the
      alternative--supporting the broadcast of B while also allowing matrix
      B to be Hermitian/symmetric--would be an absolute mess.
    - Support alignment factors for packed blocks of A, B, and C separately
      (as well as for general-purpose buffers). In addition, we support
      byte offsets from those alignment values (which is different from
      aligning by align+offset bytes to begin with). The default alignment
      values are BLIS_PAGE_SIZE in all four cases, with the offset values
      defaulting to zero.
    - Pass pack_t schema into bli_?packm_cxk() so that it can be then passed
      into the packm kernel, where it will be needed by packm kernels that
      perform broadcasts of B, since the idea is that we *only* want to
      broadcast when packing micropanels of B and not A.
    - Added definition for variadic bli_cntx_set_l3_vir_ukrs(), which can be
      used to set custom virtual level-3 microkernels in the cntx_t, which
      would typically be done in the bli_cntx_init_*() function defined in
      the subconfiguration of interest.
    - Added a "broadcast B" kernel function for use with NP/NR = 12/6,
      defined in in ref_kernels/1m/bli_packm_cxk_bb_ref.c.
    - Added a gemm, gemmtrsm, and trsm "broadcast B" reference kernels
      defined in ref_kernels/3/bb. (These kernels have been tested with
      double real with NP/NR = 12/6.)
    - Added #ifndef ... #endif guards around several macro constants defined
      in frame/include/bli_kernel_macro_defs.h.
    - Defined a few "broadcast B" static functions in
      frame/include/level0/bb for use by "broadcast B"-style packm reference
      kernels. For now, only the real domain kernels are tested and fully
      defined.
    - Output the alignment and offset values for packed blocks of A and B
      in the testsuite's "BLIS configuration info" section.
    - Comment updates to various files.
    - Bumped so_version to 3.0.0.

commit fd9bf497cd4ff73ccdfc030ba037b3cb2f1c2fad
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Sep 17 15:45:24 2019 -0500

    CREDITS file update.

commit 6c8f2d1486ce31ad3c2083e5c2035acfd4409a43
Author: ShmuelLevine <shmuel.levine@gmail.com>
Date:   Tue Sep 17 16:43:46 2019 -0400

    Fix description for function bli_*pxby2v (#340)
    
    Fix typo in BLISTypedAPI.md for bli_?axpy2v() description.

commit b5679c1520f8ae7637b3cc2313133461f62398dc
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Sep 17 14:00:37 2019 -0500

    Inserted Multithreading links into BuildSystem.md.
    
    Details:
    - Inserted brief disclaimers about default disabled multithreading
      and default single-threadedness to BuildSystem.md along with links to
      the Multithreading.md document. Thanks to Jeff Diamond for suggesting
      these additions.
    - Trivial reword of sentence regarding automatically-detected
      architectures.

commit f4f5170f8482c94132832eb3033bc8796da5420b
Author: Isuru Fernando <isuruf@gmail.com>
Date:   Wed Sep 11 07:34:48 2019 -0500

    Update README.md (#338)

commit 1cfe8e2562e5e50769468382626ce36b734741c1
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Sep 5 16:08:30 2019 -0500

    Reimplemented bli_cpuid_query() for ARM.
    
    Details:
    - Rewrote bli_cpuid_query() for ARM architectures to use stdio-based
      functions such as fopen() and fgets() instead of popen(). The new code
      does more or less the same thing as before--searches /proc/cpuinfo for
      various strings, which are then parsed in order to determine the
      model, part number, and features. Thanks to Dave Love for suggesting
      this change in issue #335.

commit 7c7819145740e96929466a248d6375d40e397e19
Author: Devin Matthews <damatthews@smu.edu>
Date:   Fri Aug 30 16:52:09 2019 -0500

    Always use sqsumv to compute normfv. (#334)
    
    * Always use sqsumv to compute normfv on MacOS.
    
    * Unconditionally disable the "dot trick" in normfv.
    
    * Added explanatory comment to normfv definition.
    
    Details:
    - Added a comment above the unconditional disabling of the dotv-based
      implementation to normfv. Thanks to Roman Yurchak, Devin Matthews,
      and Isuru Fernando in helping with this improvement.
    - CREDITS file update.

commit 80e6c10b72d50863b4b64d79f784df7befedfcd1
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Aug 29 12:12:08 2019 -0500

    Added reproduction section to Performance docs.
    
    Details:
    - Added section titled "Reproduction" to both Performance.md and
      PerformanceSmall.md that briefly nudges the motivated reader in the
      right direction if he/she wishes to run the same performance
      benchmarks used to produce the graphs shown in those documents.
      Thanks to Dave Love for making this suggestion.

commit 14cb426414856024b9ae0f84ac21efcc1d329467
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Aug 28 17:04:33 2019 -0500

    Updated OpenBLAS, Eigen sup results.
    
    Details:
    - Updated the results shown in docs/PerformanceSmall.md for OpenBLAS and
      Eigen.

commit b02e0aae8ce2705e91023b98ed416cd05430a78e
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Aug 27 14:37:46 2019 -0500

    Updated test drivers to iterate backwards.
    
    Details:
    - Updated test driver source in test, test/3, test/1m4m, and
      test/mixeddt to iterate through the problem space backwards. This
      can help avoid certain situations where the CPU frequency does not
      immediately throttle up to its maximum. Thanks to Robert van de
      Geijn for recommending this fix (originally made to test/sup drivers
      in 57e422a).
    - Applied off-by-one matlab output bugfix from b6017e5 to test drivers
      in test, test/3, test/1m4m, and test/mixeddt directories.

commit b6017e53f4b26c99b14cdaa408351f11322b1e80
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Aug 27 14:18:14 2019 -0500

    Bugfix of output text + tweaks to test/sup driver.
    
    Details:
    - Fixed an off-by-one bug in the output of matlab row indices in
      test/sup/test_gemm.c that only manifested when the problem size
      increment was equal to 1.
    - Disabled the building of rrc, rcr, rcc, crr, crc, and ccr storage
      combinations for blissup drivers in test/sup. This helps make the
      building of drivers complete sooner.
    - Trivial changes to test/sup/runme.sh.

commit 138d403b6bb15e687a3fe26d3d967b8ccd1ed97b
Author: Devin Matthews <damatthews@smu.edu>
Date:   Mon Aug 26 18:11:27 2019 -0500

    Use -funsafe-math-optimizations and -ffp-contract=fast for all reference kernels when using gcc or clang. (#331)

commit d5a05a15a7fcc38fb2519031dcc62de8ea4a530c
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Aug 26 16:54:31 2019 -0500

    Cropped whitespace from new sup graphs.
    
    Details:
    - Previously forgot crop whitespace from the new .png graphs
      added/updated in docs/graphs/sup.

commit a6c80171a353db709e43f9e6e7a3da87ce4d17ed
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Aug 26 16:51:31 2019 -0500

    Fixed contents links in docs/PerformanceSmall.md.
    
    Details:
    - Corrected links in contents section of docs/PerformanceSmall.md,
      which were erroneously directing readers to the corresponding
      sections of docs/Performance.md.

commit 40781774df56a912144ef19cc191ed626a89f0de
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Aug 26 16:47:37 2019 -0500

    Updated sup performance graphs with libxsmm.
    
    Details:
    - Added libxsmm to column-stored sup graphs presented in
      docs/PerformanceSmall.md.
    - Updated sup results for BLASFEO.
    - Added sup results for Lonestar5 (Haswell).
    - Addresses issue #326.

commit bfddf671328e7e372ac7228f72ff2d9d8e03ae18
Author: figual <figual@ucm.es>
Date:   Mon Aug 26 12:01:33 2019 +0200

    Fixed context registration for Cortex A53 (#329).

commit 4a0a6e89c568246d14de4cc30e3ff35aac23d774
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Sat Aug 24 15:25:16 2019 -0500

    Changed test/sup alpha to 1; test libxsmm+netlib.
    
    Details:
    - Changed the value of alpha to 1.0 in test/sup/test_gemm.c. This is
      needed because libxsmm currently only optimizes gemm operations where
      alpha is unit (and beta is unit or zero).
    - Adjusted the test/sup/Makefile to test libxsmm with netlib BLAS as its
      fallback library. This is the library that will be called the
      problem dimensions are deemed too large, or any other criteria for
      optimization are not met. (This was done not because it is realistic,
      but rather so that it would be very clear when libxsmm ceased handling
      gemm calls internally when the data are graphed.)

commit 7aa52b57832176c5c13a48e30a282e09ecdabf73
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Aug 23 16:12:50 2019 -0500

    Use libxsmm API in test/sup; add missing -ldl.
    
    Details:
    - Switch the driver source in test/sup so that libxsmm_?gemm() is called
      instead of ?gemm_() when compiling for / linking against libxsmm.
      libxsmm's documentation isn't clear on whether it is even *trying* to
      provide BLAS API compatibility, and I got tired of trying to figure it
      out.
    - Added missing -ldl in LDFLAGS when linking against libxsmm.

commit 57e422aa168bee7416965265c93fcd4934cd7041
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Aug 23 14:17:52 2019 -0500

    Added libxsmm support to test/sup drivers.
    
    Details:
    - Modified test/sup/Makefile to build drivers that test the performance
      of skinny/small problems via libxsmm.
    - Modified test/sup/runme.sh to run aforementioned drivers.
    - Modified test/sup/test_gemm.c so that problem sizes are tested in
      reverse order (from largest to smallest). This can help avoid certain
      situations where the CPU frequency does not immediately throttle up
      to its maximum. Thanks to Robert van de Geijn for recommending this
      fix.

commit 661681fe33978acce370255815c76348f83632bc
Merge: 2f387e32 ef0a1a0f
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Aug 22 14:29:50 2019 -0500

    Merge branch 'master' of github.com:flame/blis

commit 2f387e32ef5f9a17bafb5076dc9f66c38b52b32d
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Aug 22 14:27:30 2019 -0500

    Added Eigen -march=native hack to perf docs.
    
    Details:
    - Spell out the hack given to me by Sameer Agarwal in order to get Eigen
      to build with -march=native (which is critically important for Eigen)
      in docs/Performance.md and docs/PerformanceSmall.md.

commit ef0a1a0faf683fe205f85308a54a77ffd68a9a6c
Author: Devin Matthews <damatthews@smu.edu>
Date:   Wed Aug 21 17:40:24 2019 -0500

    Update do_sde.sh (#330)
    
    * Update do_sde.sh
    
    Automatically accept SDE license and download directly from Intel
    
    * Update .travis.yml
    
    [ci skip]
    
    * Update .travis.yml
    
    Enable SDE testing for PRs.

commit 0cd383d53a8c4a6871892a0395591ef5630d4ac0
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Aug 21 13:39:05 2019 -0500

    Corrected variable type and comment update.
    
    Details:
    - Forgot to save all changes from bli_gemmtrsm4m1_ref.c before commit
      in 8122f59. Fixed type mismatch and referenced github issue in
      comment.

commit 8122f59745db780987da6aa1e851e9e76aa985e0
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Aug 21 13:22:12 2019 -0500

    Pacify 'restrict' warning in gemmtrsm4m1 ref ukr.
    
    Details:
    - Previously, some versions of gcc would complain that the same
      pointer, one_r, is being passed in for both alpha and beta in the
      fourth call to the real gemm ukernel in bli_gemmtrsm4m1_ref.c. This
      is understandable since the compiler knows that the real gemm ukernel
      qualifies all of its floating-point arguments (including alpha and
      beta) with restrict. A small hack has been inserted into the file
      that defines a new variable to store the value 1.0, which is now used
      in lieu of one_r for beta in the fourth call to the real gemm ukernel,
      which should pacify the compiler now. Thanks to Dave Love for
      reporting this issue (#328) and for Devin Matthews for offering his
      'restrict' expertise.

commit e8c6281f139bdfc9bd68c3b36e5e89059b0ead2e
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Aug 21 12:38:53 2019 -0500

    Add -march support for specific gcc version ranges.
    
    Details:
    - Added logic to configure that checks the version of the compiler
      against known version ranges that could cause problems later in the
      build process. For example, versions of gcc older than 4.9.0 use
      different -march labels than version 4.9.0 or later
      ('-march=corei7-avx' vs '-march=sandybridge', respectively).
      Similarly, before 6.1, compilation on Zen was possible, but you
      need to start with -march=bdver4 and then disable instruction sets
      that were discarded during the transition from Excavator to Zen. So
      now, configure substitutes 'yes'/'no' values into anchors in
      config.mk.in, which sets various make variables (e.g. GCC_OT_4_9_0),
      which can be accessed and branched upon by the various
      configurations' make_defs.mk files when setting their compiler flags.
    - Updated config/haswell/make_defs.mk to branch on GCC_OT_4_9_0.
    - Updated config/sandybridge/make_defs.mk to branch on GCC_OT_4_9_0.
    - Updated config/zen/make_defs.mk to branch on GCC_OT_6_1_0.

commit e6ac4ebcb6e6a372820e7f509c0af3342966b84a
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Aug 20 13:49:47 2019 -0500

    Added page size, source location to perf docs.
    
    Details:
    - Added the page size, as returned via 'getconf -a | grep PAGE_SIZE',
      and the location of the performance drivers to docs/Performance.md
      (test/3) and docs/PerformanceSmall.md (test/sup). Thanks to Dave
      Love for suggesting these additions in #325.

commit fdce1a5648d69034fab39943100289323011c36f
Author: Meghana <Meghana.Vankadari@amd.com>
Date:   Wed Jul 24 15:04:41 2019 +0530

    changed gcc version check condition from 'ifeq' to 'if greater or equal'
    
    Change-Id: Ie4c461867829bcc113210791bbefb9517e52c226

commit c9486e0c4f82cd9f58f5ceb71c0df039e9970a20
Author: Meghana <Meghana.Vankadari@amd.com>
Date:   Wed Jul 24 09:45:17 2019 +0530

    code to detect version of gcc and set flags accordingly for zen2
    
    Change-Id: I29b0311d0000dee1a2533ee29941acf53f9e9f34

commit 54afe3dfe6828a1aff65baabbf14c98d92e50692
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Jul 23 16:54:28 2019 -0500

    Added "Education and Learning" ToC entry to README.

commit 9f53b1ce7ac702e84e71801fe96986f6aa16040e
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Jul 23 16:50:35 2019 -0500

    Added "Education and Learning" section to README.
    
    Details:
    - Added a short section after the Intro of the README.md file titled
      "Education and Learning" that directs interested readers to the
      "LAFF-On Programming for High-Performance" massive open online course
      (MOOC) hosted via edX.

commit deda4ca8a094ee18d7c7c45e040e8ef180f33a48
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Jul 22 13:59:05 2019 -0500

    Added test/1m4m driver directory.
    
    Details:
    - Added a new standalone test driver directory named '1m4m' that can
      build and run performance experiments for BLIS 1m, 4m1a, assembly,
      OpenBLAS, and the vendor library (MKL). This new driver directory
      was used to regenerate performance results for the 1m paper.
    - Added alternate (commented-out) cache blocksizes to
      config/haswell/bli_cntx_init_haswell.c. These blocksizes tend to
      work well on an a 12-core Intel Xeon E5-2650 v3.

commit dcc0ce12fde4c6dca2b4764a1922a2ab19725867
Author: Meghana <Meghana.Vankadari@amd.com>
Date:   Mon Jul 22 17:12:01 2019 +0530

    Added a global Makefile for AMD architectures in config/zen folder
    This Makefile(amd_config.mk) has all the flags that are common to EPYC series
    
    Change-Id: Ic02c60a8293ccdd37f0f292e631acd198e6895de

commit af17bca26a8bd3dcbee8ca81c18d7b25de09c483
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Jul 19 14:46:23 2019 -0500

    Updated haswell MC cache blocksizes.
    
    Details:
    - Updated the default MC cache blocksizes used by the haswell subconfig
      for both row-preferential (the default) and column-preferential
      microkernels.

commit b5e9bce4dde5bf014dd9771ae741048e1f6c7748
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Jul 19 14:42:37 2019 -0500

    Updated -march flags for sandybridge, haswell.
    
    Details:
    - Updated the '-march=corei7-avx' flag in the sandybridge subconfig
      to '-march=sandybridge' and the '-march=core-avx2' flag in the
      haswell subconfig to '-march=haswell'. The older flags were used
      by older versions of gcc and should have been updated to the newer
      forms a long time ago. (The older flags were clearly working, even
      though they are no longer documented in the gcc man page.)

commit c22b9dba5859a9fc94c8431eccc9e4eb9be02be1
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Jul 16 13:14:47 2019 -0500

    More updates to comments in testsuite modules.
    
    Details:
    - Updated most comments in testsuite modules that describe how the
      correctness test is performed so that it is clear whether the vector
      (normfv) or matrix (normfm) form of Frobenius norm is used.

commit c4cc6fa702f444a05963db01db51bc7d6669e979
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Jul 16 13:00:35 2019 -0500

    New cntx_t blksz "set" functions + misc tweaks.
    
    Details:
    - Defined two new static functions in bli_cntx.h:
        bli_cntx_set_blksz_def_dt()
        bli_cntx_set_blksz_max_dt()
      which developers may find convenient when experimenting with different
      values of cache blocksizes.
    - Updated one- and two-socket multithreaded problem size range and
      increment values in test/3/Makefile.
    - Changed default to column storage in test/3/test_gemm.c.
    - Fixed typo in comment in testsuite/src/test_subm.c.

commit b84cee29f42855dc1f263e42b83b1a46ac8def87
Merge: 1f80858a c7dd6e6c
Author: Meghana Vankadari <Meghana.Vankadari@amd.com>
Date:   Mon Jul 8 02:03:07 2019 -0400

    Merge "Added compiler flags for vanilla clang" into amd-staging-rome2.0

commit 1f80858abf5ca220b2998fbe6f9b06c32d3864c3
Author: kdevraje <kiran.Devrajegowda@amd.com>
Date:   Fri Jul 5 16:05:11 2019 +0530

     This checkin solves the dgemm performance issue jira ticket CPUPL 458, as #else was missed during integration, it was always following else path to get the block sizes
    
    Change-Id: I0084b5856c2513ab1066c08c15b5086db6532717

commit c7dd6e6cd2f910cbefcdc1e04a5adeb919a23de0
Author: Meghana <meghana.vankadari@amd.com>
Date:   Thu Jul 4 09:32:51 2019 +0530

    Added compiler flags for vanilla clang
    
    Change-Id: I13c00b4c0d65bbda4c929848fd48b0ab611952ab

commit 2acd49b76457635625a01e31c2abc8902b23cf51
Author: Meghana <meghana.vankadari@amd.com>
Date:   Mon Jul 1 15:42:38 2019 +0530

    fix for test failures using AOCC 2.0
    
    Change-Id: If44eaccc64bbe96bbbe1d32279b1b5773aba08d1

commit ceee2f973ebe115beca55ca77f9e3ce36b14c28a
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Jun 24 17:47:40 2019 -0500

    Fixed thrinfo_t printing bug for small problems.
    
    Details:
    - Fixed a bug in bli_l3_thrinfo_print_gemm_paths() and
      bli_l3_thrinfo_print_trsm_paths(), defined in bli_l3_thrinfo.c,
      whereby subnodes of the thrinfo_t tree are "dereferenced" near the
      beginning of the functions, which may lead to segfaults in certain
      situations where the thread tree was not fully formed because the
      matrix problem was too small for the level of parallelism specified.
      (That is, too small because some problems were assigned no work due
      to the smallest units in the m and n dimensions being defined by the
      register blocksizes mr and nr.) The fix requires several nested levels
      of if statements, and this is one of those few instances where use of
      goto statements results in (mostly) prettier code, especially in the
      case of _gemm_paths(). And while it wasn't necessary, I ported this
      goto usage to the loop body that prints the thrinfo_t work_id and
      comm_id values for each thread. Thanks to Nicholai Tukanov for helping
      to find this bug.

commit cac127182dd88ed0394ad81e6b91b897198e168a
Merge: 565fa385 3a45ecb1
Author: kdevraje <Kiran.Devrajegowda@amd.com>
Date:   Mon Jun 24 13:01:27 2019 +0530

    Merge branch 'amd-staging-rome2.0' of ssh://git.amd.com:29418/cpulibraries/er/blis
    with public repo commit id 565fa3853b381051ac92cff764625909d105644d.
    
    Change-Id: I68b9824b110cf14df248217a24a6191b3df79d42

commit c152109e9a3b1cd74760e8a3215a676d25c18d2e
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Jun 19 13:23:24 2019 -0500

    Updated BLASFEO results in PerformanceSmall.md.
    
    Details:
    - Updated the BLASFEO performance graphs shown in PerformanceSmall.md
      using a new commit of BLASFEO (2c9f312); updated PerformanceSmall.md
      accordingly.
    - Updated test/sup/octave/plot_l3sup_perf.m so that the .m files
      containing the mpnpkp results do not need to be preprocessed in order
      to plot half the problem size range (ie: up to 400 instead of the
      800 range of the other shape cases).
    - Trivial updates to runme.m.

commit 4d19c98110691d33ecef09d7e1b97bd1ccf4c420
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Sat Jun 8 11:02:03 2019 -0500

    Trivial change to MixedDatatypes.md link text.

commit 24965beabe83e19acf62008366097a7f198d4841
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Sat Jun 8 11:00:22 2019 -0500

    Fixed typo in README.md's MixedDatatypes.md link.

commit 50dc5d95760f41c5117c46f754245edc642b2179
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Jun 7 13:10:16 2019 -0500

    Adjust -fopenmp-simd for icc's preferred syntax.
    
    Details:
    - Use -qopenmp-simd instead of -fopenmp-simd when compiling with Intel
      icc. Recall that this option is used for SIMD auto-vectorization in
      reference kernels only. Support for the -f option has been completely
      deprecated and removed in newer versions of icc in favor of -q. Thanks
      to Victor Eijkhout for reporting this issue and suggesting the fix.

commit ad937db9507786874c801b41a4992aef42d924a1
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Jun 7 11:34:08 2019 -0500

    Added missing #include "bli_family_thunderx2.h".
    
    Details:
    - Added a cpp-conditional directive block to bli_arch_config.h that
      #includes "bli_family_thunderx2.h". The code has been missing since
      adf5c17f. However, this never manifested as an error because the file
      is virtually empty and not needed for thunderx2 (or most subconfigs).
      Thanks to Jeff Diamond for helping to spot this.

commit ce671917b2bc24895289247feef46f6fdd5020e7
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Jun 6 14:17:21 2019 -0500

    Fixed formatting/typo in docs/PerformanceSmall.md.

commit 86c33a4eb284e2cf3282a1809be377785cdb3703
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Jun 5 11:43:55 2019 -0500

    Tweaked language in README.md related to sup/AMD.

commit cbaa22e1ca368d36a8510f2b4ecd6f1523d1e1f3
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Jun 4 16:06:58 2019 -0500

    Added BLASFEO results to docs/PerformanceSmall.md.
    
    Details:
    - Updated the graphs linked in PerformanceSmall.md with BLASFEO results,
      and added documenting language accordingly.
    - Updated scripts in test/sup/octave to plot BLASFEO data.
    - Minor tweak to language re: how OpenBLAS was configured for
      docs/Performance.md.

commit 763fa39c3088c0e2c0155675a3ca868a58bffb30
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Jun 4 14:46:45 2019 -0500

    Minor tweaks to test/sup.
    
    Details:
    - Changed starting problem and increment from 16 to 4.
    - Added 'lll' (square problems) to list of problem size shapes to
      compile and run with.
    - Define BLASFEO location and added BLASFEO-related definitions.

commit 5e1e696003c9151b1879b910a1957b7bdd7b0deb
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Jun 3 18:37:20 2019 -0500

    CHANGELOG update (0.6.0)

commit 18c876b989fd0dcaa27becd14e4f16bdac7e89b3 (tag: 0.6.0)
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Jun 3 18:37:19 2019 -0500

    Version file update (0.6.0)

commit 0f1b3bf49eb593ca7bb08b68a7209f7cd550f912
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Jun 3 18:35:19 2019 -0500

    ReleaseNotes.md update in advance of next version.
    
    Details:
    - Updated ReleaseNotes.md in preparation for next version.
    - CREDITS file update.

commit 27da2e8400d900855da0d834b5417d7e83f21de1
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Jun 3 17:14:56 2019 -0500

    Minor edits to docs/PerformanceSmall.md.
    
    Details:
    - Added performance analysis to "Comments" section of both Kaby Lake and
      Epyc sections.
    - Added emphasis to certain passages.

commit 09ba05c6f87efbaadf085497dc137845f16ee9c5
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Jun 3 16:53:19 2019 -0500

    Added sup performance graphs/document to 'docs'.
    
    Details:
    - Added a new markdown document, docs/PerformanceSmall.md, which
      publishes new performance graphs for Kaby Lake and Epyc showcasing
      the new BLIS sup (small/skinny/unpacked) framework logic and kernels.
      For now, only single-threaded dgemm performance is shown.
    - Reorganized graphs in docs/graphs into docs/graphs/large, with new
      graphs being placed in docs/graphs/sup.
    - Updates to scripts in test/sup/octave, mostly to allow decent output
      in both GNU octave and Matlab.
    - Updated README.md to mention and refer to the new PerformanceSmall.md
      document.

commit 6bf449cc6941734748034de0e9af22b75f1d6ba1
Merge: abd8a9fa a4e8801d
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri May 31 17:42:40 2019 -0500

    Merge branch 'amd'

commit a4e8801d08d81fa42ebea6a05a990de8dcedc803
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri May 31 17:30:51 2019 -0500

    Increased MT sup threshold for double to 201.
    
    Details:
    - Fine-tuned the double-precision real MT threshold (which controls
      whether the sup implementation kicks for smaller m dimension values)
      from 180 to 201 for haswell and 180 to 256 for zen.
    - Updated octave scripts in test/sup/octave to include a seventh column
      to display performance for m = n = k.

commit 3a45ecb15456249c30ccccd60e42152f355615c1
Merge: 3f867c96 b69fb0b7
Author: Kiran Devrajegowda <Kiran.Devrajegowda@amd.com>
Date:   Fri May 31 06:47:02 2019 -0400

    Merge "Added back BLIS_ENABLE_ZEN_BLOCK_SIZES macro to zen configuration, this is same as release 1.3. This was added before to improve DGEMM Multithreaded scalability on Naples for when number of threads is greater than 16. By mistake this got deleted in many changes done for 2.0 release, now we are adding this change back., in bli_gemm_front.c - code cleanup" into amd-staging-rome2.0

commit b69fb0b74a4756168de270fc9b18f7cf7aa57f17
Author: Kiran Varaganti <Kiran.Varaganti@amd.com>
Date:   Fri May 31 15:14:22 2019 +0530

    Added back BLIS_ENABLE_ZEN_BLOCK_SIZES macro to zen configuration, this is same as release 1.3. This was added before to improve DGEMM Multithreaded scalability on Naples for when number of threads is greater than 16. By mistake this got deleted in many changes done for 2.0 release, now we are adding this change back., in bli_gemm_front.c - code cleanup
    
    Change-Id: I9f5d8225254676a99c6f2b09a0825e545206d0fc

commit 3f867c96caea3bbbbeeff1995d90f6cf8c9895fb
Author: kdevraje <Kiran.Devrajegowda@amd.com>
Date:   Fri May 31 12:22:44 2019 +0530

     When running HPL with pure MPI without DGEMM Threading (Single Threaded BLIS ), making this macro 1 gives best performance.wq
    
    Change-Id: I24fd0bf99216f315e49f1c74c44c3feaffd7078d

commit abd8a9fa7df4569aa2711964c19888b8e248901f (origin/pfhp)
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue May 28 12:49:44 2019 -0500

    Inadvertantly hidden xerbla_() in blastest (#313).
    
    Details:
    - Attempted a fix to issue #313, which reports that when building only
      a shared library (ie: static library build is disabled), running the
      BLAS test drivers can fail because those drivers provide their own
      local version of xerbla_() as a clever (albeit still rather hackish)
      way of checking the error codes that result from the individual tests.
      This local xerbla_() function is never found at link-time because the
      BLAS test drivers' Makefile imports BLIS compilation flags via the
      get-user-cflags-for() function, which currently conveys the
      -fvisibility=hidden flag, which hides symbols unless they are
      explicitly annotated for export. The -fvisibility=hidden flag was
      only ever intended for use when building BLIS (not for applications),
      and so the attempted solution here is to omit the symbol export
      flag(s) from get-user-cflags-for() by storing the symbol export
      flag(s) to a new BULID_SYMFLAGS variable instead of appending it
      to the subconfigurations' CMISCFLAGS variable (which is returned by
      every get-*-cflags-for() function). Thanks to M. Zhou for reporting
      this issue and also to Isuru Fernando for suggesting the fix.
    - Renamed BUILD_FLAGS to BUILD_CPPFLAGS to harmonize with the newly
      created BUILD_SYMFLAGS.
    - Fixed typo in entry for --export-shared flag in 'configure --help'
      text.

commit 13806ba3b01ca0dd341f4720fb930f97e46710b0
Author: kdevraje <Kiran.Devrajegowda@amd.com>
Date:   Mon May 27 16:24:43 2019 +0530

     This check in has changes w.r.t Copyright information, which is changed to (start year) - 2019
    
    Change-Id: Ide3c8f7172210b8d3538d3c36e88634ab1ba9041

commit ee123f535872510f77100d3d55a43d4ca56047d5
Author: Meghana <meghana.vankadari@amd.com>
Date:   Mon May 27 15:36:44 2019 +0530

    Defined small matrix thresholds for TRSM for various cases for NAPLES and ROME
    Updated copyright information for kernels/zen/bli_trsm_small.c file
    Removed separate kernels for zen2 architecture
    Instead added threshold conditions in zen kernels both for ROME and NAPLES
    
    Change-Id: Ifd715731741d649b6ad16b123a86dbd6665d97e5

commit 9d93a4caa21402d3a90aac45d7a1603736c9fd63
Author: prangana <pradeep.rao@amd.com>
Date:   Fri May 24 17:59:13 2019 +0530

    update version 2.0

commit 755730608d923538273a90c48bfdf77571f86519
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu May 23 17:34:36 2019 -0500

    Minor rewording of language around mt env. vars.

commit ba31abe73c97c16c78fffc59a215761b8d9fd1f6
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu May 23 14:59:53 2019 -0500

    Added BLIS theading info to Performance.md.
    
    Details:
    - Documented the BLIS environment variables that were set
      (e.g. BLIS_JC_NT, BLIS_IC_NT, BLIS_JR_NT) for each machine and
      threading configuration in order to achieve the parallelism reported
      on in docs/Performance.md.

commit cb788ffc89cac03b44803620412a5e83450ca949
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu May 23 13:00:53 2019 -0500

    Increased MT sup threshold for double to 180.
    
    Details:
    - Increased the double-precision real MT threshold (which controls
      whether the sup implementation kicks for smaller m dimension values)
      from 80 to 180, and this change was made for both haswell and zen
      subconfigurations. This is less about the m dimension in particular
      and more about facilitating a smoother performance transition when
      m = n = k.

commit 057f5f3d211e7513f457ee6ca6c9555d00ad1e57
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu May 23 12:51:17 2019 -0500

    Minor build system housekeeping.
    
    Details:
    - Commented out redundant setting of LIBBLIS_LINK within all driver-
      level Makefiles. This variable is already set within common.mk, and
      so the only time it should be overridden is if the user wants to link
      to a different copy of libblis.
    - Very minor changes to build/gen-make-frags/gen-make-frag.sh.
    - Whitespace and inconsequential quoting change to configure.
    - Moved top-level 'windows' directory into a new 'attic' directory.

commit e05171118c377f356f89c4daf8a0d5ddc5a4e4f7
Author: Meghana <meghana.vankadari@amd.com>
Date:   Thu May 23 16:15:27 2019 +0530

    Implemented TRSM for small matrices for cases where A is on the right
    
    Added separate kernels for zen and zen2
    
    Change-Id: I6318ddc250cf82516c1aa4732718a35eae0c9134

commit 02920f5c480c42706b487e37b5ecc96c3555b851
Author: kdevraje <Kiran.Devrajegowda@amd.com>
Date:   Thu May 23 15:29:59 2019 +0530

    make checkblis fails for matrix dimension check at the begining hence reverting it
    
    Change-Id: Ibd2ee8c2d4914598b72003fbfc5845be9c9c1e87

commit 84215022f29fb3bfedd254d041635308d177e6c0
Author: kdevraje <Kiran.Devrajegowda@amd.com>
Date:   Thu May 23 11:08:41 2019 +0530

     Adding threshold condition to dgemm small matrix kernels, defining the constants in zen2 configuration
    
    Change-Id: I53a58b5d734925a6fcb8d8bea5a02ddb8971fcd5

commit a3554eb1dcc1b5b94d81c60761b2f01c3d827ffa
Merge: ea082f83 17b878b6
Author: kdevraje <Kiran.Devrajegowda@amd.com>
Date:   Thu May 23 11:51:07 2019 +0530

    Merge branch 'amd-staging-rome2.0' of ssh://git.amd.com:29418/cpulibraries/er/blis to configure zen2
    
    Change-Id: I97e17bca9716b80b862925f97bb513c07b4b0cae

commit ea082f839071dd9ec555062dc3851c31d12f00e4
Author: kdevraje <Kiran.Devrajegowda@amd.com>
Date:   Thu May 23 10:38:29 2019 +0530

    adding empty zen2 directory with .gitignore file
    
    Change-Id: Ifa37cf54b2578aa19ad335372b44bca17043fe4b

commit b80bd5bcb2be8551a9a21fafc8e6c8b6336c99b5
Author: Kiran Varaganti <Kiran.Varaganti@amd.com>
Date:   Tue May 21 15:11:47 2019 +0530

    config/zen/bli_cntx_init_zen.c: removed BLIS_ENBLE_ZEN_BLOCK_SIZES macro. We have different configurations for both zen and zen2
    config/zen/bli_family_zen.h: deleted macro BLIS_ENBLE_ZEN_BLOCK_SIZES
    config/zen/make_defs.mk: removed compiler flag -mno-avx256-split-unaligned-store
    frame/base/bli_cpuid.c: ROME family is 17H but model # is from 0x30H.
    test/test_gemm.c - commented out #define FILE_IN_OUT (some compilation error when BLIS is configured as amd64)
    Now we can use single configuration has ./configure amd64 - this will work both for ROME & Naples
    
    Change-Id: I91b4fc35380f8a35b4f4c345da040c6b5910b4a2

commit a042db011df9a1c3e7c7ac546541f4746b176ea5
Author: Kiran Varaganti <Kiran.Varaganti@amd.com>
Date:   Mon May 20 14:17:32 2019 +0530

    Modified make_defs.mk for zen2 to get compiled by gcc version less than gcc9.0
    
    Change-Id: I8fcac30538ee39534c296932639053b47b9a2d43

commit a23f92594cf3d530e5794307fe97afc877d853b7
Author: Kiran Varaganti <Kiran.Varaganti@amd.com>
Date:   Mon May 20 10:48:06 2019 +0530

    config_registry: New AMD zen2 architecture configuration added.
      frame/base/bli_arch.c: #ifdef BLIS_FAMILY_ZEN2 id = BLIS_ARCH_ZEN2; #endif added. zen2 is added in config_name[BLIS_NUM_ARCHS]
      frame/base/bli_cpuid.c : #ifdef BLIS_CONFIG_ZEN2 if ( bli_cpuid_is_zen2( family, model, features ) ) return BLIS_ARCH_ZEN2; #endif, defined new function bool bli_cpuid_is_zen2(...).
      frame/base/bli_cpuid.h : declared bli_cpuid_is_zen2(..).
      frame/base/bli_gks.c : #ifdef BLIS_CONFIG_ZEN2 bli_gks_register_cntx(BLIS_ARCH_ZEN2, bli_cntx_init_zen2, bli_cntx_init_zen2_ref, bli_cntx_init_zen2_ind); #endif
      frame/include/bli_arch_config.h : #ifdef BLIS_CONFIG_ZEN2 CNTX_INIT_PROTS(zen2) #endif #ifdef BLIS_FAMILY_ZEN2 #include "bli_family_zen2.h" #endif
      frame/include/bli_type_defs.h : added BLIS_ARCH_ZEN2 in arch_t enum. BLIS_NUM_ARCHS 20
    
    Change-Id: I2a2d9b7266673e78a4f8543b1bfb5425b0aa7866

commit 17b878b66d917d50b6fe23721d8579e826cb3e8c
Author: kdevraje <Kiran.Devrajegowda@amd.com>
Date:   Wed May 22 14:02:53 2019 +0530

    adding license same as in ut-austin-amd-branch
    
    Change-Id: I6790768d2bf5d42369d304ef93e34701f95fbaff

commit df755848b8a271323e007c7a628c64af63deab00
Merge: ca4b33c0 c72ae27a
Author: kdevraje <Kiran.Devrajegowda@amd.com>
Date:   Wed May 22 13:30:07 2019 +0530

    Merge branch 'amd-staging-rome2.0' of ssh://git.amd.com:29418/cpulibraries/er/blis into rome2.0
    
    Change-Id: Ie8aad1ab810f0f3c0b90ec67f9dd3dfb8dcc74cc

commit c72ae27adee4726679ee004d02c972582b5285b4
Author: Nisanth M P <nisanth.padinharepatt@amd.com>
Date:   Mon Mar 19 12:49:26 2018 +0530

    Re-enabling the small matrix gemm optimization for target zen
    
    Change-Id: I13872784586984634d728cd99a00f71c3f904395

commit ab0818af80f7f683080873f3fa24734b65267df2
Author: sraut <Biplab.Raut@amd.com>
Date:   Wed Oct 3 15:30:33 2018 +0530

    Review comments incorporated for small TRSM.
    
    Change-Id: Ia64b7b2c0375cc501c2cb0be8a1af93111808cd9

commit 32392cfc72af7f42da817a129748349fb1951346
Author: Jeff Hammond <jeff.r.hammond@intel.com>
Date:   Tue May 14 15:52:30 2019 -0400

    add info about CXX in configure (#311)

commit fa7e6b182b8365465ade178b0e4cd344ff6f6460
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed May 1 19:13:00 2019 -0500

    Define _POSIX_C_SOURCE in bli_system.h.
    
    Details:
    - Added
        #ifndef _POSIX_C_SOURCE
        #define _POSIX_C_SOURCE 200809L
        #endif
      to bli_system.h so that an application that uses BLIS (specifically,
      an application that #includes blis.h) does not need to remember to
      #define the macro itself (either on the command line or in the code
      that includes blis.h) in order to activate things like the pthreads.
      Thanks to Christos Psarras for reporting this issue and suggesting
      this fix.
    - Commented out #include <sys/time.h> in bli_system.h, since I don't
      think this header is used/needed anymore.
    - Comment update to function macro for bli_?normiv_unb_var1() in
      frame/util/bli_util_unb_var1.c.

commit 3df84f1b5d5e1146bb01bfc466ac20c60a9cc859
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Sat Apr 27 21:27:32 2019 -0500

    Minor bugfixes in sup dgemm implementation.
    
    Details:
    - Fixed an obscure but in the bli_dgemmsup_rv_haswell_asm_5x8n() kernel
      that only affected the beta == 0, column-storage output case. Thanks
      to the BLAS test drivers for catching this bug.
    - Previously, bli_gemmsup_ref_var1n() and _var2m() were returning if
      k = 0, when the correct action would be to scale by beta (and then
      return). Thanks to the BLAS test drivers to catching this bug.
    - Changed the sup threshold behavior such that the sup implementation
      only kicks in if a matrix dimension is strictly less than (rather than
      less than or equal to) the threshold in question.
    - Initialize all thresholds to zero (instead of 10) by default in
      ref_kernels/bli_cntx_ref.c. This, combined with the above change to
      threshold testing means that calls to BLIS or BLAS with one or more
      matrix dimensions of zero will no longer trigger the sup
      implementation.
    - Added disabled debugging output to frame/3/bli_l3_sup.c (for future
      use, perhaps).

commit ecbdd1c42dcebfecd729fe351e6bb0076aba7d81
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Sat Apr 27 19:38:11 2019 -0500

    Ceased use of BLIS_ENABLE_SUP_MR/NR_EXT macros.
    
    Details:
    - Removed already limited use of the BLIS_ENABLE_SUP_MR_EXT and
      BLIS_ENABLE_SUP_NR_EXT macros in bli_gemmsup_ref_var1n() and
      bli_gemmsup_ref_var2m(). Their purpose was merely to avoid a long
      conditional that would determine whether to allow the last iteration
      to be merged with the second-to-last iteration. Functionally, the
      macros were not needed, and they ended up causing problems when
      building configuration families such as intel64 and x86_64.

commit aa8a6bec3036a41e1bff2034f8ef6766a704ec49
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Sat Apr 27 18:53:33 2019 -0500

    Fixed typo in --disable-sup-handling macro guard.
    
    Details:
    - Fixed an incorrectly-named macro guard that is intended to allow
      disabling of the sup framework via the configure option
      --disable-sup-handling. In this case, the preprocessor macro,
      BLIS_DISABLE_SUP_HANDLING, was still named by its name from an older
      uncommitted version of the code (BLIS_DISABLE_SM_HANDLING).

commit b9c9f03502c78a63cfcc21654b06e9089e2a3822
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Sat Apr 27 18:44:50 2019 -0500

    Implemented gemm on skinny/unpacked matrices.
    
    Details:
    - Implemented a new sub-framework within BLIS to support the management
      of code and kernels that specifically target matrix problems for which
      at least one dimension is deemed to be small, which can result in long
      and skinny matrix operands that are ill-suited for the conventional
      level-3 implementations in BLIS. The new framework tackles the problem
      in two ways. First the stripped-down algorithmic loops forgo the
      packing that is famously performed in the classic code path. That is,
      the computation is performed by a new family of kernels tailored
      specifically for operating on the source matrices as-is (unpacked).
      Second, these new kernels will typically (and in the case of haswell
      and zen, do in fact) include separate assembly sub-kernels for
      handling of edge cases, which helps smooth performance when performing
      problems whose m and n dimension are not naturally multiples of the
      register blocksizes. In a reference to the sub-framework's purpose of
      supporting skinny/unpacked level-3 operations, the "sup" operation
      suffix (e.g. gemmsup) is typically used to denote a separate namespace
      for related code and kernels. NOTE: Since the sup framework does not
      perform any packing, it targets row- and column-stored matrices A, B,
      and C. For now, if any matrix has non-unit strides in both dimensions,
      the problem is computed by the conventional implementation.
    - Implemented the default sup handler as a front-end to two variants.
      bli_gemmsup_ref_var2() provides a block-panel variant (in which the
      2nd loop around the microkernel iterates over n and the 1st loop
      iterates over m), while bli_gemmsup_ref_var1() provides a panel-block
      variant (2nd loop over m and 1st loop over n). However, these variants
      are not used by default and provided for reference only. Instead, the
      default sup handler calls _var2m() and _var1n(), which are similar
      to _var2() and _var1(), respectively, except that they defer to the
      sup kernel itself to iterate over the m and n dimension, respectively.
      In other words, these variants rely not on microkernels, but on
      so-called "millikernels" that iterate along m and k, or n and k.
      The benefit of using millikernels is a reduction of function call
      and related (local integer typecast) overhead as well as the ability
      for the kernel to know which micropanel (A or B) will change during
      the next iteration of the 1st loop, which allows it to focus its
      prefetching on that micropanel. (In _var2m()'s millikernel, the upanel
      of A changes while the same upanel of B is reused. In _var1n()'s, the
      upanel of B changes while the upanel of A is reused.)
    - Added a new configure option, --[en|dis]able-sup-handling, which is
      enabled by default. However, the default thresholds at which the
      default sup handler is activated are set to zero for each of the m, n,
      and k dimensions, which effectively disables the implementation. (The
      default sup handler only accepts the problem if at least one dimension
      is smaller than or equal to its corresponding threshold. If all
      dimensions are larger than their thresholds, the problem is rejected
      by the sup front-end and control is passed back to the conventional
      implementation, which proceeds normally.)
    - Added support to the cntx_t structure to track new fields related to
      the sup framework, most notably:
      - sup thresholds: the thresholds at which the sup handler is called.
      - sup handlers: the address of the function to call to implement
        the level-3 skinny/unpacked matrix implementation.
      - sup blocksizes: the register and cache blocksizes used by the sup
        implementation (which may be the same or different from those used
        by the conventional packm-based approach).
      - sup kernels: the kernels that the handler will use in implementing
        the sup functionality.
      - sup kernel prefs: the IO preference of the sup kernels, which may
        differ from the preferences of the conventional gemm microkernels'
        IO preferences.
    - Added a bool_t to the rntm_t structure that indicates whether sup
      handling should be enabled/disabled. This allows per-call control
      of whether the sup implementation is used, which is useful for test
      drivers that wish to switch between the conventional and sup codes
      without having to link to different copies of BLIS. The corresponding
      accessor functions for this new bool_t are defined in bli_rntm.h.
    - Implemented several row-preferential gemmsup kernels in a new
      directory, kernels/haswell/3/sup. These kernels include two general
      implementation types--'rd' and 'rv'--for the 6x8 base shape, with
      two specialized millikernels that embed the 1st loop within the kernel
      itself.
    - Added ref_kernels/3/bli_gemmsup_ref.c, which provides reference
      gemmsup microkernels. NOTE: These microkernels, unlike the current
      crop of conventional (pack-based) microkernels, do not use constant
      loop bounds. Additionally, their inner loop iterates over the k
      dimension.
    - Defined new typedef enums:
      - stor3_t: captures the effective storage combination of the level-3
        problem. Valid values are BLIS_RRR, BLIS_RRC, BLIS_RCR, etc. A
        special value of BLIS_XXX is used to denote an arbitrary combination
        which, in practice, means that at least one of the operands is
        stored according to general stride.
      - threshid_t: captures each of the three dimension thresholds.
    - Changed bli_adjust_strides() in bli_obj.c so that bli_obj_create()
      can be passed "-1, -1" as a lazy request for row storage. (Note that
      "0, 0" is still accepted as a lazy request for column storage.)
    - Added support for various instructions to bli_x86_asm_macros.h,
      including imul, vhaddps/pd, and other instructions related to integer
      vectors.
    - Disabled the older small matrix handling code inserted by AMD in
      bli_gemm_front.c, since the sup framework introduced in this commit
      is intended to provide a more generalized solution.
    - Added test/sup directory, which contains standalone performance test
      drivers, a Makefile, a runme.sh script, and an 'octave' directory
      containing scripts compatible with GNU Octave. (They also may work
      with matlab, but if not, they are probably close to working.)
    - Reinterpret the storage combination string (sc_str) in the various
      level-3 testsuite modules (e.g. src/test_gemm.c) so that the order
      of each matrix storage char is "cab" rather than "abc".
    - Comment updates in level-3 BLAS API wrappers in frame/compat.

commit 0d549ceda822833bec192bbf80633599620c15d9
Author: Isuru Fernando <isuruf@gmail.com>
Date:   Sat Apr 27 22:56:02 2019 +0000

    make unix friendly archives on appveyor (#310)

commit ca4b33c001f9e959c43b95a9a23f9df5adec7adf
Author: Kiran Varaganti <Kiran.Varaganti@amd.com>
Date:   Wed Apr 24 15:02:39 2019 +0530

     Added compiler option (-mno-avx256-split-unaligned-store) in the file config/zen/make_defs.mk to improve performance of intrinsic codes, this flag ensures compiler generates 256-bit stores for the equivalent intrinsics code.
    
    Change-Id: I8f8cd81a3604869df18d38bc42097a04f178d324

commit 945928c650051c04d6900c7f4e9e29cd0e5b299f
Merge: 663f6629 74e513eb
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Apr 17 15:58:56 2019 -0500

    Merge branch 'amd' of github.com:flame/blis into amd

commit 74e513eb6a6787a925d43cd1500277d54d86ab8f
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Apr 17 13:34:44 2019 -0500

    Support row storage in Eigen gemm test/3 driver.
    
    Details:
    - Added preprocessor branches to test/3/test_gemm.c to explicitly
      support row-stored matrices. Column-stored matrices are also still
      supported (and is the default for now). (This is mainly residual work
      leftover from initial integration of Eigen into the test drivers, so
      if we ever want to test Eigen with row-stored matrices, the code will
      be ready to use, even if it is not yet integrated into the Makefile
      in test/3.)

commit b5d457fae9bd75c4ca67f7bc7214e527aa248127
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Apr 16 12:50:01 2019 -0500

    Applied forgotten variable rename from 89a70cc.
    
    Details:
    - Somehow the variable name change (root_file_name -> root_inputname)
      in flatten-headers.py mentioned in the commit log entry for 89a70cc
      didn't make it into the actual commit. This commit applies that
      change.

commit 89a70cccf869333147eb2559cdfa5a23dc915824
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Apr 11 18:33:08 2019 -0500

    GNU-like handling of installation prefix et al.
    
    Details:
    - Changed the default installation prefix from $HOME/lib to @@HOMEBREW_PREFIX@@.
    - Modified the way configure internally handles the prefix, libdir,
      includedir, and sharedir (and also added an --exec-prefix option).
      The defaults to these variables are set as follows:
        prefix:      @@HOMEBREW_PREFIX@@
        exec_prefix: ${prefix}
        libdir:      ${exec_prefix}/lib
        includedir:  ${prefix}/include
        sharedir:    ${prefix}/share
      The key change, aside from the addition of exec_prefix and its use to
      define the default to libdir, is that the variables are substituted
      into config.mk with quoting that delays evaluation, meaning the
      substituted values may contain unevaluated references to other
      variables (namely, ${prefix} and ${exec_prefix}). This more closely
      follows GNU conventions, including those used by GNU autoconf, and
      also allows make to override any one of the variables *after*
      configure has already been run (e.g. during 'make install').
    - Updates to build/config.mk.in pursuant to above changes.
    - Updates to output of 'configure --help' pursuant to above changes.
    - Updated docs/BuildSystem.md to reflect the new default installation
      prefix, as well as mention EXECPREFIX and SHAREDIR.
    - Changed the definitions of the UNINSTALL_OLD_* variables in the
      top-level Makefile to use $(wildcard ...) instead of 'find'. This
      was motivated by the new way of handling prefix and friends, which
      leads to the 'find' command being run on @@HOMEBREW_PREFIX@@ (by default),
      which can take a while almost never yielding any benefit (since the
      user will very rarely use the uninstall-old targets).
    - Removed periods from the end of descriptive output statements (i.e.,
      non-verbose output) since those statements often end with file or
      directory paths, which get confusing to read when puctuated by a
      period.
    - Trival change to 'make showconfig' output.
    - Removed my name from 'configure --help'. (Many have contributed to it
      over the years.)
    - In configure script, changed the default state of threading_model
      variable from 'no' to 'off' to match that of debug_type, where there
      are similarly more than two valid states. ('no' is still accepted
      if given via the --enable-debug= option, though it will be
      standardized to 'off' prior to config.mk being written out.)
    - Minor variable name change in flatten-headers.py that was intended for
      32812ff.
    - CREDITS file update.

commit 9d76688ad90014a11ddc0c2f27253d62806216b1
Author: kdevraje <Kiran.Devrajegowda@amd.com>
Date:   Thu Apr 11 10:22:48 2019 +0530

    Fix for single rank crash with HPL application. When computing offset of C buffer, as integer variables are used for a row and column index, the intermediate result value overflows and a negative value gets added to the buffer, when the negative value is too large it would index the buffer out of the range resulting in segmentation fault. Although the crash is a result of dgemm kernel, added similar code in sgemm kernel also.
    
    Change-Id: I171119b0ec0dfbd8e63f1fcd6609a94384aabd27

commit 32812ff5aba05d34c421fe1024a61f3e2d5e7052
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Apr 9 12:20:19 2019 -0500

    Minor bugfix to flatten-headers.py.
    
    Details:
    - Fixed a minor bug in flatten-headers.py whereby the script, upon
      encountering a #include directive for the root header file, would
      erroneously recurse and inline the conents of that root header.
      The script has been modified to avoid recursion into any headers
      that share the same name as the root-level header that was passed
      into the script. (Note: this bug didn't actually manifest in BLIS,
      so it's merely a precaution for usage of flatten-headers.py in other
      contexts.)

commit bec90e0b6aeb3c9b19589c2b700fda2d66f6ccdf
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Apr 2 17:45:13 2019 -0500

    Minor update to docs/HardwareSupport.md document.
    
    Details:
    - Added more details and clarifying language to implications of 1m and
      the recycling of microkernels between microarchitectures.

commit 89cd650e7be01b59aefaa85885a3ea78970351e4
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Apr 2 17:23:55 2019 -0500

    Use void_fp for function pointers instead of void*.
    
    Change void*-typed function pointers to void_fp.
    - Updated all instances of void* variables that store function pointers
      to variables of a new type, void_fp. Originally, I wanted to define
      the type of void_fp as "void (*void_fp)( void )"--that is, a pointer
      to a function with no return value and no arguments. However, once
      I did this, I realized that gcc complains with incompatible pointer
      type (-Wincompatible-pointer-types) warnings every time any such a
      pointer is being assigned to its final, type-accurate function
      pointer type. That is, gcc will silently typecast a void* to
      another defined function pointer type (e.g. dscalv_ker_ft) during
      an assignment from the former to the latter, but the same statement
      will trigger a warning when typecasting from a void_fp type. I suspect
      an explicit typecast is needed in order to avoid the warning, which
      I'm not willing to insert at this time.
    - Added a typedef to bli_type_defs.h defining void_fp as void*, along
      with a commented-out version of the aborted definition described
      above. (Note that POSIX requires that void* and function pointers
      be interchangeable; it is the C standard that does not provide this
      guarantee.)
    - Comment updates to various _oapi.c files.

commit ffce3d632b284eb52474036096815ec38ca8dd5f
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Apr 2 14:40:50 2019 -0500

    Renamed armv8a gemm kernel filename.
    
    Details:
    - Renamed
        kernels/armv8a/3/bli_gemm_armv8a_opt_4x4.c
      to
        kernels/armv8a/3/bli_gemm_armv8a_asm_d6x8.c.
      This follows the naming convention used by other kernel sets, most
      notably haswell.

commit 77867478af02144544b4e7b6df5d54d874f3f93b
Author: Isuru Fernando <isuruf@gmail.com>
Date:   Tue Apr 2 13:33:11 2019 -0500

    Use pthreads on MinGW and Cygwin (#307)

commit 7bc75882f02ce3470a357950878492e87e688cec
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Mar 28 17:40:50 2019 -0500

    Updated Eigen results in docs/graphs with 3.3.90.
    
    Details:
    - Updated the level-3 performance graphs in docs/graphs with new Eigen
      results, this time using a development version cloned from their git
      mirror on March 27, 2019 (version 3.3.90). Performance is improved
      over 3.3.7, though still noticeably short of BLIS/MKL in most cases.
    - Very minor updates to docs/Performance.md and matlab scripts in
      test/3/matlab.

commit 20ea7a1217d3833db89a96158c42da2d6e968ed8
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Mar 27 18:09:17 2019 -0500

    Minor text updates (Eigen) to docs/Performance.md.
    
    Details:
    - Added/updated a few more details, mostly regarding Eigen.

commit bfb7e1bc6af468e4ff22f7e27151ea400dcd318a
Merge: 044df950 2c85e1dd
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Mar 27 17:58:19 2019 -0500

    Merge branch 'dev'

commit 2c85e1dd9d5d84da7228ea4ae6deec56a89b3a8f
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Mar 27 16:29:51 2019 -0500

    Added Eigen results to performance graphs.
    
    Details:
    - Updated the Haswell, SkylakeX, and Epyc performance graphs in
      docs/graphs to report on Eigen implementations, where applicable.
      Specifically, Eigen implements all level-3 operations sequentially,
      however, of those operations it only provides multithreaded gemm.
      Thus, mt results for symm/hemm, syrk/herk, trmm, and trsm are
      omitted. Thanks to Sameer Agarwal for his help configuring and
      using Eigen.
    - Updated docs/Performance.md to note the new implementation tested.
    - CREDITS file update.

commit bfac7e385f8061f2e6591de208b0acf852f04580
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Mar 27 16:04:48 2019 -0500

    Added ability to plot with Eigen in test/3/matlab.
    
    Details:
    - Updated matlab scripts in test/3/matlab to optionally plot/display
      Eigen performance curves. Whether Eigen is plotted is determined by
      a new boolean function parameter, with_eigen.
    - Updated runme.m scratchpad to reflect the latest invocations of the
      plot_panel_4x5() function (with Eigen plotting enabled).

commit 67535317b9411c90de7fa4cb5b0fdb8f61fdcd79
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Mar 27 13:32:18 2019 -0500

    Fixed mislabeled eigen output from test/3 drivers.
    
    Details:
    - Fixed the Makefile in test/3 so that it no longer incorrectly labels
      the matlab output variables from Eigen-linked hemm, herk, trmm, and
      trsm driver output as "vendor". (The gemm drivers were already
      correctly outputing matlab variables containing the "eigen" label.)

commit 044df9506f823643c0cdd53e81ad3c27a9f9d4ff
Author: Isuru Fernando <isuruf@gmail.com>
Date:   Wed Mar 27 12:39:31 2019 -0500

    Test with shared on windows (#306)
    
    Export macros can't support both shared and static at the same time.
    When blis is built with both shared and static, headers assume that
    shared is used at link time and dllimports the symbols with __imp_
    prefix.
    
    To use the headers with static libraries a user can give
    -DBLIS_EXPORT= to import the symbol without the __imp_ prefix

commit 5e6b160c8a85e5e23bab0f64958a8acf4918a4ed
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Mar 26 19:10:59 2019 -0500

    Link to Eigen BLAS for non-gemm drivers in test/3.
    
    Details:
    - Adjusted test/3/Makefile so that the test drivers are linked against
      Eigen's BLAS library for hemm, herk, trmm, and trsm. We have to do
      this since Eigen's headers don't define implementations to the
      standard BLAS APIs.
    - Simplified #included headers in hemm, herk, trmm, and trsm source
      driver files, since nothing specific to Eigen is needed at
      compile-time for those operations.

commit e593221383aae19dfdc3f30539de80ed05cfec7f
Merge: 92fb9c87 c208b9dc
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Mar 26 15:51:45 2019 -0500

    Merge branch 'master' into dev

commit 92fb9c87bf88b9f9c401eeecd9aa9c3521bc2adb
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Mar 26 15:43:23 2019 -0500

    Add more support for Eigen to drivers in test/3.
    
    Details:
    - Use compile-time implementations of Eigen in test_gemm.c via new
      EIGEN cpp macro, defined on command line. (Linking to Eigen's BLAS
      library is not necessary.) However, as of Eigen 3.3.7, Eigen only
      parallelizes the gemm operation and not hemm, herk, trmm, trsm, or
      any other level-3 operation.
    - Fixed a bug in trmm and trsm drivers whereby the wrong function
      (bli_does_trans()) was being called to determine whether the object
      for matrix A should be created for a left- or right-side case. This
      was corrected by changing the function to bli_is_left(), as is done
      in the hemm driver.
    - Added support for running Eigen test drivers from runme.sh.

commit c208b9dc46852c877197d53b6dd913a046b6ebb6
Author: Isuru Fernando <isuruf@gmail.com>
Date:   Mon Mar 25 13:03:44 2019 -0500

    Fix clang version detection (#305)
    
    clang -dumpversion gives 4.2.1 for all clang versions as clang was
    originally compatible with gcc 4.2.1
    
    Apple clang version and clang version are two different things
    and the real clang version cannot be deduced from apple clang version
    programatically. Rely on wikipedia to map apple clang to clang version
    
    Also fixes assembly detection with clang
    
    clang 3.8 can't build knl as it doesn't recognize zmm0

commit 53842c7e7d530cb2d5609d6d124ae350fc345c32
Author: Kiran Varaganti <Kiran.Varaganti@amd.com>
Date:   Fri Mar 22 13:57:14 2019 +0530

    Removed printing alpha and beta values
    
    Change-Id: I49102db510311a30f6a936f9d843f35838f50d23

commit 6805db45e343d83d1adaf9157cf0b841653e9ede
Author: Kiran Varaganti <Kiran.Varaganti@amd.com>
Date:   Fri Mar 22 12:55:35 2019 +0530

    Corrected setting alpha & beta values- alpha = -1 and beta = 1 - bli_setc(-1.0, 0, &alpha) should be used rather than bli_setc(0.0, -1.0, &alpha). This corrected now
    
    Change-Id: Ic1102dfd6b50ccf212386a1211c6f31e8d987ef9

commit feefcab4427a75b0b55af215486b85abcda314f7
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Mar 21 18:11:20 2019 -0500

    Allow disabling of BLAS prototypes at compile-time.
    
    Details:
    - Modified bli_blas.h so that:
      - By default, if the BLAS layer is enabled at configure-time, BLAS
        prototypes are also enabled within blis.h;
      - But if the user #defines BLIS_DISABLE_BLAS_DEFS prior to including
        blis.h, BLAS prototypes are skipped over entirely so that, for
        example, the application or some other header pulled in by the
        application may prototype the BLAS functions without causing any
        duplication.
    - Updated docs/BuildSystem.md to document the feature above, and
      related text.

commit 20153cd4b594bc34f860c381ec18de3a6cc743c7
Author: Kiran Varaganti <Kiran.Varaganti@amd.com>
Date:   Thu Mar 21 16:23:53 2019 +0530

    Modified test_gemm.c file in test folder
    A Macro 'FILE_IN_OUT" is defined to read input parameters from a csv file.
    Format for input file:
    Each line defines a gemm problem with following parameters: m k n cs_a cs_b cs_c
    The operation always implemented is C = C - A*B and column-major format.
    When macro is disabled - it reverts back to original implementation.
    Usage: ./test_gemm_<mkl/blis/openblas>.x input.csv output.csv
    GEMM is called through BLAS interface
    For BLIS - the test application also prints either 'S' indicating small gemm routine or 'N' - conventional BLIS gemm
    for MKL/OpenBLAS - ignore this character
    
    Change-Id: I0924ef2c1f7bdea48d4cdb230b888e2af2c86a36

commit 288843b06d91e1b4fade337959aef773090bd1c9
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Mar 20 17:52:23 2019 -0500

    Added Eigen support to test/3 Makefile, runme.sh.
    
    Details:
    - Added targets to test/3/Makefile that link against a BLAS library
      build by Eigen. It appears, however, that Eigen's BLAS library does
      not support multithreading. (It may be that multithreading is only
      available when using the native C++ APIs.)
    - Updated runme.sh with a few Eigen-related tweaks.
    - Minor tweaks to docs/Performance.md.

commit 153e0be21d9ff413e370511b68d553dd02abada9
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Mar 19 17:53:18 2019 -0500

    More minor tweaks to docs/Performance.md.
    
    Details:
    - Defined GFLOPS as billions of floating-point operations per second,
      and reworded the sentence after about normalization.

commit 05c4e42642cc0c8dbfa94a6c21e975ac30c0517a
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Mar 19 17:07:20 2019 -0500

    CHANGELOG update (0.5.2)

commit 9204cd0cb0cc27790b8b5a2deb0233acd9edeb9b (tag: 0.5.2)
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Mar 19 17:07:18 2019 -0500

    Version file update (0.5.2)

commit 64560cd9248ebf4c02c4a1eeef958e1ca434e510
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Mar 19 17:04:20 2019 -0500

    ReleaseNotes.md update in advance of next version.
    
    Details:
    - Updated ReleaseNotes.md in preparation for next version.

commit ab5ad557ea69479d487c9a3cb516f43fa1089863
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Mar 19 16:50:41 2019 -0500

    Very minor tweaks to Performance.md.

commit 03c4a25e1aa8a6c21abbb789baa599ac419c3641
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Mar 19 16:47:15 2019 -0500

    Minor fixes to docs/Performance.md.
    
    Details:
    - Fixed some incorrect labels associated with the pdf/png graphs,
      apparently the result of copy-pasting.

commit fe6dd8b132f39ecb8893d54cd8e75d4bbf6dab83
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Mar 19 16:30:23 2019 -0500

    Fixed broken section links in docs/Performance.md.
    
    Details:
    - Fixed a few broken section links in the Contents section.

commit 913cf97653f5f9a40aa89a5b79e2b0a8882dd509
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Mar 19 16:15:24 2019 -0500

    Added docs/Performance.md and docs/graphs subdir.
    
    Details:
    - Added a new markdown document, docs/Performance.md, which reports
      performance of a representative set of level-3 operations across a
      variety of hardware architectures, comparing BLIS to OpenBLAS and a
      vendor library (MKL on Intel/AMD, ARMPL on ARM). Performance graphs,
      in pdf and png formats, reside in docs/graphs.
    - Updated README.md to link to new Performance.md document.
    - Minor updates to CREDITS, docs/Multithreading.md.
    - Minor updates to matlab scripts in test/3/matlab.

commit 9945ef24fd758396b698b19bb4e23e53b9d95725
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Mar 19 15:28:44 2019 -0500

    Adjusted cache blocksizes for zen subconfig.
    
    Details:
    - Adjusted the zen sub-configuration's cache blocksizes for float,
      scomplex, and dcomplex based on the existing values for double.
      (The previous values were taken directly from the haswell subconfig,
      which targets Intel Haswell/Broadwell/Skylake systems.)

commit d202d008d51251609d08d3c278bb6f4ca9caf8e4
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Mar 18 18:18:25 2019 -0500

    Renamed --enable-export-all to --export-shared=[].
    
    Details:
    - Replaced the existing --enable-export-all / --disable-export-all
      configure option with --export-shared=[public|all], with the 'public'
      instance of the latter corresponding to --disable-export-all and the
      'all' instance corresponding to --enable-export-all. Nothing else
      semantically about the option, or its default, has changed.

commit ff78089870f714663026a7136e696603b5259560
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Mar 18 13:22:55 2019 -0500

    Updates to docs/Multithreading.md.
    
    Details:
    - Made extra explicit the fact that: (a) multithreading in BLIS is
      disabled by default; and (b) even with multithreading enabled, the
      user must specify multithreading at runtime in order to observe
      parallelism. Thanks to M. Zhou for suggesting these clarifications
      in #292.
    - Also made explicit that only the environment variable and global
      runtime API methods are available when using the BLAS API. If the
      user wishes to use the local runtime API (specify multithreading on
      a per-call basis), one of the native BLIS APIs must be used.

commit 3a929a3d0ba0353159a6d4cd188f01b7a390ccfc
Author: Kiran Varaganti <Kiran.Varaganti@amd.com>
Date:   Mon Mar 18 10:51:41 2019 +0530

    Fixed code merging: bli_gemm_small.c - missed conditional checks for L!=0 && K!=0. Now they are added. This fix is done to pass blastest
    
    Change-Id: Idc9c9a04d2015a68a19553c437ecaf8f1584026c

commit 663f662932c3f182fefc3c77daa1bf8c3394bb8b
Merge: 938c05ef 6bfe3812
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Sat Mar 16 16:17:12 2019 -0500

    Merge branch 'amd' of github.com:flame/blis into amd

commit 938c05ef8654e2fc013d39a57f51d91d40cc40fb
Merge: 4ed39c09 5a5f494e
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Sat Mar 16 16:01:43 2019 -0500

    Merge branch 'amd' of github.com:flame/blis into amd

commit 6bfe3812e29b86c95b828822e4e5473b48891167
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Mar 15 13:57:49 2019 -0500

    Use -fvisibility=[...] with clang on Linux/BSD/OSX.
    
    Details:
    - Modified common.mk to use the -fvisibility=[hidden|default] option
      when compiling with clang on non-Windows platforms (Linux, BSD, OS X,
      etc.). Thanks to Isuru Fernando for pointing out this option works
      with clang on these OSes.

commit 809395649c5bbf48778ede4c03c1df705dd49566
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Mar 13 18:21:35 2019 -0500

    Annotated additional symbols for export.
    
    Details:
    - Added export annotations to additional function prototypes in order to
      accommodate the testsuite.
    - Disabled calling bli_amaxv_check() from within the testsuite's
      test_amaxv.c.

commit e095926c643fd9c9c2220ebecd749caae0f71d42
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Mar 13 17:35:18 2019 -0500

    Support shared lib export of only public symbols.
    
    Details:
    - Introduced a new configure option, --enable-export-all, which will
      cause all shared library symbols to be exported by default, or,
      alternatively, --disable-export-all, which will cause all symbols to
      be hidden by default, with only those symbols that are annotated for
      visibility, via BLIS_EXPORT_BLIS (and BLIS_EXPORT_BLAS for BLAS
      symbols), to be exported. The default for this configure option is
      --disable-export-all. Thanks to Isuru Fernando for consulting on
      this commit.
    - Removed BLIS_EXPORT_BLIS annotations from frame/1m/bli_l1m_unb_var1.h,
      which was intended for 5a5f494.
    - Relocated BLIS_EXPORT-related cpp logic from bli_config.h.in to
      frame/include/bli_config_macro_defs.h.
    - Provided appropriate logic within common.mk to implement variable
      symbol visibility for gcc, clang, and icc (to the extend that each of
      these compilers allow).
    - Relocated --help text associated with debug option (-d) to configure
      slightly further down in the list.

commit 5a5f494e428372c7c27ed1f14802e15a83221e87
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Mar 12 18:45:09 2019 -0500

    Removed export macros from all internal prototypes.
    
    Details:
    - After merging PR #303, at Isuru's request, I removed the use of
      BLIS_EXPORT_BLIS from all function prototypes *except* those that we
      potentially wish to be exported in shared/dynamic libraries. In other
      words, I removed the use of BLIS_EXPORT_BLIS from all prototypes of
      functions that can be considered private or for internal use only.
      This is likely the last big modification along the path towards
      implementing the functionality spelled out in issue #248. Thanks
      again to Isuru Fernando for his initial efforts of sprinkling the
      export macros throughout BLIS, which made removing them where
      necessary relatively painless. Also, I'd like to thank Tony Kelman,
      Nathaniel Smith, Ian Henriksen, Marat Dukhan, and Matthew Brett for
      participating in the initial discussion in issue #37 that was later
      summarized and restated in issue #248.
    - CREDITS file update.

commit 3dc18920b6226026406f1d2a8b2c2b405a2649d5
Merge: b938c16b 766769ee
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Mar 12 11:20:25 2019 -0500

    Merge branch 'master' into dev

commit 766769eeb944bd28641a6f72c49a734da20da755
Author: Isuru Fernando <isuruf@gmail.com>
Date:   Mon Mar 11 19:05:32 2019 -0500

    Export functions without def file (#303)
    
    * Revert "restore bli_extern_defs exporting for now"
    
    This reverts commit 09fb07c350b2acee17645e8e9e1b8d829c73dca8.
    
    * Remove symbols not intended to be public
    
    * No need of def file anymore
    
    * Fix whitespace
    
    * No need of configure option
    
    * Remove export macro from definitions
    
    * Remove blas export macro from definitions

commit 4ed39c0971c7917e2675cf5449f563b1f4751ccc
Merge: 540ec1b4 b938c16b
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Mar 8 11:56:58 2019 -0600

    Merge branch 'amd' of github.com:flame/blis into amd

commit b938c16b0c9e839335ac2c14944b82890143d02f
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Mar 7 16:40:39 2019 -0600

    Renamed test/3m4m to test/3.
    
    Details:
    - Renamed '3m4m' directory to '3', which captures the directory nicely
      since it builds test drivers to test level-3 operations.
    - These test drivers ceased to be used to test the 3m and 4m (or even
      1m) induced methods long ago, hence the name change.

commit ab89a40582ec7acf802e59b0763bed099a02edd8
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Mar 7 16:26:12 2019 -0600

    More minor updates and edits to test/3m4m.
    
    Details:
    - Further updates to matlab scripts, mostly for compatibility with
      GNU Octave.
    - More tweaks to runme.sh.
    - Updates to runme.m that allow copy-paste into matlab interactive
      session to generate graphs.

commit f0e70dfbf3fee4c4e382c2c4e87c25454cbc79a1
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Mar 7 01:04:05 2019 +0000

    Very minor updates to test/3m4m for ul252.
    
    Details:
    - Very minor updates to the newly revamped test/3m4m drivers when used
      on a Xeon Platinum (SkylakeX).

commit 7fe44748383071f1cbbc77d904f4ae5538e13065
Author: Kiran Varaganti <Kiran.Varaganti@amd.com>
Date:   Wed Mar 6 16:23:31 2019 +0530

    Disabled BLIS_ENABLE_ZEN_BLOCK_SIZES in bli_family_zen.h for ROME tuning
    
    Change-Id: Iec47fcf51f4d4396afef1ce3958e58cf02c59a57

commit 9f1dbe572b1fd5e7dd30d5649bdf59259ad770d5
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Mar 5 17:47:55 2019 -0600

    Overhauled test/3m4m Makefile and scripts.
    
    Details:
    - Rewrote much of Makefile to generate executables for single- and dual-
      socket multithreading as well as single-threaded. Each of the three
      can also use a different problem size range/increment, as is often
      appropriate when doubling/halving the number of threads.
    - Rewrote runme.sh script to flexibly execute as many threading
      parameter scenarios as is given in the input parameter string
      (currently set within the script itself). The string also encodes
      the maximum problem size for each threading scenario, which is used
      to identify the executable to run. Also improved the "progress" output
      of the script to reduce redundant info and improve readability in
      terminals that are not especially wide.
    - Minor updates to test_*.c source files.
    - Updated matlab scripts according to changes made to the Makefile,
      test drivers, and runme.sh script, and renamed 'plot_all.m' to
      'runme.m'.

commit f5ed95ecd7d5eb4a63e1333ad5cc6765fc8df9fe
Author: Kiran Varaganti <Kiran.Varaganti@amd.com>
Date:   Tue Mar 5 15:01:57 2019 +0530

    Merged BLIS Release 1.3
    Modified config/zen/make_defs.mk, now CKVECFLAGS     := -mavx2 -mfpmath=sse -mfma -march=znver1
    
    Change-Id: Ia0942d285a21447cd0c470de1bc021fe63e80d81

commit 3bdab823fa93342895bf45d812439324a37db77c
Merge: 70f12f20 e2a02ebd
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Feb 28 14:07:24 2019 -0600

    Merge branch 'master' into dev

commit e2a02ebd005503c63138d48a2b7d18978ee29205
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Feb 28 13:58:59 2019 -0600

    Updates (from ls5) to test/3m4m/runme.sh.
    
    Details:
    - Lonestar5-specific updates to runme.sh.

commit f0dcc8944fa379d53770f5cae5d670140918f00c
Author: Isuru Fernando <isuruf@gmail.com>
Date:   Wed Feb 27 17:27:23 2019 -0600

    Add symbol export macro for all functions (#302)
    
    * initial export of blis functions
    
    * Regenerate def file for master
    
    * restore bli_extern_defs exporting for now

commit 540ec1b479712d5e1da637a718927249c15d867f
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Sun Feb 24 19:09:10 2019 -0600

    Updated level-3 BLAS to call object API directly.
    
    Details:
    - Updated the BLAS compatibility layer for level-3 operations so that
      the corresponding BLIS object API is called directly rather than first
      calling the typed BLIS API. The previous code based on the typed BLIS
      API calls is still available in a deactivated cpp macro branch, which
      may be re-activated by #defining BLIS_BLAS3_CALLS_TAPI. (This does not
      yet correspond to a configure option. If it seems like people might
      want to toggle this behavior more regularly, a configure option can be
      added in the future.)
    - Updated the BLIS typed API to statically "pre-initialize" objects via
      new initializor macros. Initialization is then finished via calls to
      static functions bli_obj_init_finish_1x1() and bli_obj_init_finish(),
      which are similar to the previously-called functions,
      bli_obj_create_1x1_with_attached_buffer() and
      bli_obj_create_with_attached_buffer(), respectively. (The BLAS
      compatibility layer updates mentioned above employ this new technique
      as well.)
    - Transformed certain routines in bli_param_map.c--specifically, the
      ones that convert netlib-style parameters to BLIS equivalents--into
      static functions, now in bli_param_map.h. (The remaining three classes
      of conversation routines were left unchanged.)
    - Added the aforementioned pre-initializor macros to bli_type_defs.h.
    - Relocated bli_obj_init_const() and bli_obj_init_constdata() from
      bli_obj_macro_defs.h to bli_type_defs.h.
    - Added a few macros to bli_param_macro_defs.h for testing domains for
      real/complexness and precisions for single/double-ness.

commit 8e023bc914e9b4ac1f13614feb360b105fbe44d2
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Feb 22 16:55:30 2019 -0600

    Updates to 3m4m/matlab scripts.
    
    Details:
    - Minor updates to matlab graph-generating scripts.
    - Added a plot_all.m script that is more of a scratchpad for copying and
      pasting function invocations into matlab to generate plots that are
      presently of interest to us.

commit b06244d98cc468346eb1a8eb931bc05f35ff280c
Merge: e938ff08 4c7e6680
Author: praveeng <praveen.g@amd.com>
Date:   Thu Feb 21 12:56:15 2019 +0530

    Merge branch 'ut-austin-amd' of ssh://git.amd.com:29418/cpulibraries/er/blis into ut-austin-amd

commit e938ff08cea3d108c84524eb129d9e89d701ea90
Author: praveeng <praveen.g@amd.com>
Date:   Thu Feb 21 12:44:38 2019 +0530

    deleted test.txt
    
    Change-Id: I3871f5fe76e548bc29ec2733745b29964e829dd3

commit ed13ad465dcba350ad3d5e16c9cc7542e33f3760
Author: mkv <Mallikarjuna-Reddy.K-V@amd.com>
Date:   Thu Feb 21 01:04:16 2019 -0500

    added test file for initial commit

commit 4c7e6680832b497468cf50c2399e3ac4de0e3450
Author: praveeng <praveen.g@amd.com>
Date:   Thu Feb 21 12:44:38 2019 +0530

    deleted test.txt
    
    Change-Id: I3871f5fe76e548bc29ec2733745b29964e829dd3

commit 95e070581c54ed2edc211874faec56055ea298c8
Author: mkv <Mallikarjuna-Reddy.K-V@amd.com>
Date:   Thu Feb 21 01:04:16 2019 -0500

    added test file for initial commit

commit 70f12f209bc1901b5205902503707134cf2991a0
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Feb 20 16:10:10 2019 -0600

    Changed unsafe-loop to unsafe-math optimizations.
    
    Details:
    - Changed -funsafe-loop-optimizations (re-)introduced in 7690855 for
      make_defs.mk files' CRVECFLAGS to -funsafe-math-optimizations (to
      account for a miscommunication in issue #300). Thanks to Dave Love
      for this suggestion and Jeff Hammond for his feedback on the topic.

commit 7690855c5106a56e5b341a350f8db1c78caacd89
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Feb 18 19:16:01 2019 -0600

    Restored -funsafe-loop-optimizations to subconfigs.
    
    Details:
    - Restored use of -funsafe-loop-optimizations in the definitions of
      CRVECFLAGS (when using gcc), but only for sub-configurations (and
      not configuration families such as amd64, intel64, and x86_64).
      This more or less reverts 5190d05 and 6cf1550.

commit 44994d1490897b08cde52a615a2e37ddae8b2061
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Feb 18 18:35:30 2019 -0600

    Disable TBM, XOP, LWP instructions in AMD configs.
    
    Details:
    - Added -mno-tbm -mno-xop -mno-lwp to CKVECFLAGS in bulldozer,
      piledriver, steamroller, and excavator configurations to explicitly
      disable AMD's bulldozer-era TBM, XOP, and LWP instruction sets in an
      attempt to fix the invalid instruction error that has plagued Travis
      CI builds since 6a014a3. Thanks to Devin Matthews for pointing out
      that the offending instruction was part of TBM (issue #300).
    - Restored -O3 to piledriver configuration's COPTFLAGS.

commit 1e5b530744c1906140d47f43c5cad235eaa619cf
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Feb 18 18:04:38 2019 -0600

    Reverted piledriver COPTFLAGS from -O3 to -O2.
    
    Details:
    - Debugging continues; changing COPTFLAGS for piledriver subconfig from
      -O3 to -O2, its original value prior to 6a014a3.

commit 6cf155049168652c512aefdd16d74e7ff39b98df
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Feb 18 17:29:51 2019 -0600

    Removed -funsafe-loop-optimizations from all configs.
    
    Details:
    - Error persists. Removed -funsafe-loop-optimizations from all remaining
      sub-configurations.

commit 5190d05a27c5fa4c7942e20094f76eb9a9785c3e
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Feb 18 17:07:35 2019 -0600

    Removed -funsafe-loop-optimizations from piledriver.
    
    Details:
    - Error persists; continuing debugging from bf0fb78c by removing
      -funsafe-loop-optimizations from piledriver configuration.

commit bf0fb78c5e575372060d22f5ceeb5b332e8978ec
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Feb 18 16:51:38 2019 -0600

    Removed -funsafe-loop-optimizations from families.
    
    Details:
    - Removed -funsafe-loop-optimizations from the configuration families
      affected by 6a014a3, specifically: intel64, amd64, and x86_64.
      This is part of an attempt to debug why the sde, as executed by
      Travis CI, is crashing via the following error:
    
        TID 0 SDE-ERROR: Executed instruction not valid for specified chip
        (ICELAKE): 0x9172a5: bextr_xop rax, rcx, 0x103

commit 6a014a3377a2e829dbc294b814ca257a2bfcb763
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Feb 18 14:52:29 2019 -0600

    Standardized optimization flags in make_defs.mk.
    
    Details:
    - Per Dave Love's recommendation in issue #300, this commit defines
        COPTFLAGS := -03
      and
        CRVECFLAGS := $(CKVECFLAGS) -funsafe-loop-optimizations
      in the make_defs.mk for all Intel- and AMD-based configurations.

commit 565fa3853b381051ac92cff764625909d105644d
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Feb 18 11:43:58 2019 -0600

    Redirect trsm pc, ir parallelism to ic, jr loops.
    
    Details:
    - trsm parallelization was temporarily simplifed in 075143d to entirely
      ignore any parallelism specified via the pc or ir loops. Now, any
      parallelism specified to the pc loop will be redirected to the ic
      loop, and any parallelism specified to the ir loop will be redirected
      to the jr loop. (Note that because of inter-iteration dependencies,
      trsm cannot parallelize the ir loop. Parallelism via the pc loop is
      at least somewhat feasible in theory, but it would require tracking
      dependencies between blocks--something for which BLIS currently lacks
      the necessary supporting infrastructure.)

commit a023c643f25222593f4c98c2166212561d030621
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Feb 14 20:18:55 2019 -0600

    Regenerated symbols in build/libblis-symbols.def.
    
    Details:
    - Reran ./build/regen-symbols.sh after running
      'configure --enable-cblas auto'

commit 075143dfd92194647da9022c1a58511b20fc11f3
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Feb 14 18:52:45 2019 -0600

    Added support for IC loop parallelism to trsm.
    
    Details:
    - Parallelism within the IC loop (3rd loop around the microkernel) is
      now supported within the trsm operation. This is done via a new branch
      on each of the control and thread trees, which guide execution of a
      new trsm-only subproblem from within bli_trsm_blk_var1(). This trsm
      subproblem corresponds to the macrokernel computation on only the
      block of A that contains the diagonal (labeled as A11 in algorithms
      with FLAME-like partitioning), and the corresponding row panel of C.
      During the trsm subproblem, all threads within the JC communicator
      participate and parallelize along the JR loop, including any
      parallelism that was specified for the IC loop. (IR loop parallelism
      is not supported for trsm due to inter-iteration dependencies.) After
      this trsm subproblem is complete, a barrier synchronizes all
      participating threads and then they proceed to apply the prescribed
      BLIS_IC_NT (or equivalent) ways of parallelism (and any BLIS_JR_NT
      parallelism specified within) to the remaining gemm subproblem (the
      rank-k update that is performed using the newly updated row-panel of
      B). Thus, trsm now supports JC, IC, and JR loop parallelism.
    - Modified bli_trsm_l_cntl_create() to create the new "prenode" branch
      of the trsm_l cntl_t tree. The trsm_r tree was left unchanged, for
      now, since it is not currently used. (All trsm problems are cast in
      terms of left-side trsm.)
    - Updated bli_cntl_free_w_thrinfo() to be able to free the newly shaped
      trsm cntl_t trees. Fixed a potentially latent bug whereby a cntl_t
      subnode is only recursed upon if there existed a corresponding
      thrinfo_t node, which may not always exist (for problems too small
      to employ full parallelization due to the minimum granularity imposed
      by micropanels).
    - Updated other functions in frame/base/bli_cntl.c, such as
      bli_cntl_copy() and bli_cntl_mark_family(), to recurse on sub-prenodes
      if they exist.
    - Updated bli_thrinfo_free() to recurse into sub-nodes and prenodes
      when they exist, and added support for growing a prenode branch to
      bli_thrinfo_grow() via a corresponding set of help functions named
      with the _prenode() suffix.
    - Added a bszid_t field thrinfo_t nodes. This field comes in handy when
      debugging the allocation/release of thrinfo_t nodes, as it helps trace
      the "identity" of each nodes as it is created/destroyed.
    - Renamed
        bli_l3_thrinfo_print_paths() -> bli_l3_thrinfo_print_gemm_paths()
      and created a separate bli_l3_thrinfo_print_trsm_paths() function to
      print out the newly reconfigured thrinfo_t trees for the trsm
      operation.
    - Trival changes to bli_gemm_blk_var?.c and bli_trsm_blk_var?.c
      regarding variable declarations.
    - Removed subpart_t enum values BLIS_SUBPART1T, BLIS_SUBPART1B,
      BLIS_SUBPART1L, BLIS_SUBPART1R. Then added support for two new labels
      (semantically speaking): BLIS_SUBPART1A and BLIS_SUBPART1B, which
      represent the subpartition ahead of and behind, respectively,
      BLIS_SUBPART1. Updated check functions in bli_check.c accordingly.
    - Shuffled layering/APIs for bli_acquire_mpart_[mn]dim() and
      bli_acquire_mpart_t2b/b2t(), _l2r/r2l().
    - Deprecated old functions in frame/3/bli_l3_thrinfo.c.

commit 78bc0bc8b6b528c79b11f81ea19250a1db7450ed
Author: Nicholai Tukanov <nicholai@utexas.edu>
Date:   Thu Feb 14 13:29:02 2019 -0600

    Power9 sub-configuration  (#298)
    
    Formally registered power9 sub-configuration.
    
    Details:
    - Added and registered power9 sub-configuration into the build system.
      Thanks to Nicholai Tukanov and Devangi Parikh for these contributions.
    - Note: The sub-configuration does not yet have a corresponding
      architecture-specific kernel set registered, and so for now the
      sub-config is using the generic kernel set.

commit 6b832731261f9e7ad003a9ea4682e9ca973ef844
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Feb 12 16:01:28 2019 -0600

    Generalized ref kernels' pragma omp simd usage.
    
    Details:
    - Replaced direct usage of _Pragma( "omp simd" ) in reference kernels
      with PRAGMA_SIMD, which is defined as a function of the compiler being
      used in a new bli_pragma_macro_defs.h file. That definition is cleared
      when BLIS detects that the -fopenmp-simd command line option is
      unsupported. Thanks to Devin Matthews and Jeff Hammond for suggestions
      that guided this commit.
    - Updated configure and bli_config.h.in so that the appropriate anchor
      is substituted in (when the corresponding pragma omp simd support is
      present).

commit b1f5ce8622b682b79f956fed83f04a60daa8e0fc
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Feb 5 17:38:50 2019 -0600

    Minor updates to scripts in test/mixeddt/matlab.

commit 38203ecd15b1fa50897d733daeac6850d254e581
Author: Devangi N. Parikh <dnp@cs.utexas.edu>
Date:   Mon Feb 4 15:28:28 2019 -0500

    Added thunderx2 system in the mixeddt test scripts
    
    Details:
     - Added thunderx2 (tx2) as a system in the runme.sh in test/mixeddt

commit dfc91843ea52297bf636147793029a0c1345be04
Author: Devangi N. Parikh <dnp@cs.utexas.edu>
Date:   Mon Feb 4 15:23:40 2019 -0500

    Fixed gcc flags for thunderx2 subconfiguration
    
    Details:
    - Fixed -march flag. Thunderx2 is an armv8.1a architecture not armv8a.

commit c665eb9b888ec7e41bd0a28c4c8ac4094d0a01b5
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Jan 28 16:22:23 2019 -0600

    Minor updates to docs, Makefiles.
    
    Details:
    - Changed all occurrances of
        micro-kernel -> microkernel
        macro-kernel -> macrokernel
        micro-panel  -> micropanel
      in all markdown documents in 'docs' directory. This change is being
      made since we've reached the point in adoption and acceptance of
      BLIS's insights where words such as "microkernel" are no longer new,
      and therefore now merit being unhyphenated.
    - Updated "Implementation Notes" sections of KernelsHowTo.md, which
      still contained references to nonexistent cpp macros such as
      BLIS_DEFAULT_MR_? and BLIS_PACKDIM_MR_?.
    - Added 'run-fast' and 'check-fast' targets to testsuite/Makefile.
    - Minor updates to Testsuite.md, including suggesting use of
      'make check' and 'make check-fast' when running from the local
      testsuite directory.
    - Added a comment to top-level Makefile explaining the purpose behind
      the TESTSUITE_WRAPPER variable, which at first glance appears to serve
      no purpose.

commit 1aa280d0520ed5eaea3b119b4e92b789ecad78a4
Author: M. Zhou <5723047+cdluminate@users.noreply.github.com>
Date:   Sun Jan 27 21:40:48 2019 +0000

    Amend OS detection for kFreeBSD. (#295)

commit fffc23bb35d117a433886eb52ee684ff5cf6997f
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Jan 25 13:35:31 2019 -0600

    CREDITS file update.

commit 26c5cf495ce22521af5a36a1012491213d5a4551
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Jan 24 18:49:31 2019 -0600

    Fixed bug in skx subconfig related to bdd46f9.
    
    Details:
    - Fixed code in the skx subconfiguration that became a bug after
      committing bdd46f9. Specifically, the bli_cntx_init_skx() function
      was overwriting default blocksizes for the scomplex and dcomplex
      microkernels despite the fact that only single and double real
      microkernels were being registered. This was not a problem prior to
      bdd46f9 since all microkernels used dynamically-queried (at runtime)
      register blocksizes for loop bounds. However, post-bdd46f9, this
      became a bug because the reference ukernels for scomplex and dcomplex
      were written with their register blocksizes hard-coded as constant
      loop bounds, which conflicted the the erroneous scomplex and dcomplex
      values that bli_cntx_init_skx() was setting in the context. The
      lesson here is that going forward, all subconfigurations must not set
      any blocksizes for datatypes corresponding to default/reference
      microkernels. (Note that a blocksize is left unchanged by the
      bli_cntx_set_blkszs() function if it was set to -1.)

commit 180f8e42e167b83a757340ad4bd4a5c7a1d6437b
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Jan 24 18:01:15 2019 -0600

    Fixed undefined behavior trsm ukr bug in bdd46f9.
    
    Details:
    - Fixed a bug that mainfested anytime a configuration was used in which
      optimized microkernels were registered and the trsm operation (or
      kernel) was invoked. The bug resulted from the optimized microkernels'
      register blocksizes conflicting with the hard-coded values--expressed
      in the form of constant loop bounds--used in the new reference trsm
      ukernels that were introduced in bdd46f9. The fix was easy: reverting
      back to the implementation that uses variable-bound loops, which
      amounted to changing an #if 0 to #if 1 (since I preserved the older
      implementation in the file alongside the new code based on constant-
      bound loops). It should be noted that this fix must be permanent,
      since the trsm kernel code with constant-bound loops can never work
      with gemm ukernels that use different register blocksizes.

commit bdd46f9ee88057d52610161966a11c224e5a026c
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Jan 24 17:23:18 2019 -0600

    Rewrote reference kernels to use #pragma omp simd.
    
    Details:
    - Rewrote level-1v, -1f, and -3 reference kernels in terms of simplified
      indexing annotated by the #pragma omp simd directive, which a compiler
      can use to vectorize certain constant-bounded loops. (The new kernels
      actually use _Pragma("omp simd") since the kernels are defined via
      templatizing macros.) Modest speedup was observed in most cases using
      gcc 5.4.0, which may improve with newer versions. Thanks to Devin
      Matthews for suggesting this via issue #286 and #259.
    - Updated default blocksizes defined in ref_kernels/bli_cntx_ref.c to
      be 4x16, 4x8, 4x8, and 4x4 for single, double, scomplex and dcomplex,
      respectively, with a default row preference for the gemm ukernel. Also
      updated axpyf, dotxf, and dotxaxpyf fusing factors to 8, 6, and 4,
      respectively, for all datatypes.
    - Modified configure to verify that -fopenmp-simd is a valid compiler
      option (via a new detect/omp_simd/omp_simd_detect.c file).
    - Added a new header in which prefetch macros are defined according to
      which compiler is detected (via macros such as __GNUC__). These
      prefetch macros are not yet employed anywhere, though.
    - Updated the year in copyrights of template license headers in
      build/templates and removed AMD as a default copyright holder.

commit 63de2b0090829677755eb5cdb27e73bc738da32d
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Jan 23 12:16:27 2019 -0600

    Prevent redef of ftnlen in blastest f2c_types.h.
    
    Details:
    - Guard typedef of ftnlen in f2c_types.h with a #ifndef HAVE_BLIS_H
      directive to prevent the redefinition of that type. Thanks to Jeff
      Diamond for reporting this compiler warning (and apologies for the
      delay in committing a fix).

commit eec2e183a7b7d67702dbd1f39c153f38148b2446
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Jan 21 12:12:18 2019 -0600

    Added escaping to '/' in os_name in configure.
    
    Details:
    - Add os_name to the list of variables into which the '/' character is
      escaped. This is meant to address (or at least make progress toward
      addressing) #293. Thanks to Isuru Fernando for spotting this as the
      potential fix, and also thanks to M. Zhou for the original report.

commit adf5c17f0839fdbc1f4a1780f637928b1e78e389
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Jan 18 15:14:45 2019 -0600

    Formally registered thunderx2 subconfiguration.
    
    Details:
    - Added a separate subconfiguration for thunderx2, which now uses
      different optimization flags than cortexa57/cortexa53.

commit 094cfdf7df6c2764c25fcbfce686ba29b933942c
Author: M. Zhou <5723047+cdluminate@users.noreply.github.com>
Date:   Fri Jan 18 18:46:13 2019 +0000

    Port BLIS to GNU Hurd OS. (#294)
    
    Prevent blis.h from misidentifying Hurd as OSX.

commit 5d7d616e8e591c2f3c7c2d73220eb27ea484f9c9
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Jan 15 20:52:51 2019 -0600

    README.md update re: mixeddt TOMS paper.

commit 58c7fb4788177487f73a3964b7a910fe4dc75941
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Jan 8 17:00:27 2019 -0600

    Added more matlab scripts for mixeddt paper.
    
    Details:
    - Added a variant set of matlab scripts geared to producing plots that
      reflect performance data gathered with and without extra memory
      optimizations enabled. These scripts reside (for now) in
      test/mixeddt/matlab/wawoxmem.

commit 34286eb914b48b56cdda4dfce192608b9f86d053
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Jan 8 11:41:20 2019 -0600

    Minor update to docs/HardwareSupport.md.

commit 108b04dc5b1b1288db95f24088d1e40407d7bc88
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Jan 7 20:16:31 2019 -0600

    Regenerated symbols in build/libblis-symbols.def.
    
    Details:
    - Reran ./build/regen-symbols.sh after running
      'configure --enable-cblas auto' to reflect removal of
      bli_malloc_pool() and bli_free_pool().

commit 706cbd9d5622f4690e6332a89cf41ab5c8771899
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Jan 7 18:28:19 2019 -0600

    Minor tweaks/cleanups to bli_malloc.c, _apool.c.
    
    Details:
    - Removed malloc_ft and free_ft function pointer arguments from the
      interface to bli_apool_init() after deciding that there is no need to
      specify the malloc()/free() for blocks within the apool. (The apool
      blocks are actually just array_t structs.) Instead, we simply call
      bli_malloc_intl()/_free_intl() directly. This has the added benefit
      of allowing additional output when memory tracing is enabled via
      --enable-mem-tracing. Also made corresponding changes elsewhere in
      the apool API.
    - Changed the inner pools (elements of the array_t within the apool_t)
      to use BLIS_MALLOC_POOL and BLIS_FREE_POOL instead of BLIS_MALLOC_INTL
      and BLIS_FREE_INTL.
    - Disabled definitions of bli_malloc_pool() and bli_free_pool() since
      there are no longer any consumers of these functions.
    - Very minor comment / printf() updates.

commit 579145039d945adbcad1177b1d53fb2d3f2e6573
Author: Minh Quan Ho <1337056+hominhquan@users.noreply.github.com>
Date:   Mon Jan 7 23:00:15 2019 +0100

    Initialize error messages at compile time (#289)
    
    * Initialize error messages at compile time
    
    - Assigning strings directly to the bli_error_string array, instead of
    snprintf() at execution-time.
    
    * Retired bli_error_init(), _finalize().
    
    Details:
    - Removed functions obviated by changes in 80e8dc6: bli_error_init(),
      bli_error_finalize(), and bli_error_init_msgs(), as well as calls to
      the former two in bli_init.c.
    
    * Regenerated symbols in build/libblis-symbols.def.
    
    Details:
    - Reran ./build/regen-symbols.sh after running
      'configure --enable-cblas auto'.

commit aafbca086e36b6727d7be67e21fef5bd9ff7bfd9
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Jan 7 12:38:21 2019 -0600

    Updated external package language in README.md.
    
    Details:
    - Updated/added comments about Fedora, OpenSUSE, and GNU Guix under the
      newly-renamed "External GNU/Linux packages" section. Thanks to Dave
      Love for providing these revisions.

commit daacfe68404c9cc8078e5e7ba49a8c7d93e8cda3
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Jan 7 12:12:47 2019 -0600

    Allow running configure with python 3.4.
    
    Details:
    - Relax version blacklisting of python3 to allow 3.4 or later instead
      of 3.5 or later. Thanks to Dave Love for pointing out that 3.4 was
      sufficient for the purpose of BLIS's build system. (It should be
      noted that we're not sure which, if any, python3 versions prior to
      3.4 are insufficient, and that the only thing stopping us from
      determining this is the fact that these earlier versions of python3
      are not readily available for us to test with.)
    - Updated docs/BuildSystem.md to be explicit about current python2 vs
      python3 version requirements.

commit cdbf16aa93234e0d6a80f0d0e385ec81e7b75465
Author: prangana <pradeep.rao@amd.com>
Date:   Fri Jan 4 15:59:21 2019 +0530

    Update version 1.3
    
    Change-Id: I32a7d24af860e87a60396614075236afb65a28a9

commit cf9c1150515b8e9cc4f12e0d4787b3471b12ba4a
Author: kdevraje <Kiran.Devrajegowda@amd.com>
Date:   Thu Jan 3 09:51:46 2019 +0530

     This commit adds a macro, which is to be enabled when BLIS is working on single instance mode
    
    Change-Id: I7f3fd654b78e64c4e6e24e9f0e245b1a30c492b0

commit ad8d9adb09a7dd267bbdeb2bd1fbbf9daf64ee76
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Jan 3 16:08:24 2019 -0600

    README.md, CREDITS update.
    
    Details:
    - Added "What's New" and "What People Are Saying About BLIS" sections to
      README.md.
    - Added missing github handles to various individuals' entries in the
      CREDITS file.

commit 7052fca5aef430241278b67d24cef6fe33106904
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Jan 2 13:48:40 2019 -0600

    Apply f272c289 to bli_fmalloc_noalign().
    
    Details:
    - Perform the same check for NULL return values and error message output
      in bli_fmalloc_noalign() as is performed by bli_fmalloc_align(). (This
      change was intended for f272c289.)

commit 528e3ad16a42311a852a8376101959b4ccd801a5
Merge: 3126c52e f272c289
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Jan 2 13:39:19 2019 -0600

    Merge branch 'amd'

commit 3126c52ea795ffb7d30b16b7f7ccc2a288a6158d
Merge: 61441b24 8091998b
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Jan 2 13:37:37 2019 -0600

    Merge branch 'amd'

commit f272c2899a6764eedbe05cea874ee3bd258dbff3
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Jan 2 12:34:15 2019 -0600

    Add error message to malloc() check for NULL.
    
    Details:
    - Output an error message if and when the malloc()-equivalent called by
      bli_fmalloc_align() ever returns NULL. Everything was already in place
      for this to happen, including the error return code, the error string
      sprintf(), the error checking function bli_check_valid_malloc_buf()
      definition, and its prototype. Thanks to Minh Quan Ho for pointing out
      the missing error message.
    - Increased the default block_ptrs_len for each inner pool stored in the
      small block allocator from 10 to 25. Under normal execution, each
      thread uses only 21 blocks, so this change will prevent the sba from
      needing to resize the block_ptrs array of any given inner pool as
      threads initially populate the pool with small blocks upon first
      execution of a level-3 operation.
    - Nix stray newline echo in configure.

commit eb97f778a1e13ee8d3b3aade05e479c4dfcfa7c0
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Dec 25 20:17:09 2018 -0600

    Added missing AMD copyrights to previous commit.
    
    Details:
    - Forgot to add AMD copyrights to several touched files that did not
      already have them in 2f31743.

commit 2f3174330fb29164097d664b7c84e05c7ced7d95
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Dec 25 19:35:01 2018 -0600

    Implemented a pool-based small block allocator.
    
    Details:
    - Implemented a sophisticated data structure and set of APIs that track
      the small blocks of memory (around 80-100 bytes each) used when
      creating nodes for control and thread trees (cntl_t and thrinfo_t) as
      well as thread communicators (thrcomm_t). The purpose of the small
      block allocator, or sba, is to allow the library to transition into a
      runtime state in which it does not perform any calls to malloc() or
      free() during normal execution of level-3 operations, regardless of
      the threading environment (potentially multiple application threads
      as well as multiple BLIS threads). The functionality relies on a new
      data structure, apool_t, which is (roughly speaking) a pool of
      arrays, where each array element is a pool of small blocks. The outer
      pool, which is protected by a mutex, provides separate arrays for each
      application thread while the arrays each handle multiple BLIS threads
      for any given application thread. The design minimizes the potential
      for lock contention, as only concurrent application threads would
      need to fight for the apool_t lock, and only if they happen to begin
      their level-3 operations at precisely the same time. Thanks to Kiran
      Varaganti and AMD for requesting this feature.
    - Added a configure option to disable the sba pools, which are enabled
      by default; renamed the --[dis|en]able-packbuf-pools option to
      --[dis|en]able-pba-pools; and rewrote the --help text associated with
      this new option and consolidated it with the --help text for the
      option associated with the sba (--[dis|en]able-sba-pools).
    - Moved the membrk field from the cntx_t to the rntm_t. We now pass in
      a rntm_t* to the bli_membrk_acquire() and _release() APIs, just as we
      do for bli_sba_acquire() and _release().
    - Replaced all calls to bli_malloc_intl() and bli_free_intl() that are
      used for small blocks with calls to bli_sba_acquire(), which takes a
      rntm (in addition to the bytes requested), and bli_sba_release().
      These latter two functions reduce to the former two when the sba pools
      are disabled at configure-time.
    - Added rntm_t* arguments to various cntl_t and thrinfo_t functions, as
      required by the new usage of bli_sba_acquire() and _release().
    - Moved the freeing of "old" blocks (those allocated prior to a change
      in the block_size) from bli_membrk_acquire_m() to the implementation
      of the pool_t checkout function.
    - Miscellaneous improvements to the pool_t API.
    - Added a block_size field to the pblk_t.
    - Harmonized the way that the trsm_ukr testsuite module performs packing
      relative to that of gemmtrsm_ukr, in part to avoid the need to create
      a packm control tree node, which now requires a rntm_t that has been
      initialized with an sba and membrk.
    - Re-enable explicit call bli_finalize() in testsuite so that users who
      run the testsuite with memory tracing enabled can check for memory
      leaks.
    - Manually imported the compact/minor changes from 61441b24 that cause
      the rntm to be copied locally when it is passed in via one of the
      expert APIs.
    - Reordered parameters to various bli_thrcomm_*() functions so that the
      thrcomm_t* to the comm being modified is last, not first.
    - Added more descriptive tracing for allocating/freeing small blocks and
      formalized via a new configure option: --[dis|en]able-mem-tracing.
    - Moved some unused scalm code and headers into frame/1m/other.
    - Whitespace changes to bli_pthread.c.
    - Regenerated build/libblis-symbols.def.

commit 61441b24f3244a4b202c29611a4899dd5c51d3a1
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Dec 20 19:38:11 2018 -0600

    Make local copy of user's rntm_t in level-3 ops.
    
    Details:
    - In the case that the caller passes in a non-NULL rntm_t pointer into
      one of the expert APIs for a level-3 operation (e.g. bli_gemm_ex()),
      make a local copy of the rntm_t and use the address of that local copy
      in all subsequent execution (which may change the contents of the
      rntm_t). This prevents a potentially confusing situation whereby a
      user-initialized rntm_t is used once (in, say, gemm), and then found
      by the user to be in a different state before it is used a second
      time.

commit e809b5d2f1023b4249969e2f516291c9a3a00b80
Merge: 76016691 0476f706
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Dec 20 16:27:26 2018 -0600

    Merge branch 'master' into amd

commit 1f4eeee5175a8fc9ac312847c796ce6db5fe75b9
Author: sraut <Biplab.Raut@amd.com>
Date:   Wed Dec 19 21:21:10 2018 +0530

    Fixed BLAS test failures of small matrix SYRK for single and double precision.
    
    Details:
    - SYRK for small matrix was implemented by reusing small GEMM routine. This was
      resulting in output written to the full C matrix, and C being symmetric the
      lower and upper triangles of C matrix contained same results. BLAS SYRK API
      spec demands either lower or upper triangle of C matrix to be written with
      results. So, this was resulting in BLAS test failures, even though testsuite
      of BLIS was passing small SYRK operation.
    - To fix BLAS test failures of small matrix SYRK, separate kernel routines are
      implemented for small SYRK for both single and double precision. The newly
      added small SYRK routines are in file kernels/zen/3/bli_syrk_small.c.
      Now the intermediate results of matrix C are written to a scratch buffer.
      Final results are written from scratch buffer to matrix C using SIMD
      copy to either lower or upper traingle part of matrix C.
    - Source and header files frame/3/syrk/bli_syrk_front.c and
      frame/3/syrk/bli_syrk_front.h are changed to invoke new small SYRK routines.
    
    Change-Id: I9cfb1116c93d150aefac673fca033952ecac97cb

commit 6d267375c3a0543f20604d74cc678ad91db3b6f1
Author: sraut <Biplab.Raut@amd.com>
Date:   Wed Dec 19 14:22:21 2018 +0530

    This commit improves the performance of multi-instance DGEMM when these multiple threads are binded to a CCX.
    Multi-Instance: Each thread runs a sequential DGEMM.
    Change-Id: I306920c8061b6dad61efac1dae68727f4ac27df6

commit 0476f706b93e83f6b74a3d7b7e6e9cc9a1a52c3b
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Dec 18 14:56:20 2018 -0600

    CHANGELOG update (0.5.1)

commit e0408c3ca3d53bc8e6fedac46ea42c86e06c922d (tag: 0.5.1)
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Dec 18 14:56:16 2018 -0600

    Version file update (0.5.1)

commit 3ab231afc9f69d14493908c53c85a84c5fba58aa
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Dec 18 14:53:37 2018 -0600

    ReleaseNotes.md update in advance of next version.
    
    Details:
    - Updated ReleaseNotes.md in preparation for next version.

commit d1aa87164e1e82347d62aa98793963c5265ef7e7
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Dec 18 14:52:40 2018 -0600

    README.md update (External packages section).
    
    Details:
    - Updated External packages section in anticipation of introducing BLIS
      into Debian package universe. Thanks to M. Zhou for sponsoring BLIS in
      Debian.

commit 7bf901e9265a1acd78e44c06f7178c8152c7e267
Author: sraut <Biplab.Raut@amd.com>
Date:   Tue Dec 18 14:39:16 2018 +0530

    Fix on EPYC machine for multi instance performance issue,
    Issue: For the default values of mc, kc and nc with multi instance mode the performance across the cores dip drastically.
    Fix: After experimentation found different set of values (mc, kc and nc) which fits in the cache size, and performance across the remains same across all the cores.
    
    Change-Id: I98265e3b7e61cd7602a0cc5596240e86c08c03fe

commit d2b2a0819a2fccad9165bc48c0e172d79a87542c
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Dec 17 19:26:35 2018 -0600

    Removed stray sections from Multithreading.md.
    
    Details:
    - Removed unintended section headers from before table of contents.

commit 93d56319f2953cf0e9df1ff2cda90b8e41351b2c
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Dec 17 19:17:30 2018 -0600

    Added missing bli_init_once() in bli_thread API.
    
    Details:
    - Fixed an issue with specifying threading globally at runtime via
      bli_thread_set_num_threads() (the automatic way) or via
      bli_thread_set_ways() (the manual way), with bli_thread_init_rntm()
      also affected. These functions were not calling bli_init_once() prior
      to acting, and therefore their effects on the global rntm_t structure
      were being wiped out by the eventual call to bli_init_once(), by some
      other BLIS function. Thanks to Ali Emre Gülcü for reporting the
      behavior associated with this bug.
    - Added additional content to docs/Multithreading.md covering topics of
      choosing between OpenMP and pthreads, and specifying affinity via
      OpenMP.
    - CREDITS file update.

commit 76016691e2c514fcb59f940c092475eda968daa2
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Dec 13 17:23:09 2018 -0600

    Improvements to bli_pool; malloc()/free() tracing.
    
    Details:
    - Added malloc_ft and free_ft fields to pool_t, which are provided when
      the pool is initialized, to allow bli_pool_alloc_block() and
      bli_pool_free_block() to call bli_fmalloc_align()/bli_ffree_align()
      with arbitrary align_size values (according to how the pool_t was
      initialized).
    - Added a block_ptrs_len argument to bli_pool_init(), which allows the
      caller to specify an initial length for the block_ptrs array, which
      previously suffered the cost of being reallocated, copied, and freed
      each time a new block was added to the pool.
    - Consolidated the "buf_sys" and "buf_align" pointer fields in pblk_t
      into a single "buf" field. Consolidated the bli_pblk API accordingly
      and also updated the bli_mem API implementation. This was done
      because I'd previously already implemented opaque alignment via
      bli_malloc_align(), which allocates extra space and stores the
      original pointer returned by malloc() one element before the element
      whose address is aligned.
    - Tweaked bli_membrk_acquire_m() and bli_membrk_release() to call
      bli_fmalloc_align() and bli_ffree_align(), which required adding an
      align_size field to the membrk_t struct.
    - Pass the pack schemas directly into bli_l3_cntl_create_if() rather
      than transmit them via objects for A and B.
    - Simplified bli_l3_cntl_free_if() and renamed to bli_l3_cntl_free().
      The function had not been conditionally freeing control trees for
      quite some time. Also, removed obj_t* parameters since they aren't
      needed anymore (or never were).
    - Spun-off OpenMP nesting code in bli_l3_thread_decorator() to a
      separate function, bli_l3_thread_decorator_thread_check().
    - Renamed:
        bli_malloc_align()   -> bli_fmalloc_align()
        bli_free_align()     -> bli_ffree_align()
        bli_malloc_noalign() -> bli_fmalloc_noalign()
        bli_free_noalign()   -> bli_ffree_noalign()
      The 'f' is for "function" since they each take a malloc_ft or free_ft
      function pointer argument.
    - Inserted various printf() calls for the purposes of tracing memory
      allocation and freeing, guarded by cpp macro ENABLE_MEM_DEBUG, which,
      for now, is intended to be a "hidden" feature rather than one hooked
      up to a configure-time option.
    - Defined bli_rntm_equals(), which compares two rntm_t for equality.
      (There are no use cases for this function yet, but there may be soon.)
    - Whitespace changes to function parameter lists in bli_pool.c, .h.

commit f808d829c58dc4194cc3ebc3825fbdde12cd3f93
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Dec 12 15:22:59 2018 -0600

    Handle edge cases, zero-filling in packm kernels.
    
    Details:
    - Updated the API and semantics of packm kernels such that they must now
      handle edge cases, meaning that a c-by-k packm kernel must be able to
      pack edge cases that are fewer than c rows/columns and be able to
      zero-fill the remaining elements. They must also be able to zero-fill
      the equivalent region when copying fewer than k columns/rows (which is
      needed by trsm). The new packm kernel API is generally:
    
        void packm_kernel
             (
               conj_t           conja,
               dim_t            cdim,
               dim_t            n,
               dim_t            n_max,
               ctype*  restrict kappa,
               ctype*  restrict a, inc_t inca, inc_t lda,
               ctype*  restrict p,             inc_t ldp,
               cntx_t* restrict cntx
             );
    
      where cdim and n are the dimensions (short and long, respectively) of
      the submatrix being copied from the source matrix A, and n_max is the
      "full" long dimension (corresponding to the k dimension in gemm) of
      the micropanel. The "full" short dimension (corresponding to the
      register blocksize MR or NR) is not part of the API because it is
      known intrinsically by the packm kernel implementation. Thanks to
      Devin Matthews for prompting us to make this change (#282).
    - Updated all reference packm kernels in ref_kernels/1m according to
      above changes, as well as all optimized packm kernels (which only
      consisted of those for knl).
    - Bumped the major soname version number in 'so_version' to 2. At first
      I was considering leaving it unchanged, but I couldn't escape the
      reality that the packm kernel API is much closer to an expert API
      than it is some obscure helper function interface within the framework
      that nobody would ever notice.
    - Removed reference packm kernels for mr/nr = 30. The only sub-config
      that would have been using those kernels is knc, which is likely no
      longer being used by very many people (if any). (This also mostly
      offset the larger object code footprint incurred by moving the edge-
      case handling into the individual packm kernels.)
    - Fixed an obscure race condition for 3mh and 4mh induced methods in
      which those implementations were modifying the contexts stored in the
      gks rather than a local copy.
    - Fixed a minor bug in the testsuite that prevented non-1m-based induced
      method implementations of trsm from executing.

commit 02ec0be3ba0b0d6b4186386ae140906a96de919b
Merge: e275def3 c534da62
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Dec 5 19:33:53 2018 -0600

    Merge branch 'master' into amd

commit c534da62c0015f91391983da5376c9e091378010
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Dec 5 15:51:05 2018 -0600

    Disabled ARM configuration families in registry.
    
    Details:
    - Disabled (commented out) the arm32 and arm64 configuration families
      in the config_registry file. Having a configuration family registered
      only makes sense if BLIS is currently outfitted with runtime hardware
      detection logic to choose the appropriate sub-configuration. That
      logic is currently missing for ARM architectures, and thus having the
      ARM configuration families in the configuration registry only serves
      to confuse people. Thanks to Devangi Parikh for suggesting this
      change.

commit 6885051a164628904fad0d8a3b39c82f9a7b193c
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Dec 5 14:45:39 2018 -0600

    Generalizations/cleanup to mixeddt matlab scripts.
    
    Details:
    - Parameterized, reorganized, and added comments to matlab scripts in
      test/mixeddt/matlab.
    - Reordered some lines of code and added comments to plot_l3_perf.m in
      test/3m4m/matlab.

commit cbdb0566bf3201a495bbdcb8cb50342fa0098649
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Dec 5 20:06:32 2018 +0000

    Updates to 3m4m, mixeddt test driver files.
    
    Details:
    - Updated 3m4m and mixeddt Makefiles and runme.sh scripts, mostly to
      port recent changes to the former to the latter.
    - Disabled (for now) code in 3m4m/test_*.c files that disables all
      induced methods except for the one that is requested from the
      Makefile via the IND macro. This is done because usually, we want to
      test whatever method is enabled automatically for complex datatypes.
      (That is, when native complex microkernels are missing, we usually
      want to test performance of 1m.)

commit 0645f239fbdf37ee9d2096ee3bb0e76b3302cfff
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Dec 4 14:31:06 2018 -0600

    Remove UT-Austin from copyright headers' clause 3.
    
    Details:
    - Removed explicit reference to The University of Texas at Austin in the
      third clause of the license comment blocks of all relevant files and
      replaced it with a more all-encompassing "copyright holder(s)".
    - Removed duplicate words ("derived") from a few kernels' license
      comment blocks.
    - Homogenized license comment block in kernels/zen/3/bli_gemm_small.c
      with format of all other comment blocks.

commit 9b688a2d69dd420f4d2582827c5ac87e422cd3bc
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Dec 4 13:30:25 2018 -0600

    Refer to color mm algorithm in Multithreading.md.

commit 22384fd2b749aa8cfdfad1084ce5e7dbd4ad2d64
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Dec 4 13:09:04 2018 -0600

    Minor updates to test_gemm.c in test/mixeddt.

commit 2ba3b1780cbca58e43a3948d67bd07e637036125
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Dec 3 19:40:39 2018 -0600

    Removed symbols from libblis-symbols.def.
    
    Details:
    - Removed bli_gemm_md_front() and bli_gemm_md_zgemm() symbols from
      build/libblis-symbols.def, which will hopefully appease AppVeyor.

commit dcb38c4e59c3395c258799e69bfe2104c578c528
Merge: dc184095 375eb30b
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Dec 3 18:06:19 2018 -0600

    Merge branch 'dev'

commit 375eb30b0a63ac06a363a5f75f283584258db48b
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Dec 3 17:49:52 2018 -0600

    Added mixed-precision support to 1m method.
    
    Details:
    - Lifted the constraint that 1m only be used when all operands' storage
      datatypes (along with the computation datatype) are equal. Now, 1m may
      be used as long as all operands are stored in the complex domain. This
      change largely consisted of adding the ability to pack to 1e and 1r
      formats from one precision to another. It also required adding logic
      for handling complex values of alpha to bli_packm_blk_var1_md()
      (similar to the logic in bli_packm_blk_var1()).
    - Fixed a bug in several virtual microkernels (bli_gemm_md_c2r_ref.c,
      bli_gemm1m_ref.c, and bli_gemmtrsm1m_ref.c) that resulted in the wrong
      ukernel output preference field being read. Previously, the preference
      for the native complex ukernel was being read instead of the pref for
      the native real domain ukernel. This bug would not manifest if the
      preference for the native complex ukernel happened to be equal to that
      of the native real ukernel.
    - Added support for testing mixed-precision 1m execution via the gemm
      module of the testsuite.
    - Tweaked/simplified bli_gemm_front() and bli_gemm_md.c so that pack
      schemas are always read from the context, rather than trying to
      sometimes embed them directly to the A and B objects. (They are still
      embedded, but now uniformly only after reading the schemas from the
      context.)
    - Redefined cpp macro bli_l3_ind_recast_1m_params() as a static function
      and renamed to bli_gemm_ind_recast_1m_params() (since gemm is the only
      consumer).
    - Added 1m optimization logic (via bli_gemm_ind_recast_1m_params()) to
      bli_gemm_ker_var2_md().
    - Added explicit handling for beta == 1 and beta == 0 in the reference
      gemm1m virtual microkernel in ref_kernels/ind/bli_gemm1m_ref.c.
    - Rewrote various level-0 macro defs, including axpyris, axpbyris,
      scal2ris, and xpbyris (and their conjugating counterparts) to
      explicitly support three operand types and updated invocations to
      xpbyris in bli_gemmtrsm1m_ref.c.
    - Query and use the storage datatype of the packed object instead of the
      storage datatype of the source object in bli_packm_blk_var1().
    - Relocated and renamed frame/ind/misc/bli_l3_ind_opt.h to
      frame/3/gemm/ind/bli_gemm_ind_opt.h.
    - Various whitespace/comment updates.

commit e275def30ac41cadce296560fa67282704f20a02
Merge: 8091998b dc184095
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Nov 30 15:39:50 2018 -0600

    Merge branch 'master' into amd

commit dc18409551f341125169fe8d4d43ac45e81bdf28
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Nov 28 11:58:40 2018 -0600

    CREDITS file update.

commit ee4d2712963816f84d7e3fdd39d93424e1aaf63d
Merge: e81c4b56 3d7e8bc3
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Nov 28 11:52:57 2018 -0600

    Merge pull request #287 from SuperFluffy/fix_configuration_links
    
    Fix configuration links

commit 3d7e8bc3b8e77693152138e75676f71573e5e6cd
Author: Richard Janis Goldschmidt <janis.beckert@gmail.com>
Date:   Wed Nov 28 15:56:37 2018 +0100

    Fix configuration links

commit 6a4885f8be9ecd81423ebf2eb6da75d7981c979b
Merge: 1d8aae22 e81c4b56
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Nov 27 13:22:59 2018 -0600

    Merge branch 'master' into dev

commit e81c4b56660b25a39f8fdc09fbe07459c5bd8e8e
Merge: 757043ea cfbdb58d
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Nov 21 17:00:49 2018 -0600

    Merge pull request #285 from isuruf/pthread
    
    Move LDFLAGS to the end

commit cfbdb58de2e44f2e3a3d8b14fceece7aef4b3006
Author: Isuru Fernando <isuruf@gmail.com>
Date:   Wed Nov 21 14:23:39 2018 -0600

    Move LDFLAGS to the end
    
    Otherwise the linker will drop flags like -lpthread

commit 757043eae8630c0a76e9bb04f2cb0bd72439a86a
Merge: e769bf46 7af8fa01
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Nov 21 13:07:26 2018 -0600

    Merge pull request #283 from isuruf/patch-3
    
    Fix MinGW and Cygwin build failures

commit 7af8fa01373b7bb30fa3b1fd110fd201c87ea225
Author: Isuru Fernando <isuruf@gmail.com>
Date:   Wed Nov 21 02:10:05 2018 -0600

    Fix blis dll path

commit 2acd8dcd23805203a6821358c5e3e09d521fecdf
Author: Isuru Fernando <isuruf@gmail.com>
Date:   Wed Nov 21 02:02:18 2018 -0600

    Fix install path of dll.a

commit b7b0ad22b151e89e2a6c7782cf4d8d47b4e60734
Author: Isuru Fernando <isuruf@gmail.com>
Date:   Wed Nov 21 01:54:44 2018 -0600

    Test mingw

commit bafe521ed0012b7b8814404b78a6c576d8386370
Author: Isuru Fernando <isuruf@gmail.com>
Date:   Wed Nov 21 01:54:36 2018 -0600

    Fixes for mingw

commit be831879bd03edcddff8a345161f749ad92215af
Author: Isuru Fernando <isuruf@gmail.com>
Date:   Wed Nov 21 01:39:32 2018 -0600

    test gcc shared

commit f6b924648c79c4b1c3d3c7fbf85372680aff8362
Author: Isuru Fernando <isuruf@gmail.com>
Date:   Wed Nov 21 01:39:19 2018 -0600

    Don't use .def for gcc

commit ce6e4eae6d5e977e6f699acc9cf239be8ac53771
Author: Isuru Fernando <isuruf@gmail.com>
Date:   Wed Nov 21 01:34:56 2018 -0600

    test no threading

commit c9169b4685bfe81bc562cf9128b35a6a9884799b
Author: Isuru Fernando <isuruf@gmail.com>
Date:   Wed Nov 21 01:17:36 2018 -0600

    Add mingw64 path

commit 0f753090eaf4264b743a49ce15de97514bcbe112
Author: Isuru Fernando <isuruf@gmail.com>
Date:   Wed Nov 21 01:14:52 2018 -0600

    Fix PATH

commit d424470b1f2fa8717fa54c0245b21341504665f6
Author: Isuru Fernando <isuruf@gmail.com>
Date:   Wed Nov 21 01:04:26 2018 -0600

    Check openmp and pthreads threading

commit c73e7601e58239e2dedec6c9f1b752e949254a42
Author: Isuru Fernando <isuruf@gmail.com>
Date:   Wed Nov 21 00:50:33 2018 -0600

    Revert "enable rdp"
    
    This reverts commit 368274bcbd0c9232521d14fa28304f35ced0e6d7.

commit 6209b2e6060b89e65f3405c31333af8952dd63c0
Author: Isuru Fernando <isuruf@gmail.com>
Date:   Wed Nov 21 00:50:22 2018 -0600

    Remove conda

commit 0b1b344447b8a2fcd635a48f0ce7ce89b2107dc4
Author: Isuru Fernando <isuruf@gmail.com>
Date:   Wed Nov 21 00:42:39 2018 -0600

    Fix make name

commit 7a9838983ba8dd32ac9f87712255721542ff561f
Author: Isuru Fernando <isuruf@gmail.com>
Date:   Wed Nov 21 00:35:27 2018 -0600

    Use m2w64-make

commit 4c1dedd6a90087807f16353a5d0bcaaade35a7a5
Author: Isuru Fernando <isuruf@gmail.com>
Date:   Wed Nov 21 00:28:20 2018 -0600

    No activate on gcc

commit 368274bcbd0c9232521d14fa28304f35ced0e6d7
Author: Isuru Fernando <isuruf@gmail.com>
Date:   Tue Nov 20 23:40:26 2018 -0600

    enable rdp

commit 707a5e7f9b07f554e1e9289dd0ce3b7dc4fded6e
Author: Isuru Fernando <isuruf@gmail.com>
Date:   Tue Nov 20 23:39:31 2018 -0600

    No conda for mingw build

commit 65b0565c0ad9162d4474bd84eabde491fa971538
Author: Isuru Fernando <isuruf@gmail.com>
Date:   Tue Nov 20 23:19:38 2018 -0600

    Check MinGW-w64

commit 9ddffba5847080e0d77d9e6059d05dc4b1d89ba5
Author: Isuru Fernando <isuruf@gmail.com>
Date:   Wed Nov 21 00:23:34 2018 -0600

    Fix MinGW build failure
    
    Fixes https://github.com/flame/blis/issues/278

commit 1d8aae220bc52ce8e3a8afaa64b57e5d83480bdc
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Nov 20 18:42:07 2018 -0600

    Track internal scalar datatypes.
    
    Details:
    - Added a num_t datatype bitfield to the obj_t in the form of a new
      info2 field in the obj_t. This change was made primarily so that in
      the case of mixed-datatype gemm, the alpha scalar would not need to
      be cast to the storage datatype of B (or A) before then being cast to
      the computation datatype just before the macrokernel is called. This
      double-casting regime could result in loss of precision if the storage
      datatype of B (or A) is less than the computation precision. In
      practice, it was likely not going to be a big deal since most usage of
      alpha is for -1.0, 0.0, and 1.0 (or integer multiples thereof), which
      can all be represented exactly in single or double precision.
    - The type of objbits_t was changed to uint32_t, so the new format
      potentially takes up the same space as the previous obj_t definition,
      assuming no padding inserted by the compiler. Shrinking info to 32
      bits and spilling over into a second field was chosen over using the
      high 32 bits of a single 64-bit objbits_t info field because many of
      the bitwise operations are performed with enums such as num_t, dom_t,
      and prec_t, which may take on the type of 32-bit ints. It's easier to
      just keep all of those bitwise operations in 32 bits than perform a
      million typecasts throughout bli_type_defs.h and bli_obj_macro_defs.h
      to ensure that the integers are treated as 64-bit for the purposes of
      the ANDs, ORs, and bitshifts.
    - Many comment updates.
    - Thanks to Devin Matthews and Devangi Parikh for their feedback and
      involvement during this commit cycle.

commit e769bf46b0931d68031af212110484ec98e16908
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Nov 20 16:16:53 2018 -0600

    Tweak testsuite to issue FAIL for Nan, Inf (#279).
    
    Details:
    - Adjusted the definition for libblis_test_get_string_for_result() in
      testsuite/src/test_libblis.c so that the "FAIL" string is returned if
      the computed residual contains either NaN or Inf. Previously, a
      residual containing NaN would result in the selection of the "PASS"
      string. Thanks to Devin Matthews for reporting this issue (#279).
    - Expounded on comment for the macro definitions of bli_isnan() and
      bli_isinf() in bli_misc_macro_defs.h to make it more obvious why they
      must remain macros.

commit 279deae18fb8b8106161863b46fcb38232314de4
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Nov 16 11:34:19 2018 -0600

    Added 4x5 matlab plotting scripts to test/3m4m.
    
    Details:
    - Added a new directory, test/3m4m/matlab, containing matlab scripts for
      plotting 4x5 panels of performance graphs (using the subplot()
      function) for gemm, hemm, herk, trmm, and trsm across all four
      floating-point datatypes. I expect to further refine these scripts as
      time goes on, but their current state constitutes a good start.

commit 7b02c726650336c12286c8ba166d1d0fdf7601a8
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Nov 14 13:49:55 2018 -0600

    CREDITS file update.

commit 84dd298a27033945fa2d3b6e5dce1fe625cd2a0a
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Nov 14 13:47:45 2018 -0600

    Patch to fix msys2/Windows build failure (#277).
    
    Details:
    - Expanded cpp guard in frame/include/bli_x86_asm_macros.h to also check
      __MINGW32__ in addition to _WIN32, __clang__, and __MIC__. Thanks to
      Isuru Fernando for suggesting this fix, and also to Costas Yamin for
      originally reporting the issue (#277).

commit 8091998b6500e343c2024561c2b1aa73c3bafb0b
Merge: 333d8562 7b5ba731
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Nov 14 12:36:35 2018 -0600

    Merge branch 'master' into amd

commit 7b5ba7319b3901ad0e6c6b4fa3c1d96b579efbe9
Merge: ce719f81 52392932
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Nov 14 12:32:01 2018 -0600

    Merge branch 'dev' of github.com:flame/blis into dev

commit 52392932dc1ea3c16220cc4e6978efcb2f5f0616
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Nov 13 22:23:38 2018 +0000

    Minor fixes to test/3m4m drivers.
    
    Details:
    - Cleanups to Makefile to allow all test drivers to be built for
      OpenBLAS and MKL in addition to BLIS.
    - Fixed copy-paste typos in test_hemm in calls to ssymm_() and dsymm_().
    - Fixed incorrect types for betap in BLAS cpp macro branch of
      test_herk.c.

commit 4f12e36a0d0e6df146314b4e50e36c5e7a1af3d3
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Nov 13 14:23:12 2018 -0600

    Fixed number of columns in first output line.
    
    Details:
    - In previous commit, forgot to remove output column corresponding to
      the k dimension.

commit a2e0cdd7debf8109198536d55af05d5631072fb2
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Nov 13 14:15:11 2018 -0600

    Added hemm test driver to test/3m4m.
    
    Details:
    - Added a new test_hemm.c test driver to test/3m4m, which was modeled
      after the driver by the similar name in test. Also updated Makefile
      so that blis-nat-[sm]t would trigger builds for the new driver.

commit 0f9b53e84b48d8d73a56cc9889eae3595ca58a78
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Nov 13 13:03:15 2018 -0600

    Fixed a bug in high-level mixeddt conditional.
    
    Details:
    - Fixed a bug in frame/3/bli_l3_oapi.c in the conditional that divides
      use of induced method (1m) execution from native execution. The former
      was intended to only be used in cases where all storage datatypes are
      complex and the datatype of C is equal to the computation datatype.
      (If mixed datatypes are detected, native execution would be used.)
      However, the code in bli_gemm() was erroneously checking the execution
      datatype instead of the computation datatype, which at that point is
      guaranteed to be equal to the storage datatype even if the computation
      datatype contains a different value. Thanks to Devangi Parikh for
      helping in isolating this bug.

commit 333d8562f04eea0676139a10cb80a97f107b45b0
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Sun Nov 11 14:28:53 2018 -0600

    Added debug output to bli_malloc.c.
    
    Details:
    - Added debug output to bli_malloc.c in order to debug certain kinds of
      memory behavior in BLIS. The printf() statements are disabled and must
      be enabled manually.
    - Whitespace/comment updates in bli_membrk.c.

commit ce719f816d1237f5277527d7f61123e77180be54
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Sat Nov 10 14:48:43 2018 -0600

    More edits to mixeddt matlab scripts.
    
    Details:
    - Renamed scripts in test/mixeddt/matlab:
        plot_case_all.m -> plot_dom_all.m
        plot_case_md.m  -> plot_dom_case.m
        plot_all_md.m   -> plot_dt_all.m
    - Added plot_dt_select.m in order to plot select graphs for the main
      body of the mixeddt paper, and added additional related legend
      handling in plot_gemm_perf.m.
    - Added test/mixeddt/matlab/output and a .gitkeep file within in order
      to force git to recognize the directory.

commit bf99e7c14baf45725b698d06ad043b531e3a2763
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Nov 8 18:47:17 2018 -0600

    Minor updates to test/mixeddt driver.
    
    Details:
    - Cleaned up test/mixeddt Makefile in preparation for gathering new
      data for mixeddt paper, including renaming implementations to
      "internal" and "ad-hoc" to match the terminology to be used in the
      paper.
    - Added new matlab scripts for generating 8 figures, each covering all
      mixed-precision cases for each mixed-domain case.
    - Updated the runme.sh script according to changes to Makefile.
    - Fixed a minor bug in test_gemm.c that may have given incorrect
      performance in complex, homogeneous storage datatype cases where
      the computation precision was equal to the storage precisions.
      (Examples: zzzd, cccs.)

commit 4bbb454bf3c361af9e97bfa394a73d610cd9002a
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Sat Nov 3 19:11:01 2018 -0500

    Testsuite docs update for mixed-datatype gemm.
    
    Details:
    - Updated docs/Testsuite.md to include mention of the new mixed-domain
      and mixed-precision settings, including descriptions.
    - Updated docs/MixedDatatypes.md to include a brief section on running
      the testsuite to exercise mixed-datatype functionality, which mostly
      amounts to a link to the Testsuite.md document.
    - Minor verbiage change to testsuite output to correct a misleading
      label associated with the value returned by the query function
      bli_info_get_simd_num_registers(). (The function does not return the
      number of SIMD registers present in the hardware, but rather a maximum
      assumed value for the purposes of allocating temporary microtile
      workspace on the function stack.)

commit 16401ae922b1285437cf5f6867b2764650a95fb0
Merge: f19c33af 2d403a15
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Sat Nov 3 19:09:43 2018 -0500

    Merge branch 'dev'

commit 2d403a1535380a2ebe2ae2c0f5ac54ba7564fbeb
Merge: e90e7f30 4a12979f
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Nov 1 20:18:53 2018 -0500

    Merge pull request #275 from RhysU/patch-1
    
    Spelling in FAQ

commit 4a12979f65697ed79ba290efd59f4b994ac9429b
Author: Rhys Ulerich <rhys.ulerich@gmail.com>
Date:   Thu Nov 1 20:20:59 2018 -0400

    Spelling in FAQ

commit f19c33af4cbe6f5705b96fbf2b8799c3c2bd75c3
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Oct 26 17:07:15 2018 -0500

    Disallow 64b BLAS integers + 32b BLIS integers.
    
    Details:
    - Print an error message from configure if the user attempts to
      explicitly configure BLIS for simultaneous use of 64-bit integers in
      the BLAS API with 32-bit integers in the BLIS API.
    - Added cpp macro conditional to bli_type_defs.h to mandate that BLIS
      integers be 64 bits if the BLAS integers are 64 bits. This and the
      above item take care of issue #274. Thanks to Devin Matthews and
      Jeff Hammond for suggesting these safeguards.
    - Slight reorganization and relabeling (for clarity) of BLAS/CBLAS
      sections and BLIS integer size line of the testsuite configuration
      output.
    - Very minor edits to docs/MixedDatatypes.md.

commit e90e7f309b3f2760a01e8e09a29bf702754fa2b5 (origin/win-pthreads)
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Oct 25 14:09:43 2018 -0500

    CHANGELOG update (0.5.0)

commit be7c57819cfd48adb175d9a480cc9f37928645c1 (tag: 0.5.0)
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Oct 25 14:09:40 2018 -0500

    Version file update (0.5.0)

commit 75da7f2a208ad7d26ed9c6d3e10d08b2a1caf9d6
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Oct 25 14:02:41 2018 -0500

    ReleaseNotes.md update in advance of next version.
    
    Details:
    - Updated ReleaseNotes.md in preparation for next version.
    - Updated docs/FAQ.md to reflect recent developments, and other edits.
    - Minor updates to RELEASING.

commit 6fbc456fb3f4401ec951a618990f15a84fdfa236
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Oct 25 13:20:25 2018 -0500

    Added SALT testing to Travis CI.
    
    Details:
    - Modified .travis.yml to automatically employ the simulation of
      application-level threading within the testsuite, with supporting
      changes to common.mk, the top-level Makefile, and
      travis/do_testsuite.sh.
    - Added a new pair of input files to testsuite directory with the
      '.salt' suffix (similar to those with the '.fast' suffix) for
      testing application-level threading.
    - Updated docs/BuildSystem.md to document the new make targets
      'testblis-salt' and 'checkblis-salt'.

commit 0e27963a6770e6b64f3299ad0613d5df45d8b6ae
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Oct 24 12:16:19 2018 -0500

    Add bli_pthread_mutex_trylock().
    
    Details:
    - Added the missing bli_pthread_mutex_trylock() function and prototype
      to the non-Windows sections of bli_pthread.c and .h. This function
      isn't needed by BLIS, but I figured why not make the Windows and
      non-Windows sections consistent with one another.

commit 4b683740c12f83804a51ec610b16ce28607d5c85
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Oct 24 11:56:16 2018 -0500

    Defined bli_pthread_cond_*() and related defs.
    
    Details:
    - Added function definitions for bli_pthread_cond_*() as well as related
      types and constants to bli_pthread.c, and corresponding prototypes to
      bli_pthread.h.

commit 4b4f8072b9bb495b3e01d45698b0bad3dac31ba8
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Oct 24 11:31:46 2018 -0500

    Define bli_pthreads barrier types on OS X.
    
    Details:
    - Fully define bli_pthreads barrier-related types on OS X. Only typedef
      those types in terms of pthreads types on non-Windows, non-Apple OSes
      (i.e. Linux).

commit ad98790dcef6bd9aab7f13d615b987b5daa58757
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Oct 23 20:35:05 2018 -0500

    Fix names of Windows pthread initializer macros.
    
    Details:
    - Renamed the PTHREAD_ initializer macros in the Windows cpp case to use
      BLIS_ prefixes to match their non-Windows counterparts.

commit 06c23954e6b17219a50c3d37821544a46defaf89
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Oct 23 19:16:54 2018 -0500

    Defined unified bli_pthreads_*() API for all OSes.
    
    Details:
    - Expanded the bli_pthread_*() -> pthread_*() wrappers in
      frame/thread/bli_pthread.c to include cases for Windows taken from
      frame/base/bli_pthread_wrap.c. Now, bli_thread_*() is always defined
      and always used by BLIS and the BLIS testsuite (in lieu of calling
      pthreads directly, as before). The implementation used in this new
      API depends on whether we are building for Windows, and to a lesser
      extent, whether we are building on OS X. For the core API, Windows
      uses Windows threads, non-Windows (Linux, OS X) uses pthreads.
      OS X and Windows get barriers implemented in terms of other
      bli_pthread_*() functions, and Linux gets barriers implemented in
      terms of pthread_barrier*(). This commit addresses issue #273.
    - Fixed a bug in the Linux definition of bli_pthread_mutex_unlock(),
      which was erroneously calling pthread_mutex_lock().
    - Minor changes to configure so that the auto-detection executable
      can be built given the above changes (most notably, turning on
      POSIX extensions via -D_GNU_SOURCE).
    - Removed temporary play-test code for shiftd that accidentally got
      committed into test/3m4m/test_gemm.c.

commit 0ae9585da1e3db1cf8034d4b16305a5883beb0d3
Author: pradeeptrgit <pradeep.rao@amd.com>
Date:   Tue Oct 23 09:36:23 2018 +0530

    Update version number to 1.2
    
    Change-Id: Ibb31f6683cdecca6b218bc2f0c14701d7e92ebf3

commit eac7d267a017d646a2c5b4fa565f4637ebfd9da7
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Oct 22 18:10:59 2018 -0500

    Unconditionally define bli_l3_thread_entry().
    
    Details:
    - Define a dummy bli_l3_thread_entry() function when multithreading is
      disabled altogether, or enabled via OpenMP. This function was
      originally necessary when multithreading is enabled via pthreads.
      By defining the function no matter the threading options given, it is
      less likely that an AppVeyor Windows build will complain due to a
      missing symbol in the DLL. (To be clear: AppVeyor was working fine
      before, but a problem may have arisen if it were switched to an
      OpenMP build.)
    - Removed the prototype for bli_l3_thread_entry() from
      bli_thrcomm_pthreads.c and placed it in bli_thrcomm.h.
    - Regenerated the symbols list file build/libblis-symbols.def.

commit 4ee986f0a74207f4ca29df077929134725d62b80
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Oct 22 14:09:44 2018 -0500

    Added mixed-datatype testing to Travis CI (#271).
    
    Details:
    - Modified .travis.yml to automatically test the mixed-datatype support
      of the gemm operation, with supporting changes to common.mk, the
      top-level Makefile, and travis/do_testsuite.sh.
    - Added a new pair of input files to testsuite directory with the
      '.mixed' suffix (similar to those with the '.fast' suffix) for testing
      mixed-datatype gemm.
    - Updated docs/BuildSystem.md to document the new make targets
      'testblis-md' and 'checkblis-md'.

commit c3c6ebc9c6244053d654a9b0c955acb2fef42ee8
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Sun Oct 21 18:48:54 2018 -0500

    Fixed thrinfo_t printing for small problems.
    
    Details:
    - Fixed a bug in the code that prints out the communicator and work ids
      from the various threads' thrinfo_t nodes. This bug manifested when
      the dimension being parallelized was not large enough such that every
      thread was assigned actual work (since the minimum amount of work is
      determined by the register blocksize in the dimension being
      parallelized). In those cases, the threads that receive no work in
      that dimension do not finish building their thrinfo_t tree, leaving
      lower-level nodes non-existent. (The bug itself was usally observed as
      a segfault when the printing code attempted to dereference all the way
      down the thrinfo_t tree.) The solution involves explicitly checking
      each node as it is dereferenced, and if at any time NULL is found, all
      subsequent communicator and work ids are set to -1.

commit 73a222c0d99dcc221be7dea10eaebf844f31f72e
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Sat Oct 20 14:13:04 2018 -0500

    Minor edits to 'configure --help' text.

commit 14f3d5e6df183819a0c393b2661ad15df0786544
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Oct 19 20:39:35 2018 -0500

    Refresh libblis-symbols.def post-merge 090e4f0.

commit 090e4f08fc2f429a1b2db77b0a6f8276f892a7ac
Merge: c9be5889 0854e880
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Oct 19 18:41:10 2018 -0500

    Merge branch 'master' into dev

commit 0854e880b0848e0c2e3d0644c93c80b0fd13c0dc
Merge: 4e38a8d4 343a2715
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Oct 19 18:05:00 2018 -0500

    Merge pull request #261 from flame/win-pthreads
    
    Implement missing pthreads function on Windows

commit c9be5889fbe947c64ef75740662e4d63032f4c35
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Oct 19 17:42:40 2018 -0500

    Added "Known issues" section to Multithreading.md.
    
    Details:
    - Added known issues section to Multithreading.md.
    - Trivial changes to MixedDatatypes.md, Sandboxes.md.

commit 343a2715ebee28d250ee41b914abdcd1dc77c344
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Oct 19 16:59:19 2018 -0500

    Whitespace changes to configure, bli_pthread_wrap.
    
    Details:
    - Mostly whitespace changes (spaces to tabs) to configure and
      bli_pthread_wrap.c and .h.

commit 3678a1cd518df9447b4b1ea86885eb2ba8abcf6e
Merge: 85397cd4 4e38a8d4
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Oct 19 16:11:31 2018 -0500

    Merge branch 'master' into win-pthreads

commit 4e38a8d4eebb18ead74e644fac76a4fde8e7f6c6
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Oct 19 15:54:15 2018 -0500

    Implemented python version checking in configure.
    
    Details:
    - Added python version checking to configure script. (Recall that python
      is needed to execute the flatten-headers.py script.) Minimum versions
      of python needed are currently as follows:
        python2: 2.7 or later
        python3: 3.5 or later
      The standard search order for python interpeters is:
        python python3 python2
      The PYTHON environment variable is also supported and will be checked
      before the standard search order list.
    - Updated BuildSystem.md to include: a minimum make version; mention
      that the C compiler must actually be a C99 compiler; and the caveat
      that Windows builds do not require pthreads since BLIS can provide
      an implementation of pthreads internally.

commit 85397cd4fa52f6c4c33f4fb715478c55533c680e
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Oct 19 13:12:43 2018 -0500

    Added explanatory comment to bli_pthread.c.
    
    Details:
    - Added a verbose comment to bli_pthread.c that explains why a bli_
      wrapper to pthreads APIs is useful.

commit 53c07035ef61cc9b8469636d4d8fa5085f37652d
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Fri Oct 19 12:53:03 2018 -0500

    Refresh libblis-symbols.def from bb6df28.
    
    Details:
    - Forgot to regenerate the symbols file after the previous commit
      (bb6df281) in which shiftd operation was introduced.

commit 473ce54f5fbea4860ac0514e7e8b022c1ea03e63
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Oct 18 19:03:56 2018 -0500

    Added bli_pthread_*() API.
    
    Details:
    - Defined a bli_pthread_*() API so that the testsuite, when being linked
      against a Windows DLL, will be able to access pthreads functionality
      without those pthreads functions being explicitly exported by the DLL.
      Instead, we export the bli_pthread_*() layer, which uses types and
      functions that are identical to pthreads, but adds a 'bli_' prefix.
      Only a few basic functions are present in the bli_pthreads_*() API
      for now. Thanks to Devin Matthews and Isuru Fernando for their help
      on a related PR (#261) that this commit will hopefully facilitate.
    - Updated testsuite so that it calls bli_pthread_*() layer instead of
      pthread_*() functions directly.
    - Regenerated build/libblis-symbols.def.
    - Comment updated to build/regen-symbols.sh.

commit bb6df2814fcaa2fa62a549379f61be2f8667a598
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Oct 18 17:11:39 2018 -0500

    Defined a new level-1d operation: shiftd.
    
    Details:
    - Defined a new level-1d operation called 'shiftd', including object and
      typed APIs. This operation adds a scalar value to every element along
      an arbitrary diagonal of a matrix. Currently, shiftd is implemented in
      terms of the addv kernel. (The scalar is passed in as the x vector
      with an increment of zero.)
    - Replaced ad-hoc usage of setd and addd (after creating a temporary
      matrix object) with use of shiftd, which is much more concise, in
      various test driver files in the testsuite. Similar changes were made
      to the standalone test drivers and the example code.
    - Added documentation entries in BLISObjectAPI.md and BLISTypedAPI.md
      for bli_shiftd() and bli_?shiftd(), respectively.
    - Added observed object properties to level-1d documentation in
      BLISObjectAPI.md.

commit 53e0a0c9b38e8525c7224e280342ef56328af567
Merge: 1c7247b6 ec676799
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Oct 18 14:54:59 2018 -0500

    Merge branch 'master' into win-pthreads

commit ec67679990660a60362a49406595383672812287
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Oct 18 14:27:02 2018 -0500

    Refreshed Windows symbol list; added regen script.
    
    Details:
    - Moved windows/build/libblis-symbols.def to build/libblis-symbols.def.
      Updated link commands in common.mk accordingly.
    - Added a new script build/regen-symbols.sh that will regenerate the
      libblis-symbols.def file in its new location after building a
      haswell-targeted shared library. Thanks to Isuru Fernando for
      providing the symbol generation command.
    - Ran the new script to refresh the symbols file.

commit fdad54ab8eee4a7efd04ec4afb3e6902eb22e60a
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Oct 18 12:43:22 2018 -0500

    Removed old symbol from libblis-symbols.def.
    
    Details:
    - Removed bli_gemm_ker_var1() from windows/build/libblis-symbols.def
      since this function is no longer compiled.

commit 49d3f9fcbb4a75553439f97c099ea48d85763eea
Merge: 779d64dc 3c527256
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Oct 17 18:00:40 2018 -0500

    Merge branch 'master' into dev

commit 3c52725693d0d7726e1c8fb224f9b1ef786db8b9
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Oct 17 14:56:22 2018 -0500

    Renamed/moved l3 zen ukernels to haswell kernel set.
    
    Details:
    - Renamed the microkernels in kernels/zen/3 to kernels/haswell/3 and
      then updated the file contents to use the 'haswell' infix.
    - Updated bli_cntx_init_zen.c and bli_cntx_init_haswell.c according to
      above function renames.
    - Moved/updated the corresponding prototypes in bli_kernels_zen.h to
      bli_kernels_haswell.h.
    - Updated config_registry according to above changes.
    - NOTE: This rename reflects the fact that haswell microkernels are
      specifically written to overcome the floating-point latency for FMA
      instructions on Intel Haswell-like architectures, which can issue two
      FMA instructions per cycle. These ukernels happen to work fine on AMD
      Zen-based architectures. However, Zen only issues one FMA per cycle,
      which, while halving its floating-point throughput, gives it extra
      flexibility in the design of its microkernels--namely, mr and nr can
      be smaller and still overcome the floating-point latency for those
      single-issue cores. A smaller value of mr and nr allows for a larger
      value of kc, which may be useful in some situations. In the future,
      we may write such Zen-specific microkernels to take advantage of this
      additional flexibility.

commit 71c5832d5f5596f25204980803423d08143a4010
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Oct 17 14:11:01 2018 -0500

    Consolidated slab/rr-explicit level-3 macrokernels.
    
    Details:
    - Consolidated the *sl.c and *rr.c level-3 macrokernels into a single
      file per sl/rr pair, with those files named as they were before
      c92762e. The consolidation does not take away the *option* of using
      slab or round-robin assignment of micropanels to threads; it merely
      *hides* the choice within the definitions of functions such as
      bli_thread_range_jrir(), bli_packm_my_iter(), and bli_is_last_iter()
      rather than expose that choice explicitly in the code. The choice of
      slab or rr is not always hidden, however; there are some cases
      involving herk and trmm, for example, that require some part of the
      computation to use rr unconditionally. (The --thread-part-jrir option
      controls the partitioning in all other cases.)
    - Note: Originally, the sl and rr macrokernels were separated out for
      clarity. However, aside from the additional binary code bloat, I later
      deemed that clarity not worth the price of maintaining the additional
      (mostly similar) codes.

commit 57eab3a4f0e43099fc2ff189df9fcc0d7801c2cd
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Oct 17 11:29:20 2018 -0500

    CREDITS file update.

commit 6722ec21817cbab9d86ee63f00984eb407b5e627
Author: Ye Luo <xw111luoye@gmail.com>
Date:   Wed Oct 17 11:26:00 2018 -0500

    Fix bgclang compilation on BGQ (#270)
    
    * Fix bgq kernels
    
    * Support bgq with bgclang

commit 1c7247b6d146fc728d7c4240e4e069e33f8f8868
Merge: c1bc5530 6c5a1aaf
Author: Devin Matthews <damatthews@smu.edu>
Date:   Tue Oct 16 14:44:32 2018 -0500

    Merge branch 'win-pthreads' of github.com:flame/blis into win-pthreads

commit c1bc5530d51bf55b4aa3c35165f6d4452a0fd779
Author: Devin Matthews <damatthews@smu.edu>
Date:   Tue Oct 16 14:44:10 2018 -0500

    Don't call pthread_once in auto-detect.

commit b9c61d03f542a2e92551ff0595415bec3076ab25
Merge: 5a1e461f 3612ecac
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Oct 16 14:39:57 2018 -0500

    Merge branch 'nested-omp-patch'

commit 5a1e461ffe09ed200ee2fc7aafccf6dd7e8c0080
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Oct 16 14:21:45 2018 -0500

    Execute flatten-headers.py via $(PYTHON).
    
    Details:
    - Execute build/flatten-headers.py python script via $(PYTHON) in
      common.mk. This allows distributions that define the current/preferred
      python interpreter in the PYTHON environment variable to use that
      interpreter when executing flatten-headers.py. Thanks to Isuru
      Fernando for this suggestion, and for Dave Love for submitting the
      initial issue/request.

commit 6c5a1aaff540b19672e91501e894ed695aee322b
Author: Devin Matthews <damatthews@smu.edu>
Date:   Tue Oct 16 10:15:59 2018 -0500

    Fix type in bli_pthread_wrap.c

commit 29e6245816760b1bd4ac738d7d3e11a9d9d13473
Merge: 0b73209f ed657714
Author: Devin Matthews <damatthews@smu.edu>
Date:   Tue Oct 16 10:12:25 2018 -0500

    Merge branch 'master' into win-pthreads

commit 0b73209f6b22cc024169146d343627f6999b63d8
Author: Devin Matthews <damatthews@smu.edu>
Date:   Tue Oct 16 10:02:06 2018 -0500

    Add missing argument to WaitForSingleObject and use $is_win in configure
    to turn off pthreads.

commit ed65771482a705f7ed028d822489766327b44e76
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Oct 15 17:54:45 2018 -0500

    Fixed merge fail on testsuite threading macros.
    
    Details:
    - Applied the following C preprocessor macro renames
    
        BLIS_DEFAULT_MR_THREAD_MAX  -> BLIS_THREAD_MAX_IR
        BLIS_DEFAULT_NR_THREAD_MAX  -> BLIS_THREAD_MAX_JR
        BLIS_DEFAULT_M_THREAD_RATIO -> BLIS_THREAD_RATIO_M
        BLIS_DEFAULT_N_THREAD_RATIO -> BLIS_THREAD_RATIO_N
    
      in src/test_libblis.c. This is apparently the result of a failure by
      git to properly merge the 'master' and 'amd' branches in the previous
      commit. (The 'master' branch contained a commit, 53a9ab1, in which
      these same cpp macros were renamed throughout the source distribution.

commit dc5fd898af8c74c2e2a75fc647157da0d04dd922
Merge: 667d3929 637c2ce7
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Oct 15 17:41:35 2018 -0500

    Merge branch 'amd'

commit 779d64dc3091dea6b7530283304e52878151d218
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Oct 15 17:13:18 2018 -0500

    Added entry for xpbym to input.operations.fast.
    
    Details:
    - Forgot to add an entry for the new xpbym operation to
      input.operations.fast in previous commit.

commit 5fec95b99f61761963834f62a9867f797687813c
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Mon Oct 15 16:37:39 2018 -0500

    Implemented mixed-datatype support for gemm.
    
    Details:
    - Implemented support for gemm where A, B, and C may have different
      storage datatypes, as well as a computational precision (and implied
      computation domain) that may be different from the storage precision
      of either A or B. This results in 128 different combinations, all
      which are implemented within this commit. (For now, the mixed-datatype
      functionality is only supported via the object API.) If desired, the
      mixed-datatype support may be disabled at configure-time.
    - Added a memory-intensive optimization to certain mixed-datatype cases
      that requires a single m-by-n matrix be allocated (temporarily) per
      call to gemm. This optimization aims to avoid the overhead involved in
      repeatedly updating C with general stride, or updating C after a
      typecast from the computation precision. This memory optimization may
      be disabled at configure-time (provided that the mixed-datatype
      support is enabled in the first place).
    - Added support for testing mixed-datatype combinations to testsuite.
      The user may test gemm with mixed domains, precisions, both, or
      neither.
    - Added a standalone test driver directory for building and running
      mixed-datatype performance experiments.
    - Defined a new variation of castm, castnzm, which operates like castm
      except that imaginary values are not touched when casting a real
      operand to a complex operand. (By contrast, in these situations castm
      sets the imaginary components of the destination matrix to zero.)
    - Defined bli_obj_imag_is_zero() and substituted calls in lieu of all
      usages of bli_obj_imag_equals() that tested against BLIS_ZERO, and
      also simplified the implementation of bli_obj_imag_equals().
    - Fixed bad behavior from bli_obj_is_real() and bli_obj_is_complex()
      when given BLIS_CONSTANT objects.
    - Disabled dt_on_output field in auxinfo_t structure as well as all
      accessor functions. Also commented out all usage of accessor
      functions within macrokernels. (Typecasting in the microkernel is
      still feasible, though probably unrealistic for now given the
      additional complexity required.)
    - Use void function pointer type (instead of void*) for storing function
      pointers in bli_l0_fpa.c.
    - Added documentation for using gemm with mixed datatypes in
      docs/MixedDatatypes.md and example code in examples/oapi/11gemm_md.c.
    - Defined level-1d operation xpbyd and level-1m operation xpbym.
    - Added xpbym test module to testsuite.
    - Updated frame/include/bli_x86_asm_macros.h with additional macros
      (courtsey of Devin Matthews).

commit 3612ecac98a9d36c3fcd64154121d420bb69febd (origin/nested-omp-patch)
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Oct 11 15:16:41 2018 -0500

    Added comments to nested OpenMP handling code.
    
    Details:
    - Added comments to bli_thrcomm_openmp.c relating to changes made in
      6ac0c80 and 1064d79.

commit 667d3929ee20e94849b4e25b693b4037b7e3f350
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Thu Oct 11 11:47:57 2018 -0500

    Added Fortran APIs for some thread functions.
    
    Details:
    - Defined Fortran-77 compatible APIs for bli_thread_set_num_threads()
      and bli_thread_set_ways(). These wrappers are defined in
      frame/compat/blis/thread/b77_thread.c. Thanks to Kay Dewhurst for
      suggesting these new interfaces.
    - Added missing prototype for bli_thread_set_ways() in bli_thread.h and
      removed prototypes for non-existent functions bli_thread_set_*_nt().
    - CREDITS file update.

commit 1064d79711f03a0541b92d8b8b9b7e25e04097a5
Author: Devin Matthews <damatthews@smu.edu>
Date:   Thu Oct 11 11:14:25 2018 -0500

    Adjust rntm_t struct as well.

commit 6ac0c805609b85616ddb32e50101c4f9feb25a35
Author: Devin Matthews <damatthews@smu.edu>
Date:   Thu Oct 11 10:45:07 2018 -0500

    Fix OMP nesting problem.
    
    Detect when OpenMP uses fewer threads than requested and correct accordingly, so that we don't wait forever for nonexistent threads. Fixes #267.

commit 78a6935483409ae277c766406e175772e820b1de
Author: sraut <Biplab.Raut@amd.com>
Date:   Thu Oct 11 10:49:40 2018 +0530

    Added comments for the change in syrk small matrix change.
    
    Change-Id: I958939e9953323730da49ef07d1b10e578837d82

commit 53a9ab1c85be14dcfd2560f5b16e898e3e258797
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Wed Oct 10 15:11:09 2018 -0500

    Renamed thread auto-factorization macro constants.
    
    Details:
    - Renamed the following C preprocessor macros whose fallback/default
      values are specified within frame/include/bli_kernel_macro_defs.h:
    
        BLIS_DEFAULT_MR_THREAD_MAX  -> BLIS_THREAD_MAX_IR
        BLIS_DEFAULT_NR_THREAD_MAX  -> BLIS_THREAD_MAX_JR
        BLIS_DEFAULT_M_THREAD_RATIO -> BLIS_THREAD_RATIO_M
        BLIS_DEFAULT_N_THREAD_RATIO -> BLIS_THREAD_RATIO_N
    
    - Renamed the above cpp macro overrides within the knl, skx, and zen
      sub-configurations, as well as invocations of those macros in
      bli_rntm.c.
    - Moved config/zen/bli_kernel.h to an 'old' directory as it is no longer
      used by any code within BLIS.

commit 637c2ce794b0414ba8b25e9a452f7d64f825d63a
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Oct 9 17:18:04 2018 -0500

    Updated column index range for irun.py -q.
    
    Details:
    - Forgot to apply the column index range fix in 10f179f to situations
      when "quiet" mode (-q) is requested. This commit applies the new
      column index range modifications to the quiet case.

commit e2a59400bdda7ed7ee0ff00edea70c00ed593b6c
Author: Field G. Van Zee <field@cs.utexas.edu>
Date:   Tue Oct 9 15:29:48 2018 -0500

    Allow trsm_l parallelism in the jc loop.
    
    Details:
